#!/usr/bin/env node
"use strict";var e=require("fs"),t=require("path"),n=require("os"),r=require("crypto"),i=require("module"),s=require("util"),o=require("url"),a=require("vm"),c=require("repl"),l=require("console"),p=require("assert"),u="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function h(e){if(e.__esModule)return e;var t=e.default;if("function"==typeof t){var n=function e(){return this instanceof e?Reflect.construct(t,arguments,this.constructor):t.apply(this,arguments)};n.prototype=t.prototype}else n={};return Object.defineProperty(n,"__esModule",{value:!0}),Object.keys(e).forEach((function(t){var r=Object.getOwnPropertyDescriptor(e,t);Object.defineProperty(n,t,r.get?r:{enumerable:!0,get:function(){return e[t]}})})),n}var d,f={exports:{}},m={name:"dotenv",version:"16.4.6",description:"Loads environment variables from .env file",main:"lib/main.js",types:"lib/main.d.ts",exports:{".":{types:"./lib/main.d.ts",require:"./lib/main.js",default:"./lib/main.js"},"./config":"./config.js","./config.js":"./config.js","./lib/env-options":"./lib/env-options.js","./lib/env-options.js":"./lib/env-options.js","./lib/cli-options":"./lib/cli-options.js","./lib/cli-options.js":"./lib/cli-options.js","./package.json":"./package.json"},scripts:{"dts-check":"tsc --project tests/types/tsconfig.json",lint:"standard",pretest:"npm run lint && npm run dts-check",test:"tap run --allow-empty-coverage --disable-coverage --timeout=60000","test:coverage":"tap run --show-full-coverage --timeout=60000 --coverage-report=lcov",prerelease:"npm test",release:"standard-version"},repository:{type:"git",url:"git://github.com/motdotla/dotenv.git"},funding:"https://dotenvx.com",keywords:["dotenv","env",".env","environment","variables","config","settings"],readmeFilename:"README.md",license:"BSD-2-Clause",devDependencies:{"@types/node":"^18.11.3",decache:"^4.6.2",sinon:"^14.0.1",standard:"^17.0.0","standard-version":"^9.5.0",tap:"^19.2.0",typescript:"^4.8.4"},engines:{node:">=12"},browser:{fs:!1}};var g=function(){if(d)return f.exports;d=1;const i=e,s=t,o=n,a=r,c=m.version,l=/(?:^|^)\s*(?:export\s+)?([\w.-]+)(?:\s*=\s*?|:\s+?)(\s*'(?:\\'|[^'])*'|\s*"(?:\\"|[^"])*"|\s*`(?:\\`|[^`])*`|[^#\r\n]+)?\s*(?:#.*)?(?:$|$)/gm;function p(e){console.log(`[dotenv@${c}][DEBUG] ${e}`)}function u(e){return e&&e.DOTENV_KEY&&e.DOTENV_KEY.length>0?e.DOTENV_KEY:process.env.DOTENV_KEY&&process.env.DOTENV_KEY.length>0?process.env.DOTENV_KEY:""}function h(e,t){let n;try{n=new URL(t)}catch(e){if("ERR_INVALID_URL"===e.code){const e=new Error("INVALID_DOTENV_KEY: Wrong format. Must be in valid uri format like dotenv://:key_1234@dotenvx.com/vault/.env.vault?environment=development");throw e.code="INVALID_DOTENV_KEY",e}throw e}const r=n.password;if(!r){const e=new Error("INVALID_DOTENV_KEY: Missing key part");throw e.code="INVALID_DOTENV_KEY",e}const i=n.searchParams.get("environment");if(!i){const e=new Error("INVALID_DOTENV_KEY: Missing environment part");throw e.code="INVALID_DOTENV_KEY",e}const s=`DOTENV_VAULT_${i.toUpperCase()}`,o=e.parsed[s];if(!o){const e=new Error(`NOT_FOUND_DOTENV_ENVIRONMENT: Cannot locate environment ${s} in your .env.vault file.`);throw e.code="NOT_FOUND_DOTENV_ENVIRONMENT",e}return{ciphertext:o,key:r}}function g(e){let t=null;if(e&&e.path&&e.path.length>0)if(Array.isArray(e.path))for(const n of e.path)i.existsSync(n)&&(t=n.endsWith(".vault")?n:`${n}.vault`);else t=e.path.endsWith(".vault")?e.path:`${e.path}.vault`;else t=s.resolve(process.cwd(),".env.vault");return i.existsSync(t)?t:null}function v(e){return"~"===e[0]?s.join(o.homedir(),e.slice(1)):e}const y={configDotenv:function(e){const t=s.resolve(process.cwd(),".env");let n="utf8";const r=Boolean(e&&e.debug);e&&e.encoding?n=e.encoding:r&&p("No encoding is specified. UTF-8 is used by default");let o,a=[t];if(e&&e.path)if(Array.isArray(e.path)){a=[];for(const t of e.path)a.push(v(t))}else a=[v(e.path)];const c={};for(const t of a)try{const r=y.parse(i.readFileSync(t,{encoding:n}));y.populate(c,r,e)}catch(e){r&&p(`Failed to load ${t} ${e.message}`),o=e}let l=process.env;return e&&null!=e.processEnv&&(l=e.processEnv),y.populate(l,c,e),o?{parsed:c,error:o}:{parsed:c}},_configVault:function(e){var t;t="Loading env from encrypted .env.vault",console.log(`[dotenv@${c}][INFO] ${t}`);const n=y._parseVault(e);let r=process.env;return e&&null!=e.processEnv&&(r=e.processEnv),y.populate(r,n,e),{parsed:n}},_parseVault:function(e){const t=g(e),n=y.configDotenv({path:t});if(!n.parsed){const e=new Error(`MISSING_DATA: Cannot parse ${t} for an unknown reason`);throw e.code="MISSING_DATA",e}const r=u(e).split(","),i=r.length;let s;for(let e=0;e<i;e++)try{const t=h(n,r[e].trim());s=y.decrypt(t.ciphertext,t.key);break}catch(t){if(e+1>=i)throw t}return y.parse(s)},config:function(e){if(0===u(e).length)return y.configDotenv(e);const t=g(e);return t?y._configVault(e):(n=`You set DOTENV_KEY but you are missing a .env.vault file at ${t}. Did you forget to build it?`,console.log(`[dotenv@${c}][WARN] ${n}`),y.configDotenv(e));var n},decrypt:function(e,t){const n=Buffer.from(t.slice(-64),"hex");let r=Buffer.from(e,"base64");const i=r.subarray(0,12),s=r.subarray(-16);r=r.subarray(12,-16);try{const e=a.createDecipheriv("aes-256-gcm",n,i);return e.setAuthTag(s),`${e.update(r)}${e.final()}`}catch(e){const t=e instanceof RangeError,n="Invalid key length"===e.message,r="Unsupported state or unable to authenticate data"===e.message;if(t||n){const e=new Error("INVALID_DOTENV_KEY: It must be 64 characters long (or more)");throw e.code="INVALID_DOTENV_KEY",e}if(r){const e=new Error("DECRYPTION_FAILED: Please check your DOTENV_KEY");throw e.code="DECRYPTION_FAILED",e}throw e}},parse:function(e){const t={};let n,r=e.toString();for(r=r.replace(/\r\n?/gm,"\n");null!=(n=l.exec(r));){const e=n[1];let r=n[2]||"";r=r.trim();const i=r[0];r=r.replace(/^(['"`])([\s\S]*)\1$/gm,"$2"),'"'===i&&(r=r.replace(/\\n/g,"\n"),r=r.replace(/\\r/g,"\r")),t[e]=r}return t},populate:function(e,t,n={}){const r=Boolean(n&&n.debug),i=Boolean(n&&n.override);if("object"!=typeof t){const e=new Error("OBJECT_REQUIRED: Please check the processEnv argument being passed to populate");throw e.code="OBJECT_REQUIRED",e}for(const n of Object.keys(t))Object.prototype.hasOwnProperty.call(e,n)?(!0===i&&(e[n]=t[n]),r&&p(!0===i?`"${n}" is already defined and WAS overwritten`:`"${n}" is already defined and was NOT overwritten`)):e[n]=t[n]}};return f.exports.configDotenv=y.configDotenv,f.exports._configVault=y._configVault,f.exports._parseVault=y._parseVault,f.exports.config=y.config,f.exports.decrypt=y.decrypt,f.exports.parse=y.parse,f.exports.populate=y.populate,f.exports=y,f.exports}();function v(e){throw new Error('Could not dynamically require "'+e+'". Please configure the dynamicRequireTargets or/and ignoreDynamicRequires option of @rollup/plugin-commonjs appropriately for this require call to work.')}var y,x={},E={exports:{}};var S,w,b,_,k,C={},P={exports:{}};function A(){if(w)return S;w=1;const e=new Map([[5,.25],[6,.25],[7,.25],["t",.75],["y",1],["u",.75],["g",.25],["h",.25],["j",.25]]),t=new Map([[2,.25],[3,.25],[4,.25],["w",.75],["e",1],["r",.75],["s",.25],["d",.25],["f",.25]]),n=new Map([["q",.25],["w",.25],["e",.25],["a",.75],["s",1],["d",.75],["z",.25],["x",.25],["c",.25]]),r=new Map([["h",.25],["j",.25],["k",.25],["b",.75],["n",1],["m",.75]]),i=new Map([[9,.25],[0,.25],["i",.75],["o",1],["p",.75],["k",.25],["l",.25]]);return S=(s,o)=>function(r){const[i,s,o]=r;let a=0;return e.has(i)&&(a+=e.get(i)),t.has(s)&&(a+=t.get(s)),n.has(o)&&(a+=n.get(o)),a}(s)>=2||!(function(e){const[t,n]=e;let s=0;return r.has(t)&&(s+=r.get(t)),i.has(n)&&(s+=i.get(n)),s}(s)>=1.25)&&o.default}function N(){if(b)return P.exports;b=1;const e=A(),t=(t,n)=>{if(t=String(t).trim(),null!==(n=Object.assign({lenient:!1,default:null},n)).default&&"boolean"!=typeof n.default)throw new TypeError(`Expected the \`default\` option to be of type \`boolean\`, got \`${typeof n.default}\``);return!!/^(?:y|yes|true|1)$/i.test(t)||!/^(?:n|no|false|0)$/i.test(t)&&(!0===n.lenient?e(t,n):n.default)};return P.exports=t,P.exports.default=t,P.exports}function I(){if(k)return _;k=1;const n=i,r=t,s=e;return _=function(e){return e||(e=process.cwd()),function(e){try{return s.lstatSync(e).isDirectory()}catch(e){return!1}}(e)&&(e=r.join(e,"index.js")),n.createRequire?n.createRequire(e):n.createRequireFromPath?n.createRequireFromPath(e):function(e){const t=new n.Module(e,null);return t.filename=e,t.paths=n.Module._nodeModulePaths(r.dirname(e)),t._compile("module.exports = require;",e),t.exports}(e)}}var T,R,O={};function L(){if(T)return O;T=1;const s=i,o=r,c=e,l=t,p=a,h=n,d=Object.prototype.hasOwnProperty;class f{constructor(e,t){const n=t?y(t+"."):"";this._blobFilename=l.join(e,n+"BLOB"),this._mapFilename=l.join(e,n+"MAP"),this._lockFilename=l.join(e,n+"LOCK"),this._directory=e,this._load()}has(e,t){return d.call(this._memoryBlobs,e)?this._invalidationKeys[e]===t:!!d.call(this._storedMap,e)&&this._storedMap[e][0]===t}get(e,t){if(d.call(this._memoryBlobs,e)){if(this._invalidationKeys[e]===t)return this._memoryBlobs[e]}else if(d.call(this._storedMap,e)){const n=this._storedMap[e];if(n[0]===t)return this._storedBlob.slice(n[1],n[2])}}set(e,t,n){this._invalidationKeys[e]=t,this._memoryBlobs[e]=n,this._dirty=!0}delete(e){d.call(this._memoryBlobs,e)&&(this._dirty=!0,delete this._memoryBlobs[e]),d.call(this._invalidationKeys,e)&&(this._dirty=!0,delete this._invalidationKeys[e]),d.call(this._storedMap,e)&&(this._dirty=!0,delete this._storedMap[e])}isDirty(){return this._dirty}save(){const e=this._getDump(),t=Buffer.concat(e[0]),n=JSON.stringify(e[1]);try{g(this._directory),c.writeFileSync(this._lockFilename,"LOCK",{flag:"wx"})}catch(e){return!1}try{c.writeFileSync(this._blobFilename,t),c.writeFileSync(this._mapFilename,n)}finally{c.unlinkSync(this._lockFilename)}return!0}_load(){try{this._storedBlob=c.readFileSync(this._blobFilename),this._storedMap=JSON.parse(c.readFileSync(this._mapFilename))}catch(e){this._storedBlob=Buffer.alloc(0),this._storedMap={}}this._dirty=!1,this._memoryBlobs={},this._invalidationKeys={}}_getDump(){const e=[],t={};let n=0;function r(r,i,s){e.push(s),t[r]=[i,n,n+s.length],n+=s.length}for(const e of Object.keys(this._memoryBlobs)){const t=this._memoryBlobs[e];r(e,this._invalidationKeys[e],t)}for(const e of Object.keys(this._storedMap)){if(d.call(t,e))continue;const n=this._storedMap[e],i=this._storedBlob.slice(n[1],n[2]);r(e,n[0],i)}return[e,t]}}class m{constructor(){this._cacheStore=null,this._previousModuleCompile=null}setCacheStore(e){this._cacheStore=e}install(){const e=this,t="function"==typeof require.resolve.paths;this._previousModuleCompile=s.prototype._compile,s.prototype._compile=this._ownModuleCompile=function(n,r){if(!e.enabled)return this._previousModuleCompile.apply(this,arguments);const i=this;function o(e){return i.require(e)}function a(e,t){return s._resolveFilename(e,i,!1,t)}o.resolve=a,t&&(a.paths=function(e){return s._resolveLookupPaths(e,i,!0)});o.main=process.mainModule,o.extensions=s._extensions,o.cache=s._cache;const c=l.dirname(r),p=e._moduleCompile(r,n),h=[i.exports,o,i,r,c,process,u,Buffer];return p.apply(i.exports,h)},e.enabled=!0}uninstall(){this.enabled=!1,s.prototype._compile===this._ownModuleCompile&&(s.prototype._compile=this._previousModuleCompile)}_moduleCompile(e,t){var n=t.length;if(n>=2&&35===t.charCodeAt(0)&&33/*!*/===t.charCodeAt(1))if(2===n)t="";else{for(var r=2;r<n;++r){var i=t.charCodeAt(r);if(10===i||13===i)break}t=r===n?"":t.slice(r)}var a=s.wrap(t),c=o.createHash("sha1").update(t,"utf8").digest("hex"),l=this._cacheStore.get(e,c),u=new p.Script(a,{filename:e,lineOffset:0,displayErrors:!0,cachedData:l,produceCachedData:!0});return u.cachedDataProduced?this._cacheStore.set(e,c,u.cachedData):u.cachedDataRejected&&this._cacheStore.delete(e),u.runInThisContext({filename:e,lineOffset:0,columnOffset:0,displayErrors:!0})}}function g(e){v(l.resolve(e),511)}function v(e,t){try{c.mkdirSync(e,t)}catch(t){if("ENOENT"===t.code)v(l.dirname(e)),v(e);else try{if(!c.statSync(e).isDirectory())throw t}catch(e){throw t}}}function y(e){const t={"\\":"zB",":":"zC","/":"zS","\0":"z0",z:"zZ"};return e.replace(/[\\:/\x00z]/g,(e=>t[e]))}function x(){return!0===new p.Script('""',{produceCachedData:!0}).cachedDataProduced}function E(){const e=process.env.V8_COMPILE_CACHE_CACHE_DIR;if(e)return e;const t="function"==typeof process.getuid?"v8-compile-cache-"+process.getuid():"v8-compile-cache",n="string"==typeof process.versions.v8?process.versions.v8:"string"==typeof process.versions.chakracore?"chakracore-"+process.versions.chakracore:"node-"+process.version;return l.join(h.tmpdir(),t,n)}function S(){return require.main&&"string"==typeof require.main.filename?require.main.filename:process.cwd()}return O.install=function(e){if(!process.env.DISABLE_V8_COMPILE_CACHE&&x()){void 0===e&&(e={});let t=e.cacheDir;void 0===t&&(t=E());let n=e.prefix;void 0===n&&(n=S());const r=new f(t,n),i=new m;i.setCacheStore(r),i.install();let s=!1;const o=()=>{s||(s=!0,process.removeListener("exit",o),r.isDirty()&&r.save(),i.uninstall())};return process.once("exit",o),{uninstall:o}}},O.__TEST__={FileSystemBlobStore:f,NativeCompileCache:m,mkdirpSync:g,slashEscape:y,supportsCachedData:x,getCacheDir:E,getMainName:S},O}function D(){if(R)return C;var e;R=1,Object.defineProperty(C,"__esModule",{value:!0}),C.versionGteLt=C.once=C.getBasePathForProjectLocalDependencyResolution=C.createProjectLocalResolveHelper=C.attemptRequireWithV8CompileCache=C.cachedLookup=C.hasOwnProperty=C.normalizeSlashes=C.parse=C.split=C.assign=C.yn=C.createRequire=void 0;const n=i,r=N(),s=t;C.createRequire=null!==(e=null!==n.createRequire&&void 0!==n.createRequire?n.createRequire:n.createRequireFromPath)&&void 0!==e?e:I(),C.yn=function(e){var t;return null!==(t=r(e))&&void 0!==t?t:void 0},C.assign=function(e,...t){for(const n of t)for(const t of Object.keys(n)){const r=n[t];void 0!==r&&(e[t]=r)}return e},C.split=function(e){return"string"==typeof e?e.split(/ *, */g).filter((e=>""!==e)):void 0},C.parse=function(e){return"string"==typeof e?JSON.parse(e):void 0};const o=/\\/g;return C.normalizeSlashes=function(e){return e.replace(o,"/")},C.hasOwnProperty=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},C.cachedLookup=function(e){const t=new Map;return n=>{if(!t.has(n)){const r=e(n);return t.set(n,r),r}return t.get(n)}},C.attemptRequireWithV8CompileCache=function(e,t){try{const n=L().install();try{return e(t)}finally{null==n||n.uninstall()}}catch(n){return e(t)}},C.createProjectLocalResolveHelper=function(e){return function(t,n){return require.resolve(t,{paths:n?[e,__dirname]:[e]})}},C.getBasePathForProjectLocalDependencyResolution=function(e,t,n,r){var i;return null!=e?(0,s.dirname)(e):null!==(i=null!=t?t:n)&&void 0!==i?i:r},C.once=function(e){let t,n=!1;return function(...r){return n||(t=e(...r),n=!0),t}},C.versionGteLt=function(e,t,n){const[r,i,s,o]=h(e),[a,c,l]=h(t),p=r>a||r===a&&(i>c||i===c&&s>=l);let u=!0;if(n){const[e,t,o]=h(n);u=r<e||r===e&&(i<t||i===t&&s<o)}return p&&u;function h(e){return e.split(/[\.-]/).map((e=>parseInt(e,10)))}},C}var j,F={},M={};function V(){if(j)return M;j=1,Object.defineProperty(M,"__esModule",{value:!0}),M.getEmitScriptTarget=M.getUseDefineForClassFields=M.getPatternFromSpec=M.createTsInternals=void 0;const e=t,n=D();function r(t,...r){return(0,n.normalizeSlashes)((0,e.resolve)(t,...r.filter((e=>e))))}function i(e,t){return 0===e.lastIndexOf(t,0)}M.createTsInternals=(0,n.cachedLookup)((function(t){const s=t;return{getExtendsConfigPath:function(t,o,a,c,l){if(t=(0,n.normalizeSlashes)(t),h=t,(0,e.isAbsolute)(h)||i(t,"./")||i(t,"../")){let r=(p=t,u=a,(0,n.normalizeSlashes)(null!=u?(0,e.resolve)(u,p):(0,e.resolve)(p)));return o.fileExists(r)||function(e,t){const n=e.length-t.length;return n>=0&&e.indexOf(t,n)===n}(r,s.Extension.Json)||(r=`${r}.json`,o.fileExists(r))?r:void c.push(l(s.Diagnostics.File_0_not_found,t))}var p,u,h;const d=(0,n.versionGteLt)(s.version,"5.3.0"),f=s.nodeModuleNameResolver(t,r(a,"tsconfig.json"),{moduleResolution:s.ModuleResolutionKind.NodeJs},o,void 0,void 0,!d||void 0,!!d||void 0);if(f.resolvedModule)return f.resolvedModule.resolvedFileName;c.push(l(s.Diagnostics.File_0_not_found,t))}}}));const s=/[^\w\s\/]/g;M.getPatternFromSpec=function(e,t){const n=e&&function(e,t,{singleAsteriskRegexFragment:n,doubleAsteriskRegexFragment:i,replaceWildcardCharacter:o}){let u="",h=!1;const d=(g=e,v=t,function(e){if(!((t=e)&&t.length>0))return[];var t;const n=[e[0]];for(let t=1;t<e.length;t++){const r=e[t];if(r&&"."!==r){if(".."===r)if(n.length>1){if(".."!==n[n.length-1]){n.pop();continue}}else if(n[0])continue;n.push(r)}}return n}(function(e,t=""){return function(e,t){const n=e.substring(0,t),r=e.substring(t).split(a);var i;return r.length&&!(0===(i=r).length?void 0:i[i.length-1])&&r.pop(),[n,...r]}(e=r(t,e),function(e){const t=function(e){if(!e)return 0;const t=e.charCodeAt(0);if(47===t||92===t){if(e.charCodeAt(1)!==t)return 1;const n=e.indexOf(47===t?a:c,2);return n<0?e.length:n+1}if(p(t)&&58===e.charCodeAt(1)){const t=e.charCodeAt(2);if(47===t||92===t)return 3;if(2===e.length)return 2}const n=e.indexOf(l);if(-1!==n){const t=n+l.length,r=e.indexOf(a,t);if(-1!==r){const i=e.slice(0,n),s=e.slice(t,r);if("file"===i&&(""===s||"localhost"===s)&&p(e.charCodeAt(r+1))){const t=function(e,t){const n=e.charCodeAt(t);if(58===n)return t+1;if(37===n&&51===e.charCodeAt(t+1)){const n=e.charCodeAt(t+2);if(97===n||65===n)return t+3}return-1}(e,r+2);if(-1!==t){if(47===e.charCodeAt(t))return~(t+1);if(t===e.length)return~t}}return~(r+1)}return~e.length}return 0}(e);return t<0?~t:t}(e))}(g,v))),f=(m=d,m[m.length-1]);var m;var g,v;d[0]=function(e){if(function(e){return e.length>0&&(t=e.charCodeAt(e.length-1),47===t||92===t);var t}(e))return e.substr(0,e.length-1);return e}(d[0]),function(e){return!/[.*?]/.test(e)}(f)&&d.push("**","*");let y=0;for(let e of d)"**"===e?u+=i:(h&&(u+=a),u+=e.replace(s,o)),h=!0;for(;y>0;)u+=")?",y--;return u}(e,t,o);return n&&`^(${n})($|/)`};const o={singleAsteriskRegexFragment:"[^/]*",doubleAsteriskRegexFragment:"(/.+?)?",replaceWildcardCharacter:e=>function(e,t){return"*"===e?t:"?"===e?"[^/]":"\\"+e}(e,o.singleAsteriskRegexFragment)};const a="/",c="\\",l="://";function p(e){return e>=97&&e<=122||e>=65&&e<=90}function u(e){var t;return null!==(t=e.target)&&void 0!==t?t:(100===e.module?9:199===e.module&&99)||1}return M.getUseDefineForClassFields=function(e){return void 0===e.useDefineForClassFields?u(e)>=9:e.useDefineForClassFields},M.getEmitScriptTarget=u,M}var B,U,H={},q={$schema:"https://json.schemastore.org/tsconfig",display:"Node 16",compilerOptions:{lib:["es2021"],module:"Node16",target:"es2021",strict:!0,esModuleInterop:!0,skipLibCheck:!0,forceConsistentCasingInFileNames:!0,moduleResolution:"node"}},$={$schema:"https://json.schemastore.org/tsconfig",display:"Node 14",compilerOptions:{lib:["es2020"],module:"commonjs",target:"es2020",strict:!0,esModuleInterop:!0,skipLibCheck:!0,forceConsistentCasingInFileNames:!0,moduleResolution:"node"}},W={$schema:"https://json.schemastore.org/tsconfig",display:"Node 12",compilerOptions:{lib:["es2019","es2020.promise","es2020.bigint","es2020.string"],module:"commonjs",target:"es2019",strict:!0,esModuleInterop:!0,skipLibCheck:!0,forceConsistentCasingInFileNames:!0,moduleResolution:"node"}},G={$schema:"https://json.schemastore.org/tsconfig",compilerOptions:{lib:["es2018"],module:"commonjs",target:"es2018",strict:!0,esModuleInterop:!0,skipLibCheck:!0,moduleResolution:"node"}};function K(){return U||(U=1,function(e){Object.defineProperty(e,"__esModule",{value:!0}),e.getTsConfigDefaults=e.ComputeAsCommonRootOfFiles=e.loadCompiler=e.resolveAndLoadCompiler=e.readConfig=e.findAndReadConfig=void 0;const n=t,r=Zt(),i=V(),s=function(){if(B)return H;B=1,Object.defineProperty(H,"__esModule",{value:!0}),H.getDefaultTsconfigJsonForNodeVersion=void 0;const e=parseInt(process.versions.node.split(".")[0],10);return H.getDefaultTsconfigJsonForNodeVersion=function(t){const n=t;if(e>=16){const e=q;if(r(e))return e}if(e>=14){const e=$;if(r(e))return e}if(e>=12){const e=W;if(r(e))return e}return G;function r(e){return"number"==typeof t.ScriptTarget[e.compilerOptions.target.toUpperCase()]&&n.libs&&e.compilerOptions.lib.every((e=>n.libs.includes(e)))}},H}(),o=D(),a={sourceMap:!0,inlineSourceMap:!1,inlineSources:!0,declaration:!1,noEmit:!1,outDir:".ts-node"};function c(e,t,c){var l,p,u;const d=[];let f,m={compilerOptions:{}},g=e;const v=(0,n.resolve)(e,null!==(l=c.projectSearchDir)&&void 0!==l?l:e),{fileExists:y=t.sys.fileExists,readFile:x=t.sys.readFile,skipProject:E=r.DEFAULTS.skipProject,project:S=r.DEFAULTS.project,tsTrace:w=r.DEFAULTS.tsTrace}=c;if(!E){if(S){const t=(0,n.resolve)(e,S),r=(0,n.join)(t,"tsconfig.json");f=y(r)?r:t}else f=t.findConfigFile(v,y);if(f){let e=f;const r=(0,i.createTsInternals)(t),s=[];for(;;){const i=t.readConfigFile(e,x);if(i.error)return{configFilePath:f,config:{errors:[i.error],fileNames:[],options:{}},tsNodeOptionsFromTsconfig:{},optionBasePaths:{}};const o=i.config,a=(0,n.dirname)(e);if(d.push({config:o,basePath:a,configPath:e}),null==o.extends)break;const c=r.getExtendsConfigPath(o.extends,{fileExists:y,readDirectory:t.sys.readDirectory,readFile:x,useCaseSensitiveFileNames:t.sys.useCaseSensitiveFileNames,trace:w},a,s,t.createCompilerDiagnostic);if(s.length)return{configFilePath:f,config:{errors:s,fileNames:[],options:{}},tsNodeOptionsFromTsconfig:{},optionBasePaths:{}};if(null==c)break;e=c}({config:m,basePath:g}=d[0])}}const b={},_={};for(let e=d.length-1;e>=0;e--){const{config:t,basePath:r,configPath:i}=d[e],s=h(t["ts-node"]).recognized;if(s.require){const e=(0,o.createProjectLocalResolveHelper)((0,n.dirname)(i));s.require=s.require.map((t=>e(t,!1)))}s.scopeDir&&(s.scopeDir=(0,n.resolve)(r,s.scopeDir)),s.moduleTypes&&(_.moduleTypes=r),null!=s.transpiler&&(_.transpiler=r),null!=s.compiler&&(_.compiler=r),null!=s.swc&&(_.swc=r),(0,o.assign)(b,s)}const k=null!==(u=null!==(p=c.files)&&void 0!==p?p:b.files)&&void 0!==u?u:r.DEFAULTS.files,C=null!=f?void 0:{...(0,s.getDefaultTsconfigJsonForNodeVersion)(t).compilerOptions,types:["node"]};m.compilerOptions=Object.assign({},C,m.compilerOptions,r.DEFAULTS.compilerOptions,b.compilerOptions,c.compilerOptions,a);const P=function(e,t){return delete t.options.out,delete t.options.outFile,delete t.options.composite,delete t.options.declarationDir,delete t.options.declarationMap,delete t.options.emitDeclarationOnly,void 0===t.options.target&&(t.options.target=e.ScriptTarget.ES5),void 0===t.options.module&&(t.options.module=e.ModuleKind.CommonJS),t}(t,t.parseJsonConfigFileContent(m,{fileExists:y,readFile:x,readDirectory:k?t.sys.readDirectory:()=>[],useCaseSensitiveFileNames:t.sys.useCaseSensitiveFileNames},g,void 0,f));return{configFilePath:f,config:P,tsNodeOptionsFromTsconfig:b,optionBasePaths:_}}function l(e,t){const{compiler:n}=p(e,t);return{compiler:n,ts:u(n)}}function p(e,t){return{compiler:(0,o.createProjectLocalResolveHelper)(t)(e||"typescript",!0)}}function u(e){return(0,o.attemptRequireWithV8CompileCache)(v,e)}function h(e){if(null==e)return{recognized:{},unrecognized:{}};const{compiler:t,compilerHost:n,compilerOptions:r,emit:i,files:s,ignore:o,ignoreDiagnostics:a,logError:c,preferTsExts:l,pretty:p,require:u,skipIgnore:h,transpileOnly:d,typeCheck:f,transpiler:m,scope:g,scopeDir:v,moduleTypes:y,experimentalReplAwait:x,swc:E,experimentalResolver:S,esm:w,experimentalSpecifierResolution:b,experimentalTsImportSpecifiers:_,...k}=e;return{recognized:{compiler:t,compilerHost:n,compilerOptions:r,emit:i,experimentalReplAwait:x,files:s,ignore:o,ignoreDiagnostics:a,logError:c,preferTsExts:l,pretty:p,require:u,skipIgnore:h,transpileOnly:d,typeCheck:f,transpiler:m,scope:g,scopeDir:v,moduleTypes:y,swc:E,experimentalResolver:S,esm:w,experimentalSpecifierResolution:b,experimentalTsImportSpecifiers:_},unrecognized:k}}e.findAndReadConfig=function(e){var t,i,s,a,u;const h=(0,n.resolve)(null!==(s=null!==(i=null!==(t=e.cwd)&&void 0!==t?t:e.dir)&&void 0!==i?i:r.DEFAULTS.cwd)&&void 0!==s?s:process.cwd()),d=null!==(a=e.compiler)&&void 0!==a?a:r.DEFAULTS.compiler;let f=(0,o.getBasePathForProjectLocalDependencyResolution)(void 0,e.projectSearchDir,e.project,h),{compiler:m,ts:g}=l(d,f);const{configFilePath:v,config:y,tsNodeOptionsFromTsconfig:x,optionBasePaths:E}=c(h,g,e),S=(0,o.assign)({},r.DEFAULTS,x||{},{optionBasePaths:E},e);return S.require=[...x.require||[],...e.require||[]],v&&(f=(0,o.getBasePathForProjectLocalDependencyResolution)(v,e.projectSearchDir,e.project,h),({compiler:m}=p(S.compiler,null!==(u=E.compiler)&&void 0!==u?u:f))),{options:S,config:y,projectLocalResolveDir:f,optionBasePaths:E,configFilePath:v,cwd:h,compiler:m}},e.readConfig=c,e.resolveAndLoadCompiler=l,e.loadCompiler=u,e.ComputeAsCommonRootOfFiles=Symbol(),e.getTsConfigDefaults=function(t,n,r,i,s){const{composite:o=!1}=t.options;let a=t.options.rootDir;null==a&&(a=o?n:e.ComputeAsCommonRootOfFiles);const{outDir:c=a}=t.options;return{rootDir:a,outDir:c,include:r?[]:["**/*"],files:null!=r?r:[],exclude:null!=s?s:[c],composite:o}}}(F)),F}var z,J={};var Y,Q={};function X(){if(Y)return Q;Y=1,Object.defineProperty(Q,"__esModule",{value:!0}),Q.createResolverFunctions=void 0;const e=t;return Q.createResolverFunctions=function(t){const{host:n,ts:r,config:i,cwd:s,getCanonicalFileName:o,projectLocalResolveHelper:a,options:c,extensions:l}=t,p=r.createModuleResolutionCache(s,o,i.options),u=new Set,h=new Set,d=/.*\/node_modules\/(?:@[^\/]+\/)?[^\/]+\//;function f(e){const t=d.exec(e);return t?t[0]:""}function m(e){return u.has(e)}const g=e=>{const{resolvedFileName:t}=e;var n;void 0!==t&&(e.isExternalLibraryImport&&(t.endsWith(".ts")&&!t.endsWith(".d.ts")||t.endsWith(".cts")&&!t.endsWith(".d.cts")||t.endsWith(".mts")&&!t.endsWith(".d.mts")||m(t)||(n=t,h.has(f(n))))&&(e.isExternalLibraryImport=!1),e.isExternalLibraryImport||u.add(t))};return{resolveModuleNames:(e,t,s,o,a,u)=>e.map(((e,s)=>{var a,h;const d=u?null===(h=(a=r).getModeForResolutionAtIndex)||void 0===h?void 0:h.call(a,u,s):void 0;let{resolvedModule:f}=r.resolveModuleName(e,t,i.options,n,p,o,d);if(!f&&c.experimentalTsImportSpecifiers){const s=e.lastIndexOf("."),a=s>=0?e.slice(s):"";if(a){const s=l.tsResolverEquivalents.get(a);for(const c of null!=s?s:[])if(({resolvedModule:f}=r.resolveModuleName(e.slice(0,-a.length)+c,t,i.options,n,p,o,d)),f)break}}return f&&g(f),f})),getResolvedModuleWithFailedLookupLocationsFromCache:(e,t,n)=>{const i=r.resolveModuleNameFromCache(e,t,p,n);return i&&i.resolvedModule&&g(i.resolvedModule),i},resolveTypeReferenceDirectives:(t,s,o,c,l)=>t.map((t=>{const c="string"==typeof t,p=c?void 0:r.getModeForFileReference(t,l),u=c?t:t.fileName.toLowerCase();let{resolvedTypeReferenceDirective:h}=r.resolveTypeReferenceDirective(u,s,i.options,n,o,void 0,p);if("node"===t&&!h){let c;try{c=a("@types/node/package.json",!0)}catch{}if(c){const a=[(0,e.resolve)(c,"../..")];({resolvedTypeReferenceDirective:h}=r.resolveTypeReferenceDirective(t,s,{...i.options,typeRoots:a},n,o))}}return h&&g(h),h})),isFileKnownToBeInternal:m,markBucketOfFilenameInternal:function(e){h.add(f(e))}}},Q}var Z,ee={};var te,ne,re={};function ie(){return ne?te:(ne=1,te={ArrayFrom:Array.from,ArrayIsArray:Array.isArray,ArrayPrototypeShift:e=>Array.prototype.shift.call(e),ArrayPrototypeForEach:(e,...t)=>Array.prototype.forEach.apply(e,t),ArrayPrototypeIncludes:(e,...t)=>Array.prototype.includes.apply(e,t),ArrayPrototypeJoin:(e,...t)=>Array.prototype.join.apply(e,t),ArrayPrototypePop:(e,...t)=>Array.prototype.pop.apply(e,t),ArrayPrototypePush:(e,...t)=>Array.prototype.push.apply(e,t),FunctionPrototype:Function.prototype,JSONParse:JSON.parse,JSONStringify:JSON.stringify,ObjectFreeze:Object.freeze,ObjectKeys:Object.keys,ObjectGetOwnPropertyNames:Object.getOwnPropertyNames,ObjectDefineProperty:Object.defineProperty,ObjectPrototypeHasOwnProperty:(e,t)=>Object.prototype.hasOwnProperty.call(e,t),RegExpPrototypeExec:(e,t)=>RegExp.prototype.exec.call(e,t),RegExpPrototypeTest:(e,t)=>RegExp.prototype.test.call(e,t),RegExpPrototypeSymbolReplace:(e,...t)=>RegExp.prototype[Symbol.replace].apply(e,t),SafeMap:Map,SafeSet:Set,SafeWeakMap:WeakMap,StringPrototypeEndsWith:(e,...t)=>String.prototype.endsWith.apply(e,t),StringPrototypeIncludes:(e,...t)=>String.prototype.includes.apply(e,t),StringPrototypeLastIndexOf:(e,...t)=>String.prototype.lastIndexOf.apply(e,t),StringPrototypeIndexOf:(e,...t)=>String.prototype.indexOf.apply(e,t),StringPrototypeRepeat:(e,...t)=>String.prototype.repeat.apply(e,t),StringPrototypeReplace:(e,...t)=>String.prototype.replace.apply(e,t),StringPrototypeSlice:(e,...t)=>String.prototype.slice.apply(e,t),StringPrototypeSplit:(e,...t)=>String.prototype.split.apply(e,t),StringPrototypeStartsWith:(e,...t)=>String.prototype.startsWith.apply(e,t),StringPrototypeSubstr:(e,...t)=>String.prototype.substr.apply(e,t),StringPrototypeCharCodeAt:(e,...t)=>String.prototype.charCodeAt.apply(e,t),StringPrototypeMatch:(e,...t)=>String.prototype.match.apply(e,t),SyntaxError:SyntaxError})}var se,oe,ae,ce,le,pe={};function ue(){if(se)return pe;se=1;const e=i,t={canBeRequiredByUsers:t=>e.builtinModules.includes(t)};return pe.NativeModule=t,pe}function he(){if(ae)return oe;ae=1;const t=e,{versionGteLt:n}=D();const r=n(process.versions.node,"15.3.0")||n(process.versions.node,"14.17.0","15.0.0");return oe={internalModuleReadJSON:function(e){let n;try{n=t.readFileSync(e,"utf8")}catch(e){if("ENOENT"===e.code)return[];throw e}return[n,!0]},internalModuleStat:r?function(e){const n=t.statSync(e,{throwIfNoEntry:!1});return n?n.isFile()?0:n.isDirectory()?1:void 0:-1}:function(e){try{const n=t.statSync(e);if(n.isFile())return 0;if(n.isDirectory())return 1}catch(e){return-e.errno||-1}}}}function de(){if(le)return ce;le=1;const{SafeMap:e}=ie(),{internalModuleReadJSON:n}=he(),{pathToFileURL:r}=o,{toNamespacedPath:i}=t,s=new e;let a;return ce={read:function(e){if(s.has(e))return s.get(e);const[t,o]=n(i(e)),c={string:t,containsKeys:o};if(void 0!==t&&(void 0===a&&(a=null),null!==a)){const n=r(e);a.assertIntegrity(n,t)}return s.set(e,c),c}}}var fe,me,ge,ve,ye={},xe={};function Ee(){if(ge)return xe;let e;function t(e){return function(){if(me)return fe;me=1;const e=Symbol("arg flag");function t(t,{argv:n=process.argv.slice(2),permissive:r=!1,stopAtPositional:i=!1}={}){if(!t)throw new Error("Argument specification object is required");const s={_:[]},o={},a={};for(const n of Object.keys(t)){if(!n)throw new TypeError("Argument key cannot be an empty string");if("-"!==n[0])throw new TypeError(`Argument key must start with '-' but found: '${n}'`);if(1===n.length)throw new TypeError(`Argument key must have a name; singular '-' keys are not allowed: ${n}`);if("string"==typeof t[n]){o[n]=t[n];continue}let r=t[n],i=!1;if(Array.isArray(r)&&1===r.length&&"function"==typeof r[0]){const[t]=r;r=(e,n,r=[])=>(r.push(t(e,n,r[r.length-1])),r),i=t===Boolean||!0===t[e]}else{if("function"!=typeof r)throw new TypeError(`Type missing or not a function or valid array type: ${n}`);i=r===Boolean||!0===r[e]}if("-"!==n[1]&&n.length>2)throw new TypeError(`Short argument keys (with a single hyphen) must have only one character: ${n}`);a[n]=[r,i]}for(let e=0,t=n.length;e<t;e++){const t=n[e];if(i&&s._.length>0){s._=s._.concat(n.slice(e));break}if("--"===t){s._=s._.concat(n.slice(e+1));break}if(t.length>1&&"-"===t[0]){const i="-"===t[1]||2===t.length?[t]:t.slice(1).split("").map((e=>`-${e}`));for(let t=0;t<i.length;t++){const c=i[t],[l,p]="-"===c[1]?c.split(/=(.*)/,2):[c,void 0];let u=l;for(;u in o;)u=o[u];if(!(u in a)){if(r){s._.push(c);continue}{const e=new Error(`Unknown or unexpected option: ${l}`);throw e.code="ARG_UNKNOWN_OPTION",e}}const[h,d]=a[u];if(!d&&t+1<i.length)throw new TypeError(`Option requires argument (but was followed by another short argument): ${l}`);if(d)s[u]=h(!0,u,s[u]);else if(void 0===p){if(n.length<e+2||n[e+1].length>1&&"-"===n[e+1][0]&&(!n[e+1].match(/^-?\d*(\.(?=\d))?\d*$/)||h!==Number&&("undefined"==typeof BigInt||h!==BigInt)))throw new Error(`Option requires argument: ${l}${l===u?"":` (alias for ${u})`}`);s[u]=h(n[e+1],u,s[u]),++e}else s[u]=h(p,u,s[u])}}else s._.push(t)}return s}return t.flag=t=>(t[e]=!0,t),t.COUNT=t.flag(((e,t,n)=>(n||0)+1)),fe=t}()({"--preserve-symlinks":Boolean,"--preserve-symlinks-main":Boolean,"--input-type":String,"--experimental-specifier-resolution":String,"--es-module-specifier-resolution":"--experimental-specifier-resolution","--experimental-policy":String,"--conditions":[String],"--pending-deprecation":Boolean,"--experimental-json-modules":Boolean,"--experimental-wasm-modules":Boolean},{argv:e,permissive:!0})}function n(){const e=function(e,t){const n=[];let r=!1,i=!0;for(let s=0;s<e.length;++s){let o=e[s];if("\\"===o&&r){if(s+1===e.length)return t.push("invalid value for NODE_OPTIONS (invalid escape)\n"),n;o=e[++s]}else{if(" "===o&&!r){i=!0;continue}if('"'===o){r=!r;continue}}i?(n.push(o),i=!1):n[n.length-1]+=o}r&&t.push("invalid value for NODE_OPTIONS (unterminated string)\n");return n}(process.env.NODE_OPTIONS||"",[]);return e}function r(){const e={};return"1"===process.env.NODE_PENDING_DEPRECATION&&(e["--pending-deprecation"]=!0),e}return ge=1,xe.getOptionValue=function(i){return function(){e||(e={"--preserve-symlinks":!1,"--preserve-symlinks-main":!1,"--input-type":void 0,"--experimental-specifier-resolution":"explicit","--experimental-policy":void 0,"--conditions":[],"--pending-deprecation":!1,...t(n()),...t(process.execArgv),...r()})}(),e[i]},xe}var Se,we,be,_e,ke,Ce,Pe={};function Ae(){if(Se)return Pe;Se=1;const e=t;function n(e){return(...t)=>[e,...t].join(" ")}function r(e){return class extends Error{constructor(...t){super(e(...t))}}}return Pe.codes={ERR_INPUT_TYPE_NOT_ALLOWED:r(n("ERR_INPUT_TYPE_NOT_ALLOWED")),ERR_INVALID_ARG_VALUE:r(n("ERR_INVALID_ARG_VALUE")),ERR_INVALID_MODULE_SPECIFIER:r(n("ERR_INVALID_MODULE_SPECIFIER")),ERR_INVALID_PACKAGE_CONFIG:r(n("ERR_INVALID_PACKAGE_CONFIG")),ERR_INVALID_PACKAGE_TARGET:r(n("ERR_INVALID_PACKAGE_TARGET")),ERR_MANIFEST_DEPENDENCY_MISSING:r(n("ERR_MANIFEST_DEPENDENCY_MISSING")),ERR_MODULE_NOT_FOUND:r(((e,t,n="package")=>`Cannot find ${n} '${e}' imported from ${t}`)),ERR_PACKAGE_IMPORT_NOT_DEFINED:r(n("ERR_PACKAGE_IMPORT_NOT_DEFINED")),ERR_PACKAGE_PATH_NOT_EXPORTED:r(n("ERR_PACKAGE_PATH_NOT_EXPORTED")),ERR_UNSUPPORTED_DIR_IMPORT:r(n("ERR_UNSUPPORTED_DIR_IMPORT")),ERR_UNSUPPORTED_ESM_URL_SCHEME:r(n("ERR_UNSUPPORTED_ESM_URL_SCHEME")),ERR_UNKNOWN_FILE_EXTENSION:r(n("ERR_UNKNOWN_FILE_EXTENSION"))},Pe.createErrRequireEsm=function(n,r,i){const s="ERR_REQUIRE_ESM",o=new Error(function(n,r=null,i=null){const s=e.extname(n);let o=`Must use import to load ES Module: ${n}`;if(r&&i){const e=t;return e.basename(n)===e.basename(r)||e.basename(n),o+=`\nrequire() of ES modules is not supported.\nrequire() of ${n} ${r?`from ${r} `:""}is an ES module file as it is a ${s} file whose nearest parent package.json contains "type": "module" which defines all ${s} files in that package scope as ES modules.\nInstead change the requiring code to use import(), or remove "type": "module" from ${i}.\n`,o}return o}(n,r,i));return o.name=`Error [${s}]`,o.stack,Object.defineProperty(o,"name",{value:"Error",enumerable:!1,writable:!0,configurable:!0}),o.code=s,o},Pe}function Ne(){if(ke)return _e;ke=1;const{ArrayIsArray:n,ArrayPrototypeIncludes:r,ArrayPrototypeJoin:s,ArrayPrototypePush:a,JSONParse:c,ObjectKeys:l,RegExpPrototypeTest:p,SafeMap:u,SafeWeakMap:h,StringPrototypeCharCodeAt:d,StringPrototypeEndsWith:f,StringPrototypeLastIndexOf:m,StringPrototypeIndexOf:g,StringPrototypeMatch:y,StringPrototypeSlice:x,StringPrototypeStartsWith:E}=ie(),{NativeModule:S}=ue(),{pathToFileURL:w,fileURLToPath:b}=o,_=e,k=t,{sep:C}=k,{internalModuleStat:P}=he(),A=de(),{cjsConditions:N}=function(){if(ve)return ye;ve=1;const{ArrayPrototypeForEach:e,ObjectDefineProperty:t,ObjectPrototypeHasOwnProperty:n,SafeSet:r,StringPrototypeIncludes:s,StringPrototypeStartsWith:o}=ie(),{getOptionValue:a}=Ee(),c=a("--conditions"),l=new r(["require","node",...a("--no-addons")?[]:["node-addons"],...c]);return ye.addBuiltinLibsToObject=function(r,a){const c=i.Module,{builtinModules:l}=c,p=new c(a);e(l,(e=>{if(o(e,"_")||s(e,"/")||n(r,e))return;const i=t=>{delete r[e],r[e]=t};t(r,e,{get:()=>{const n=(p.require||v)(e);return delete r[e],t(r,e,{get:()=>n,set:i,configurable:!0,enumerable:!1}),n},set:i,configurable:!0,enumerable:!1})}))},ye.cjsConditions=l,ye}(),{getOptionValue:I}=Ee(),T=I("--preserve-symlinks"),R=I("--preserve-symlinks-main"),{normalizeSlashes:O}=D(),{createErrRequireEsm:L}=Ae(),{codes:{ERR_INVALID_MODULE_SPECIFIER:j}}=Ae(),{CHAR_FORWARD_SLASH:F}=be?we:(be=1,we={CHAR_FORWARD_SLASH:47}),M=i,V="win32"===process.platform;function B(e){e=k.toNamespacedPath(e);return P(e)}const U=new h,H=new u;function q(e){const t=k.resolve(e,"package.json"),n=H.get(t);if(void 0!==n)return n;const r=A.read(t),i=!1===r.containsKeys?"{}":r.string;if(void 0===i)return H.set(t,!1),!1;try{const e=c(i),n={name:e.name,main:e.main,exports:e.exports,imports:e.imports,type:e.type};return H.set(t,n),n}catch(e){throw e.path=t,e.message="Error parsing "+t+": "+e.message,e}}function $(e){const t=g(e,C);let n;do{if(n=m(e,C),e=x(e,0,n),f(e,C+"node_modules"))return!1;const t=q(e+C);if(t)return{data:t,path:e}}while(n>t);return!1}return _e={createCjsLoader:function(e){const{nodeEsmResolver:t,preferTsExts:o}=e,{replacementsForCjs:c,replacementsForJs:h,replacementsForMjs:f,replacementsForJsx:m}=e.extensions,{encodedSepRegEx:g,packageExportsResolve:v,packageImportsResolve:C}=t;function P(e,t,n,r){const i=q(e),s=null!=i?i.main:void 0;if(!s)return D(k.resolve(e,"index"),t,n);const o=k.resolve(e,s);let a=L(o,n)||A(o,n)||D(o,t,n)||D(k.resolve(o,"index"),t,n);if(!1===a){if(a=D(k.resolve(e,"index"),t,n),!a){const t=new Error(`Cannot find module '${o}'. Please verify that the package.json has a valid "main" entry`);throw t.code="MODULE_NOT_FOUND",t.path=k.resolve(e,"package.json"),t.requestPath=r,t}{const t=k.resolve(e,"package.json");process.emitWarning(`Invalid 'main' field in '${t}' of '${s}'. Please either fix that or report it to the module author`,"DeprecationWarning","DEP0128")}}return a}function A(e,t){if(0===B(e))return T&&!t?k.resolve(e):I(e)}function I(e){return _.realpathSync(e,{})}function O(e){const t=e.lastIndexOf(".");if(t>=0){const n=e.slice(t);if(".js"===n||".jsx"===n||".mjs"===n||".cjs"===n){const r=e.slice(0,t),i=".js"===n?h:".jsx"===n?m:".mjs"===n?f:c;for(let e=0;e<i.length;e++){const t=r+i[e],n=B(t);if(0===n)return[n,t]}}}return[B(e),e]}function L(e,t){const n=e.lastIndexOf(".");if(n>=0){const r=e.slice(n);if(".js"===r||".jsx"===r||".mjs"===r||".cjs"===r){const i=e.slice(0,n),s=".js"===r?h:".jsx"===r?m:".mjs"===r?f:c;for(let e=0;e<s.length;e++){const n=A(i+s[e],t);if(n)return n}}}return!1}function D(e,t,n){for(let r=0;r<t.length;r++){const i=A(e+t[r],n);if(i)return i}return!1}new u;const H=/^((?:@[^/\\%]+\/)?[^./\\%][^/\\%]*)(\/.*)?$/;function W(e,t){const{1:n,2:r=""}=y(t,H)||[];if(!n)return;const i=k.resolve(e,n),s=q(i);if(null!=s&&null!=s.exports)try{return Q(v(w(i+"/package.json"),"."+r,s,null,N).resolved,null,i)}catch(e){if("ERR_MODULE_NOT_FOUND"===e.code)throw X(t,i+"/package.json");throw e}}const G=!!i._pathCache,K=Object.create(null),z=G?e=>M._pathCache[e]:e=>K[e],J=G?(e,t)=>M._pathCache[e]=t:e=>K[e]=value,Y=/(?:^|\/)\.?\.$/;function Q(e,t,n){if(p(g,e))throw new j(e,'must not include encoded "/" or "\\" characters',t);const r=b(e),i=L(r)||A(r);if(i)return i;throw X(r,k.resolve(n,"package.json"))}function X(e,t){const n=new Error(`Cannot find module '${e}'`);return n.code="MODULE_NOT_FOUND",t&&(n.path=t),n}return{Module_findPath:function(e,t,n){const r=k.isAbsolute(e);if(r)t=[""];else if(!t||0===t.length)return!1;const i=e+"\0"+s(t,"\0"),o=z(i);if(o)return o;let a,c=e.length>0&&d(e,e.length-1)===F;c||(c=p(Y,e));for(let s=0;s<t.length;s++){const o=t[s];if(o&&B(o)<1)continue;if(!r){const t=W(o,e);if(t)return t}const p=k.resolve(o,e);let u;const[h,d]=O(p);if(c||(0===h&&(u=n?R?k.resolve(d):I(d):T?k.resolve(d):I(d)),u||(void 0===a&&(a=l(M._extensions)),u=D(d,a,n))),u||1!==h||(void 0===a&&(a=l(M._extensions)),u=P(d,a,n,e)),u)return J(i,u),u}return!1},Module_resolveFilename:function(e,t,i,o){if(E(e,"node:")||S.canBeRequiredByUsers(e))return e;let c;if("object"==typeof o&&null!==o)if(n(o.paths)){if(E(e,"./")||E(e,"../")||V&&E(e,".\\")||E(e,"..\\"))c=o.paths;else{const t=new M("",null);c=[];for(let n=0;n<o.paths.length;n++){const i=o.paths[n];t.paths=M._nodeModulePaths(i);const s=M._resolveLookupPaths(e,t);for(let e=0;e<s.length;e++)r(c,s[e])||a(c,s[e])}}}else{if(void 0!==o.paths)throw new ERR_INVALID_ARG_VALUE("options.paths",o.paths);c=M._resolveLookupPaths(e,t)}else c=M._resolveLookupPaths(e,t);if(null!=t&&t.filename&&"#"===e[0]){const n=$(t.filename)||{};if(null!=n.data&&null!=n.data.imports)try{return Q(C(e,w(t.filename),N),t.filename,n.path)}catch(t){if("ERR_MODULE_NOT_FOUND"===t.code)throw X(e);throw t}}const l=function(e){if(!e)return!1;if(e.filename)return e.filename;if("<repl>"===e.id||"internal/preload"===e.id)try{return process.cwd()+k.sep}catch{return!1}}(t),p=function(e,t){if(!e)return!1;const{data:n,path:r}=$(e)||{};if(!n||void 0===n.exports)return!1;if("string"!=typeof n.name)return!1;let i;if(t===n.name)i=".";else{if(!E(t,`${n.name}/`))return!1;i="."+x(t,n.name.length)}try{return Q(v(w(r+"/package.json"),i,n,w(e),N).resolved,e,r)}catch(e){if("ERR_MODULE_NOT_FOUND"===e.code)throw X(t,r+"/package.json");throw e}}(l,e);if(p){const t=e+"\0"+(1===c.length?c[0]:s(c,"\0"));return M._pathCache[t]=p,p}const u=M._findPath(e,c,i,!1);if(u)return u;const h=[];for(let e=t;e;e=U.get(e))a(h,e.filename||e.id);let d=`Cannot find module '${e}'`;h.length>0&&(d=d+"\nRequire stack:\n- "+s(h,"\n- "));const f=new Error(d);throw f.code="MODULE_NOT_FOUND",f.requireStack=h,f}}},assertScriptCanLoadAsCJSImpl:function(e,t,n){const r=$(n),i=e.moduleTypeClassifier.classifyModuleByModuleTypeOverrides(O(n));if("cjs"===i.moduleType)return;const s=n.lastIndexOf("."),o=s>=0?n.slice(s):"";if((".cts"!==o&&".cjs"!==o||"auto"!==i.moduleType)&&(".mts"===o||".mjs"===o||"esm"===i.moduleType||r&&r.data&&"module"===r.data.type)){const e=t.parent&&t.parent.filename,i=r?k.resolve(r.path,"package.json"):null;throw L(n,e,i)}},readPackageScope:$},_e}var Ie,Te={};var Re,Oe={};var Le,De={},je={exports:{}};je.exports;function Fe(){return Le||(Le=1,function(e){var t=[509,0,227,0,150,4,294,9,1368,2,2,1,6,3,41,2,5,0,166,1,574,3,9,9,7,9,32,4,318,1,80,3,71,10,50,3,123,2,54,14,32,10,3,1,11,3,46,10,8,0,46,9,7,2,37,13,2,9,6,1,45,0,13,2,49,13,9,3,2,11,83,11,7,0,3,0,158,11,6,9,7,3,56,1,2,6,3,1,3,2,10,0,11,1,3,6,4,4,68,8,2,0,3,0,2,3,2,4,2,0,15,1,83,17,10,9,5,0,82,19,13,9,214,6,3,8,28,1,83,16,16,9,82,12,9,9,7,19,58,14,5,9,243,14,166,9,71,5,2,1,3,3,2,0,2,1,13,9,120,6,3,6,4,0,29,9,41,6,2,3,9,0,10,10,47,15,343,9,54,7,2,7,17,9,57,21,2,13,123,5,4,0,2,1,2,6,2,0,9,9,49,4,2,1,2,4,9,9,330,3,10,1,2,0,49,6,4,4,14,10,5350,0,7,14,11465,27,2343,9,87,9,39,4,60,6,26,9,535,9,470,0,2,54,8,3,82,0,12,1,19628,1,4178,9,519,45,3,22,543,4,4,5,9,7,3,6,31,3,149,2,1418,49,513,54,5,49,9,0,15,0,23,4,2,14,1361,6,2,16,3,6,2,1,2,4,101,0,161,6,10,9,357,0,62,13,499,13,245,1,2,9,726,6,110,6,6,9,4759,9,787719,239],n=[0,11,2,25,2,18,2,1,2,14,3,13,35,122,70,52,268,28,4,48,48,31,14,29,6,37,11,29,3,35,5,7,2,4,43,157,19,35,5,35,5,39,9,51,13,10,2,14,2,6,2,1,2,10,2,14,2,6,2,1,4,51,13,310,10,21,11,7,25,5,2,41,2,8,70,5,3,0,2,43,2,1,4,0,3,22,11,22,10,30,66,18,2,1,11,21,11,25,71,55,7,1,65,0,16,3,2,2,2,28,43,28,4,28,36,7,2,27,28,53,11,21,11,18,14,17,111,72,56,50,14,50,14,35,39,27,10,22,251,41,7,1,17,2,60,28,11,0,9,21,43,17,47,20,28,22,13,52,58,1,3,0,14,44,33,24,27,35,30,0,3,0,9,34,4,0,13,47,15,3,22,0,2,0,36,17,2,24,20,1,64,6,2,0,2,3,2,14,2,9,8,46,39,7,3,1,3,21,2,6,2,1,2,4,4,0,19,0,13,4,31,9,2,0,3,0,2,37,2,0,26,0,2,0,45,52,19,3,21,2,31,47,21,1,2,0,185,46,42,3,37,47,21,0,60,42,14,0,72,26,38,6,186,43,117,63,32,7,3,0,3,7,2,1,2,23,16,0,2,0,95,7,3,38,17,0,2,0,29,0,11,39,8,0,22,0,12,45,20,0,19,72,200,32,32,8,2,36,18,0,50,29,113,6,2,1,2,37,22,0,26,5,2,1,2,31,15,0,328,18,16,0,2,12,2,33,125,0,80,921,103,110,18,195,2637,96,16,1071,18,5,26,3994,6,582,6842,29,1763,568,8,30,18,78,18,29,19,47,17,3,32,20,6,18,433,44,212,63,129,74,6,0,67,12,65,1,2,0,29,6135,9,1237,42,9,8936,3,2,6,2,1,2,290,16,0,30,2,3,0,15,3,9,395,2309,106,6,12,4,8,8,9,5991,84,2,70,2,1,3,0,3,1,3,3,2,11,2,0,2,6,2,64,2,3,3,7,2,6,2,27,2,3,2,4,2,0,4,6,2,339,3,24,2,24,2,30,2,24,2,30,2,24,2,30,2,24,2,30,2,24,2,7,1845,30,7,5,262,61,147,44,11,6,17,0,322,29,19,43,485,27,229,29,3,0,496,6,2,3,2,1,2,14,2,196,60,67,8,0,1205,3,2,26,2,1,2,0,3,0,2,9,2,3,2,0,2,0,7,0,5,0,2,0,2,0,2,2,2,1,2,0,3,0,2,0,2,0,2,0,2,0,2,1,2,0,3,3,2,6,2,3,2,3,2,0,2,9,2,16,6,2,2,4,2,16,4421,42719,33,4153,7,221,3,5761,15,7472,16,621,2467,541,1507,4938,6,4191],r="‌‍·̀-ͯ·҃-֑҇-ׇֽֿׁׂׅׄؐ-ًؚ-٩ٰۖ-ۜ۟-۪ۤۧۨ-ۭ۰-۹ܑܰ-݊ަ-ް߀-߉߫-߽߳ࠖ-࠙ࠛ-ࠣࠥ-ࠧࠩ-࡙࠭-࡛ࢗ-࢟࣊-ࣣ࣡-ःऺ-़ा-ॏ॑-ॗॢॣ०-९ঁ-ঃ়া-ৄেৈো-্ৗৢৣ০-৯৾ਁ-ਃ਼ਾ-ੂੇੈੋ-੍ੑ੦-ੱੵઁ-ઃ઼ા-ૅે-ૉો-્ૢૣ૦-૯ૺ-૿ଁ-ଃ଼ା-ୄେୈୋ-୍୕-ୗୢୣ୦-୯ஂா-ூெ-ைொ-்ௗ௦-௯ఀ-ఄ఼ా-ౄె-ైొ-్ౕౖౢౣ౦-౯ಁ-ಃ಼ಾ-ೄೆ-ೈೊ-್ೕೖೢೣ೦-೯ೳഀ-ഃ഻഼ാ-ൄെ-ൈൊ-്ൗൢൣ൦-൯ඁ-ඃ්ා-ුූෘ-ෟ෦-෯ෲෳัิ-ฺ็-๎๐-๙ັິ-ຼ່-໎໐-໙༘༙༠-༩༹༵༷༾༿ཱ-྄྆྇ྍ-ྗྙ-ྼ࿆ါ-ှ၀-၉ၖ-ၙၞ-ၠၢ-ၤၧ-ၭၱ-ၴႂ-ႍႏ-ႝ፝-፟፩-፱ᜒ-᜕ᜲ-᜴ᝒᝓᝲᝳ឴-៓៝០-៩᠋-᠍᠏-᠙ᢩᤠ-ᤫᤰ-᤻᥆-᥏᧐-᧚ᨗ-ᨛᩕ-ᩞ᩠-᩿᩼-᪉᪐-᪙᪰-᪽ᪿ-ᫎᬀ-ᬄ᬴-᭄᭐-᭙᭫-᭳ᮀ-ᮂᮡ-ᮭ᮰-᮹᯦-᯳ᰤ-᰷᱀-᱉᱐-᱙᳐-᳔᳒-᳨᳭᳴᳷-᳹᷀-᷿‌‍‿⁀⁔⃐-⃥⃜⃡-⃰⳯-⵿⳱ⷠ-〪ⷿ-゙゚〯・꘠-꘩꙯ꙴ-꙽ꚞꚟ꛰꛱ꠂ꠆ꠋꠣ-ꠧ꠬ꢀꢁꢴ-ꣅ꣐-꣙꣠-꣱ꣿ-꤉ꤦ-꤭ꥇ-꥓ꦀ-ꦃ꦳-꧀꧐-꧙ꧥ꧰-꧹ꨩ-ꨶꩃꩌꩍ꩐-꩙ꩻ-ꩽꪰꪲ-ꪴꪷꪸꪾ꪿꫁ꫫ-ꫯꫵ꫶ꯣ-ꯪ꯬꯭꯰-꯹ﬞ︀-️︠-︯︳︴﹍-﹏０-９＿･",i="ªµºÀ-ÖØ-öø-ˁˆ-ˑˠ-ˤˬˮͰ-ʹͶͷͺ-ͽͿΆΈ-ΊΌΎ-ΡΣ-ϵϷ-ҁҊ-ԯԱ-Ֆՙՠ-ֈא-תׯ-ײؠ-يٮٯٱ-ۓەۥۦۮۯۺ-ۼۿܐܒ-ܯݍ-ޥޱߊ-ߪߴߵߺࠀ-ࠕࠚࠤࠨࡀ-ࡘࡠ-ࡪࡰ-ࢇࢉ-ࢎࢠ-ࣉऄ-हऽॐक़-ॡॱ-ঀঅ-ঌএঐও-নপ-রলশ-হঽৎড়ঢ়য়-ৡৰৱৼਅ-ਊਏਐਓ-ਨਪ-ਰਲਲ਼ਵਸ਼ਸਹਖ਼-ੜਫ਼ੲ-ੴઅ-ઍએ-ઑઓ-નપ-રલળવ-હઽૐૠૡૹଅ-ଌଏଐଓ-ନପ-ରଲଳଵ-ହଽଡ଼ଢ଼ୟ-ୡୱஃஅ-ஊஎ-ஐஒ-கஙசஜஞடணதந-பம-ஹௐఅ-ఌఎ-ఐఒ-నప-హఽౘ-ౚౝౠౡಀಅ-ಌಎ-ಐಒ-ನಪ-ಳವ-ಹಽೝೞೠೡೱೲഄ-ഌഎ-ഐഒ-ഺഽൎൔ-ൖൟ-ൡൺ-ൿඅ-ඖක-නඳ-රලව-ෆก-ะาำเ-ๆກຂຄຆ-ຊຌ-ຣລວ-ະາຳຽເ-ໄໆໜ-ໟༀཀ-ཇཉ-ཬྈ-ྌက-ဪဿၐ-ၕၚ-ၝၡၥၦၮ-ၰၵ-ႁႎႠ-ჅჇჍა-ჺჼ-ቈቊ-ቍቐ-ቖቘቚ-ቝበ-ኈኊ-ኍነ-ኰኲ-ኵኸ-ኾዀዂ-ዅወ-ዖዘ-ጐጒ-ጕጘ-ፚᎀ-ᎏᎠ-Ᏽᏸ-ᏽᐁ-ᙬᙯ-ᙿᚁ-ᚚᚠ-ᛪᛮ-ᛸᜀ-ᜑᜟ-ᜱᝀ-ᝑᝠ-ᝬᝮ-ᝰក-ឳៗៜᠠ-ᡸᢀ-ᢨᢪᢰ-ᣵᤀ-ᤞᥐ-ᥭᥰ-ᥴᦀ-ᦫᦰ-ᧉᨀ-ᨖᨠ-ᩔᪧᬅ-ᬳᭅ-ᭌᮃ-ᮠᮮᮯᮺ-ᯥᰀ-ᰣᱍ-ᱏᱚ-ᱽᲀ-ᲊᲐ-ᲺᲽ-Ჿᳩ-ᳬᳮ-ᳳᳵᳶᳺᴀ-ᶿḀ-ἕἘ-Ἕἠ-ὅὈ-Ὅὐ-ὗὙὛὝὟ-ώᾀ-ᾴᾶ-ᾼιῂ-ῄῆ-ῌῐ-ΐῖ-Ίῠ-Ῥῲ-ῴῶ-ῼⁱⁿₐ-ₜℂℇℊ-ℓℕ℘-ℝℤΩℨK-ℹℼ-ℿⅅ-ⅉⅎⅠ-ↈⰀ-ⳤⳫ-ⳮⳲⳳⴀ-ⴥⴧⴭⴰ-ⵧⵯⶀ-ⶖⶠ-ⶦⶨ-ⶮⶰ-ⶶⶸ-ⶾⷀ-ⷆⷈ-ⷎⷐ-ⷖⷘ-ⷞ々-〇〡-〩〱-〵〸-〼ぁ-ゖ゛-ゟァ-ヺー-ヿㄅ-ㄯㄱ-ㆎㆠ-ㆿㇰ-ㇿ㐀-䶿一-ꒌꓐ-ꓽꔀ-ꘌꘐ-ꘟꘪꘫꙀ-ꙮꙿ-ꚝꚠ-ꛯꜗ-ꜟꜢ-ꞈꞋ-ꟍꟐꟑꟓꟕ-Ƛꟲ-ꠁꠃ-ꠅꠇ-ꠊꠌ-ꠢꡀ-ꡳꢂ-ꢳꣲ-ꣷꣻꣽꣾꤊ-ꤥꤰ-ꥆꥠ-ꥼꦄ-ꦲꧏꧠ-ꧤꧦ-ꧯꧺ-ꧾꨀ-ꨨꩀ-ꩂꩄ-ꩋꩠ-ꩶꩺꩾ-ꪯꪱꪵꪶꪹ-ꪽꫀꫂꫛ-ꫝꫠ-ꫪꫲ-ꫴꬁ-ꬆꬉ-ꬎꬑ-ꬖꬠ-ꬦꬨ-ꬮꬰ-ꭚꭜ-ꭩꭰ-ꯢ가-힣ힰ-ퟆퟋ-ퟻ豈-舘並-龎ﬀ-ﬆﬓ-ﬗיִײַ-ﬨשׁ-זּטּ-לּמּנּסּףּפּצּ-ﮱﯓ-ﴽﵐ-ﶏﶒ-ﷇﷰ-ﷻﹰ-ﹴﹶ-ﻼＡ-Ｚａ-ｚｦ-ﾾￂ-ￇￊ-ￏￒ-ￗￚ-ￜ",s={3:"abstract boolean byte char class double enum export extends final float goto implements import int interface long native package private protected public short static super synchronized throws transient volatile",5:"class enum extends super const export import",6:"enum",strict:"implements interface let package private protected public static yield",strictBind:"eval arguments"},o="break case catch continue debugger default do else finally for function if return switch throw try var while with null true false instanceof typeof void delete new in this",a={5:o,"5module":o+" export import",6:o+" const class extends export import super"},c=/^in(stanceof)?$/,l=new RegExp("["+i+"]"),p=new RegExp("["+i+r+"]");function u(e,t){for(var n=65536,r=0;r<t.length;r+=2){if((n+=t[r])>e)return!1;if((n+=t[r+1])>=e)return!0}return!1}function h(e,t){return e<65?36===e:e<91||(e<97?95===e:e<123||(e<=65535?e>=170&&l.test(String.fromCharCode(e)):!1!==t&&u(e,n)))}function d(e,r){return e<48?36===e:e<58||!(e<65)&&(e<91||(e<97?95===e:e<123||(e<=65535?e>=170&&p.test(String.fromCharCode(e)):!1!==r&&(u(e,n)||u(e,t)))))}var f=function(e,t){void 0===t&&(t={}),this.label=e,this.keyword=t.keyword,this.beforeExpr=!!t.beforeExpr,this.startsExpr=!!t.startsExpr,this.isLoop=!!t.isLoop,this.isAssign=!!t.isAssign,this.prefix=!!t.prefix,this.postfix=!!t.postfix,this.binop=t.binop||null,this.updateContext=null};function m(e,t){return new f(e,{beforeExpr:!0,binop:t})}var g={beforeExpr:!0},v={startsExpr:!0},y={};function x(e,t){return void 0===t&&(t={}),t.keyword=e,y[e]=new f(e,t)}var E={num:new f("num",v),regexp:new f("regexp",v),string:new f("string",v),name:new f("name",v),privateId:new f("privateId",v),eof:new f("eof"),bracketL:new f("[",{beforeExpr:!0,startsExpr:!0}),bracketR:new f("]"),braceL:new f("{",{beforeExpr:!0,startsExpr:!0}),braceR:new f("}"),parenL:new f("(",{beforeExpr:!0,startsExpr:!0}),parenR:new f(")"),comma:new f(",",g),semi:new f(";",g),colon:new f(":",g),dot:new f("."),question:new f("?",g),questionDot:new f("?."),arrow:new f("=>",g),template:new f("template"),invalidTemplate:new f("invalidTemplate"),ellipsis:new f("...",g),backQuote:new f("`",v),dollarBraceL:new f("${",{beforeExpr:!0,startsExpr:!0}),eq:new f("=",{beforeExpr:!0,isAssign:!0}),assign:new f("_=",{beforeExpr:!0,isAssign:!0}),incDec:new f("++/--",{prefix:!0,postfix:!0,startsExpr:!0}),prefix:new f("!/~",{beforeExpr:!0,prefix:!0,startsExpr:!0}),logicalOR:m("||",1),logicalAND:m("&&",2),bitwiseOR:m("|",3),bitwiseXOR:m("^",4),bitwiseAND:m("&",5),equality:m("==/!=/===/!==",6),relational:m("</>/<=/>=",7),bitShift:m("<</>>/>>>",8),plusMin:new f("+/-",{beforeExpr:!0,binop:9,prefix:!0,startsExpr:!0}),modulo:m("%",10),star:m("*",10),slash:m("/",10),starstar:new f("**",{beforeExpr:!0}),coalesce:m("??",1),_break:x("break"),_case:x("case",g),_catch:x("catch"),_continue:x("continue"),_debugger:x("debugger"),_default:x("default",g),_do:x("do",{isLoop:!0,beforeExpr:!0}),_else:x("else",g),_finally:x("finally"),_for:x("for",{isLoop:!0}),_function:x("function",v),_if:x("if"),_return:x("return",g),_switch:x("switch"),_throw:x("throw",g),_try:x("try"),_var:x("var"),_const:x("const"),_while:x("while",{isLoop:!0}),_with:x("with"),_new:x("new",{beforeExpr:!0,startsExpr:!0}),_this:x("this",v),_super:x("super",v),_class:x("class",v),_extends:x("extends",g),_export:x("export"),_import:x("import",v),_null:x("null",v),_true:x("true",v),_false:x("false",v),_in:x("in",{beforeExpr:!0,binop:7}),_instanceof:x("instanceof",{beforeExpr:!0,binop:7}),_typeof:x("typeof",{beforeExpr:!0,prefix:!0,startsExpr:!0}),_void:x("void",{beforeExpr:!0,prefix:!0,startsExpr:!0}),_delete:x("delete",{beforeExpr:!0,prefix:!0,startsExpr:!0})},S=/\r\n?|\n|\u2028|\u2029/,w=new RegExp(S.source,"g");function b(e){return 10===e||13===e||8232===e||8233===e}function _(e,t,n){void 0===n&&(n=e.length);for(var r=t;r<n;r++){var i=e.charCodeAt(r);if(b(i))return r<n-1&&13===i&&10===e.charCodeAt(r+1)?r+2:r+1}return-1}var k=/[\u1680\u2000-\u200a\u202f\u205f\u3000\ufeff]/,C=/(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g,P=Object.prototype,A=P.hasOwnProperty,N=P.toString,I=Object.hasOwn||function(e,t){return A.call(e,t)},T=Array.isArray||function(e){return"[object Array]"===N.call(e)},R=Object.create(null);function O(e){return R[e]||(R[e]=new RegExp("^(?:"+e.replace(/ /g,"|")+")$"))}function L(e){return e<=65535?String.fromCharCode(e):(e-=65536,String.fromCharCode(55296+(e>>10),56320+(1023&e)))}var D=/(?:[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])/,j=function(e,t){this.line=e,this.column=t};j.prototype.offset=function(e){return new j(this.line,this.column+e)};var F=function(e,t,n){this.start=t,this.end=n,null!==e.sourceFile&&(this.source=e.sourceFile)};function M(e,t){for(var n=1,r=0;;){var i=_(e,r,t);if(i<0)return new j(n,t-r);++n,r=i}}var V={ecmaVersion:null,sourceType:"script",onInsertedSemicolon:null,onTrailingComma:null,allowReserved:null,allowReturnOutsideFunction:!1,allowImportExportEverywhere:!1,allowAwaitOutsideFunction:null,allowSuperOutsideMethod:null,allowHashBang:!1,checkPrivateFields:!0,locations:!1,onToken:null,onComment:null,ranges:!1,program:null,sourceFile:null,directSourceFile:null,preserveParens:!1},B=!1;function U(e){var t={};for(var n in V)t[n]=e&&I(e,n)?e[n]:V[n];if("latest"===t.ecmaVersion?t.ecmaVersion=1e8:null==t.ecmaVersion?(!B&&"object"==typeof console&&console.warn&&(B=!0,console.warn("Since Acorn 8.0.0, options.ecmaVersion is required.\nDefaulting to 2020, but this will stop working in the future.")),t.ecmaVersion=11):t.ecmaVersion>=2015&&(t.ecmaVersion-=2009),null==t.allowReserved&&(t.allowReserved=t.ecmaVersion<5),e&&null!=e.allowHashBang||(t.allowHashBang=t.ecmaVersion>=14),T(t.onToken)){var r=t.onToken;t.onToken=function(e){return r.push(e)}}return T(t.onComment)&&(t.onComment=H(t,t.onComment)),t}function H(e,t){return function(n,r,i,s,o,a){var c={type:n?"Block":"Line",value:r,start:i,end:s};e.locations&&(c.loc=new F(this,o,a)),e.ranges&&(c.range=[i,s]),t.push(c)}}var q=1,$=2,W=4,G=8,K=16,z=32,J=64,Y=128,Q=256,X=q|$|Q;function Z(e,t){return $|(e?W:0)|(t?G:0)}var ee=0,te=1,ne=2,re=3,ie=4,se=5,oe=function(e,t,n){this.options=e=U(e),this.sourceFile=e.sourceFile,this.keywords=O(a[e.ecmaVersion>=6?6:"module"===e.sourceType?"5module":5]);var r="";!0!==e.allowReserved&&(r=s[e.ecmaVersion>=6?6:5===e.ecmaVersion?5:3],"module"===e.sourceType&&(r+=" await")),this.reservedWords=O(r);var i=(r?r+" ":"")+s.strict;this.reservedWordsStrict=O(i),this.reservedWordsStrictBind=O(i+" "+s.strictBind),this.input=String(t),this.containsEsc=!1,n?(this.pos=n,this.lineStart=this.input.lastIndexOf("\n",n-1)+1,this.curLine=this.input.slice(0,this.lineStart).split(S).length):(this.pos=this.lineStart=0,this.curLine=1),this.type=E.eof,this.value=null,this.start=this.end=this.pos,this.startLoc=this.endLoc=this.curPosition(),this.lastTokEndLoc=this.lastTokStartLoc=null,this.lastTokStart=this.lastTokEnd=this.pos,this.context=this.initialContext(),this.exprAllowed=!0,this.inModule="module"===e.sourceType,this.strict=this.inModule||this.strictDirective(this.pos),this.potentialArrowAt=-1,this.potentialArrowInForAwait=!1,this.yieldPos=this.awaitPos=this.awaitIdentPos=0,this.labels=[],this.undefinedExports=Object.create(null),0===this.pos&&e.allowHashBang&&"#!"===this.input.slice(0,2)&&this.skipLineComment(2),this.scopeStack=[],this.enterScope(q),this.regexpState=null,this.privateNameStack=[]},ae={inFunction:{configurable:!0},inGenerator:{configurable:!0},inAsync:{configurable:!0},canAwait:{configurable:!0},allowSuper:{configurable:!0},allowDirectSuper:{configurable:!0},treatFunctionsAsVar:{configurable:!0},allowNewDotTarget:{configurable:!0},inClassStaticBlock:{configurable:!0}};oe.prototype.parse=function(){var e=this.options.program||this.startNode();return this.nextToken(),this.parseTopLevel(e)},ae.inFunction.get=function(){return(this.currentVarScope().flags&$)>0},ae.inGenerator.get=function(){return(this.currentVarScope().flags&G)>0&&!this.currentVarScope().inClassFieldInit},ae.inAsync.get=function(){return(this.currentVarScope().flags&W)>0&&!this.currentVarScope().inClassFieldInit},ae.canAwait.get=function(){for(var e=this.scopeStack.length-1;e>=0;e--){var t=this.scopeStack[e];if(t.inClassFieldInit||t.flags&Q)return!1;if(t.flags&$)return(t.flags&W)>0}return this.inModule&&this.options.ecmaVersion>=13||this.options.allowAwaitOutsideFunction},ae.allowSuper.get=function(){var e=this.currentThisScope(),t=e.flags,n=e.inClassFieldInit;return(t&J)>0||n||this.options.allowSuperOutsideMethod},ae.allowDirectSuper.get=function(){return(this.currentThisScope().flags&Y)>0},ae.treatFunctionsAsVar.get=function(){return this.treatFunctionsAsVarInScope(this.currentScope())},ae.allowNewDotTarget.get=function(){var e=this.currentThisScope(),t=e.flags,n=e.inClassFieldInit;return(t&($|Q))>0||n},ae.inClassStaticBlock.get=function(){return(this.currentVarScope().flags&Q)>0},oe.extend=function(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];for(var n=this,r=0;r<e.length;r++)n=e[r](n);return n},oe.parse=function(e,t){return new this(t,e).parse()},oe.parseExpressionAt=function(e,t,n){var r=new this(n,e,t);return r.nextToken(),r.parseExpression()},oe.tokenizer=function(e,t){return new this(t,e)},Object.defineProperties(oe.prototype,ae);var ce=oe.prototype,le=/^(?:'((?:\\[^]|[^'\\])*?)'|"((?:\\[^]|[^"\\])*?)")/;ce.strictDirective=function(e){if(this.options.ecmaVersion<5)return!1;for(;;){C.lastIndex=e,e+=C.exec(this.input)[0].length;var t=le.exec(this.input.slice(e));if(!t)return!1;if("use strict"===(t[1]||t[2])){C.lastIndex=e+t[0].length;var n=C.exec(this.input),r=n.index+n[0].length,i=this.input.charAt(r);return";"===i||"}"===i||S.test(n[0])&&!(/[(`.[+\-/*%<>=,?^&]/.test(i)||"!"===i&&"="===this.input.charAt(r+1))}e+=t[0].length,C.lastIndex=e,e+=C.exec(this.input)[0].length,";"===this.input[e]&&e++}},ce.eat=function(e){return this.type===e&&(this.next(),!0)},ce.isContextual=function(e){return this.type===E.name&&this.value===e&&!this.containsEsc},ce.eatContextual=function(e){return!!this.isContextual(e)&&(this.next(),!0)},ce.expectContextual=function(e){this.eatContextual(e)||this.unexpected()},ce.canInsertSemicolon=function(){return this.type===E.eof||this.type===E.braceR||S.test(this.input.slice(this.lastTokEnd,this.start))},ce.insertSemicolon=function(){if(this.canInsertSemicolon())return this.options.onInsertedSemicolon&&this.options.onInsertedSemicolon(this.lastTokEnd,this.lastTokEndLoc),!0},ce.semicolon=function(){this.eat(E.semi)||this.insertSemicolon()||this.unexpected()},ce.afterTrailingComma=function(e,t){if(this.type===e)return this.options.onTrailingComma&&this.options.onTrailingComma(this.lastTokStart,this.lastTokStartLoc),t||this.next(),!0},ce.expect=function(e){this.eat(e)||this.unexpected()},ce.unexpected=function(e){this.raise(null!=e?e:this.start,"Unexpected token")};var pe=function(){this.shorthandAssign=this.trailingComma=this.parenthesizedAssign=this.parenthesizedBind=this.doubleProto=-1};ce.checkPatternErrors=function(e,t){if(e){e.trailingComma>-1&&this.raiseRecoverable(e.trailingComma,"Comma is not permitted after the rest element");var n=t?e.parenthesizedAssign:e.parenthesizedBind;n>-1&&this.raiseRecoverable(n,t?"Assigning to rvalue":"Parenthesized pattern")}},ce.checkExpressionErrors=function(e,t){if(!e)return!1;var n=e.shorthandAssign,r=e.doubleProto;if(!t)return n>=0||r>=0;n>=0&&this.raise(n,"Shorthand property assignments are valid only in destructuring patterns"),r>=0&&this.raiseRecoverable(r,"Redefinition of __proto__ property")},ce.checkYieldAwaitInDefaultParams=function(){this.yieldPos&&(!this.awaitPos||this.yieldPos<this.awaitPos)&&this.raise(this.yieldPos,"Yield expression cannot be a default value"),this.awaitPos&&this.raise(this.awaitPos,"Await expression cannot be a default value")},ce.isSimpleAssignTarget=function(e){return"ParenthesizedExpression"===e.type?this.isSimpleAssignTarget(e.expression):"Identifier"===e.type||"MemberExpression"===e.type};var ue=oe.prototype;ue.parseTopLevel=function(e){var t=Object.create(null);for(e.body||(e.body=[]);this.type!==E.eof;){var n=this.parseStatement(null,!0,t);e.body.push(n)}if(this.inModule)for(var r=0,i=Object.keys(this.undefinedExports);r<i.length;r+=1){var s=i[r];this.raiseRecoverable(this.undefinedExports[s].start,"Export '"+s+"' is not defined")}return this.adaptDirectivePrologue(e.body),this.next(),e.sourceType=this.options.sourceType,this.finishNode(e,"Program")};var he={kind:"loop"},de={kind:"switch"};ue.isLet=function(e){if(this.options.ecmaVersion<6||!this.isContextual("let"))return!1;C.lastIndex=this.pos;var t=C.exec(this.input),n=this.pos+t[0].length,r=this.input.charCodeAt(n);if(91===r||92===r)return!0;if(e)return!1;if(123===r||r>55295&&r<56320)return!0;if(h(r,!0)){for(var i=n+1;d(r=this.input.charCodeAt(i),!0);)++i;if(92===r||r>55295&&r<56320)return!0;var s=this.input.slice(n,i);if(!c.test(s))return!0}return!1},ue.isAsyncFunction=function(){if(this.options.ecmaVersion<8||!this.isContextual("async"))return!1;C.lastIndex=this.pos;var e,t=C.exec(this.input),n=this.pos+t[0].length;return!(S.test(this.input.slice(this.pos,n))||"function"!==this.input.slice(n,n+8)||n+8!==this.input.length&&(d(e=this.input.charCodeAt(n+8))||e>55295&&e<56320))},ue.parseStatement=function(e,t,n){var r,i=this.type,s=this.startNode();switch(this.isLet(e)&&(i=E._var,r="let"),i){case E._break:case E._continue:return this.parseBreakContinueStatement(s,i.keyword);case E._debugger:return this.parseDebuggerStatement(s);case E._do:return this.parseDoStatement(s);case E._for:return this.parseForStatement(s);case E._function:return e&&(this.strict||"if"!==e&&"label"!==e)&&this.options.ecmaVersion>=6&&this.unexpected(),this.parseFunctionStatement(s,!1,!e);case E._class:return e&&this.unexpected(),this.parseClass(s,!0);case E._if:return this.parseIfStatement(s);case E._return:return this.parseReturnStatement(s);case E._switch:return this.parseSwitchStatement(s);case E._throw:return this.parseThrowStatement(s);case E._try:return this.parseTryStatement(s);case E._const:case E._var:return r=r||this.value,e&&"var"!==r&&this.unexpected(),this.parseVarStatement(s,r);case E._while:return this.parseWhileStatement(s);case E._with:return this.parseWithStatement(s);case E.braceL:return this.parseBlock(!0,s);case E.semi:return this.parseEmptyStatement(s);case E._export:case E._import:if(this.options.ecmaVersion>10&&i===E._import){C.lastIndex=this.pos;var o=C.exec(this.input),a=this.pos+o[0].length,c=this.input.charCodeAt(a);if(40===c||46===c)return this.parseExpressionStatement(s,this.parseExpression())}return this.options.allowImportExportEverywhere||(t||this.raise(this.start,"'import' and 'export' may only appear at the top level"),this.inModule||this.raise(this.start,"'import' and 'export' may appear only with 'sourceType: module'")),i===E._import?this.parseImport(s):this.parseExport(s,n);default:if(this.isAsyncFunction())return e&&this.unexpected(),this.next(),this.parseFunctionStatement(s,!0,!e);var l=this.value,p=this.parseExpression();return i===E.name&&"Identifier"===p.type&&this.eat(E.colon)?this.parseLabeledStatement(s,l,p,e):this.parseExpressionStatement(s,p)}},ue.parseBreakContinueStatement=function(e,t){var n="break"===t;this.next(),this.eat(E.semi)||this.insertSemicolon()?e.label=null:this.type!==E.name?this.unexpected():(e.label=this.parseIdent(),this.semicolon());for(var r=0;r<this.labels.length;++r){var i=this.labels[r];if(null==e.label||i.name===e.label.name){if(null!=i.kind&&(n||"loop"===i.kind))break;if(e.label&&n)break}}return r===this.labels.length&&this.raise(e.start,"Unsyntactic "+t),this.finishNode(e,n?"BreakStatement":"ContinueStatement")},ue.parseDebuggerStatement=function(e){return this.next(),this.semicolon(),this.finishNode(e,"DebuggerStatement")},ue.parseDoStatement=function(e){return this.next(),this.labels.push(he),e.body=this.parseStatement("do"),this.labels.pop(),this.expect(E._while),e.test=this.parseParenExpression(),this.options.ecmaVersion>=6?this.eat(E.semi):this.semicolon(),this.finishNode(e,"DoWhileStatement")},ue.parseForStatement=function(e){this.next();var t=this.options.ecmaVersion>=9&&this.canAwait&&this.eatContextual("await")?this.lastTokStart:-1;if(this.labels.push(he),this.enterScope(0),this.expect(E.parenL),this.type===E.semi)return t>-1&&this.unexpected(t),this.parseFor(e,null);var n=this.isLet();if(this.type===E._var||this.type===E._const||n){var r=this.startNode(),i=n?"let":this.value;return this.next(),this.parseVar(r,!0,i),this.finishNode(r,"VariableDeclaration"),(this.type===E._in||this.options.ecmaVersion>=6&&this.isContextual("of"))&&1===r.declarations.length?(this.options.ecmaVersion>=9&&(this.type===E._in?t>-1&&this.unexpected(t):e.await=t>-1),this.parseForIn(e,r)):(t>-1&&this.unexpected(t),this.parseFor(e,r))}var s=this.isContextual("let"),o=!1,a=this.containsEsc,c=new pe,l=this.start,p=t>-1?this.parseExprSubscripts(c,"await"):this.parseExpression(!0,c);return this.type===E._in||(o=this.options.ecmaVersion>=6&&this.isContextual("of"))?(t>-1?(this.type===E._in&&this.unexpected(t),e.await=!0):o&&this.options.ecmaVersion>=8&&(p.start!==l||a||"Identifier"!==p.type||"async"!==p.name?this.options.ecmaVersion>=9&&(e.await=!1):this.unexpected()),s&&o&&this.raise(p.start,"The left-hand side of a for-of loop may not start with 'let'."),this.toAssignable(p,!1,c),this.checkLValPattern(p),this.parseForIn(e,p)):(this.checkExpressionErrors(c,!0),t>-1&&this.unexpected(t),this.parseFor(e,p))},ue.parseFunctionStatement=function(e,t,n){return this.next(),this.parseFunction(e,me|(n?0:ge),!1,t)},ue.parseIfStatement=function(e){return this.next(),e.test=this.parseParenExpression(),e.consequent=this.parseStatement("if"),e.alternate=this.eat(E._else)?this.parseStatement("if"):null,this.finishNode(e,"IfStatement")},ue.parseReturnStatement=function(e){return this.inFunction||this.options.allowReturnOutsideFunction||this.raise(this.start,"'return' outside of function"),this.next(),this.eat(E.semi)||this.insertSemicolon()?e.argument=null:(e.argument=this.parseExpression(),this.semicolon()),this.finishNode(e,"ReturnStatement")},ue.parseSwitchStatement=function(e){var t;this.next(),e.discriminant=this.parseParenExpression(),e.cases=[],this.expect(E.braceL),this.labels.push(de),this.enterScope(0);for(var n=!1;this.type!==E.braceR;)if(this.type===E._case||this.type===E._default){var r=this.type===E._case;t&&this.finishNode(t,"SwitchCase"),e.cases.push(t=this.startNode()),t.consequent=[],this.next(),r?t.test=this.parseExpression():(n&&this.raiseRecoverable(this.lastTokStart,"Multiple default clauses"),n=!0,t.test=null),this.expect(E.colon)}else t||this.unexpected(),t.consequent.push(this.parseStatement(null));return this.exitScope(),t&&this.finishNode(t,"SwitchCase"),this.next(),this.labels.pop(),this.finishNode(e,"SwitchStatement")},ue.parseThrowStatement=function(e){return this.next(),S.test(this.input.slice(this.lastTokEnd,this.start))&&this.raise(this.lastTokEnd,"Illegal newline after throw"),e.argument=this.parseExpression(),this.semicolon(),this.finishNode(e,"ThrowStatement")};var fe=[];ue.parseCatchClauseParam=function(){var e=this.parseBindingAtom(),t="Identifier"===e.type;return this.enterScope(t?z:0),this.checkLValPattern(e,t?ie:ne),this.expect(E.parenR),e},ue.parseTryStatement=function(e){if(this.next(),e.block=this.parseBlock(),e.handler=null,this.type===E._catch){var t=this.startNode();this.next(),this.eat(E.parenL)?t.param=this.parseCatchClauseParam():(this.options.ecmaVersion<10&&this.unexpected(),t.param=null,this.enterScope(0)),t.body=this.parseBlock(!1),this.exitScope(),e.handler=this.finishNode(t,"CatchClause")}return e.finalizer=this.eat(E._finally)?this.parseBlock():null,e.handler||e.finalizer||this.raise(e.start,"Missing catch or finally clause"),this.finishNode(e,"TryStatement")},ue.parseVarStatement=function(e,t,n){return this.next(),this.parseVar(e,!1,t,n),this.semicolon(),this.finishNode(e,"VariableDeclaration")},ue.parseWhileStatement=function(e){return this.next(),e.test=this.parseParenExpression(),this.labels.push(he),e.body=this.parseStatement("while"),this.labels.pop(),this.finishNode(e,"WhileStatement")},ue.parseWithStatement=function(e){return this.strict&&this.raise(this.start,"'with' in strict mode"),this.next(),e.object=this.parseParenExpression(),e.body=this.parseStatement("with"),this.finishNode(e,"WithStatement")},ue.parseEmptyStatement=function(e){return this.next(),this.finishNode(e,"EmptyStatement")},ue.parseLabeledStatement=function(e,t,n,r){for(var i=0,s=this.labels;i<s.length;i+=1)s[i].name===t&&this.raise(n.start,"Label '"+t+"' is already declared");for(var o=this.type.isLoop?"loop":this.type===E._switch?"switch":null,a=this.labels.length-1;a>=0;a--){var c=this.labels[a];if(c.statementStart!==e.start)break;c.statementStart=this.start,c.kind=o}return this.labels.push({name:t,kind:o,statementStart:this.start}),e.body=this.parseStatement(r?-1===r.indexOf("label")?r+"label":r:"label"),this.labels.pop(),e.label=n,this.finishNode(e,"LabeledStatement")},ue.parseExpressionStatement=function(e,t){return e.expression=t,this.semicolon(),this.finishNode(e,"ExpressionStatement")},ue.parseBlock=function(e,t,n){for(void 0===e&&(e=!0),void 0===t&&(t=this.startNode()),t.body=[],this.expect(E.braceL),e&&this.enterScope(0);this.type!==E.braceR;){var r=this.parseStatement(null);t.body.push(r)}return n&&(this.strict=!1),this.next(),e&&this.exitScope(),this.finishNode(t,"BlockStatement")},ue.parseFor=function(e,t){return e.init=t,this.expect(E.semi),e.test=this.type===E.semi?null:this.parseExpression(),this.expect(E.semi),e.update=this.type===E.parenR?null:this.parseExpression(),this.expect(E.parenR),e.body=this.parseStatement("for"),this.exitScope(),this.labels.pop(),this.finishNode(e,"ForStatement")},ue.parseForIn=function(e,t){var n=this.type===E._in;return this.next(),"VariableDeclaration"===t.type&&null!=t.declarations[0].init&&(!n||this.options.ecmaVersion<8||this.strict||"var"!==t.kind||"Identifier"!==t.declarations[0].id.type)&&this.raise(t.start,(n?"for-in":"for-of")+" loop variable declaration may not have an initializer"),e.left=t,e.right=n?this.parseExpression():this.parseMaybeAssign(),this.expect(E.parenR),e.body=this.parseStatement("for"),this.exitScope(),this.labels.pop(),this.finishNode(e,n?"ForInStatement":"ForOfStatement")},ue.parseVar=function(e,t,n,r){for(e.declarations=[],e.kind=n;;){var i=this.startNode();if(this.parseVarId(i,n),this.eat(E.eq)?i.init=this.parseMaybeAssign(t):r||"const"!==n||this.type===E._in||this.options.ecmaVersion>=6&&this.isContextual("of")?r||"Identifier"===i.id.type||t&&(this.type===E._in||this.isContextual("of"))?i.init=null:this.raise(this.lastTokEnd,"Complex binding patterns require an initialization value"):this.unexpected(),e.declarations.push(this.finishNode(i,"VariableDeclarator")),!this.eat(E.comma))break}return e},ue.parseVarId=function(e,t){e.id=this.parseBindingAtom(),this.checkLValPattern(e.id,"var"===t?te:ne,!1)};var me=1,ge=2,ve=4;function ye(e,t){var n=t.key.name,r=e[n],i="true";return"MethodDefinition"!==t.type||"get"!==t.kind&&"set"!==t.kind||(i=(t.static?"s":"i")+t.kind),"iget"===r&&"iset"===i||"iset"===r&&"iget"===i||"sget"===r&&"sset"===i||"sset"===r&&"sget"===i?(e[n]="true",!1):!!r||(e[n]=i,!1)}function xe(e,t){var n=e.computed,r=e.key;return!n&&("Identifier"===r.type&&r.name===t||"Literal"===r.type&&r.value===t)}ue.parseFunction=function(e,t,n,r,i){this.initFunction(e),(this.options.ecmaVersion>=9||this.options.ecmaVersion>=6&&!r)&&(this.type===E.star&&t&ge&&this.unexpected(),e.generator=this.eat(E.star)),this.options.ecmaVersion>=8&&(e.async=!!r),t&me&&(e.id=t&ve&&this.type!==E.name?null:this.parseIdent(),!e.id||t&ge||this.checkLValSimple(e.id,this.strict||e.generator||e.async?this.treatFunctionsAsVar?te:ne:re));var s=this.yieldPos,o=this.awaitPos,a=this.awaitIdentPos;return this.yieldPos=0,this.awaitPos=0,this.awaitIdentPos=0,this.enterScope(Z(e.async,e.generator)),t&me||(e.id=this.type===E.name?this.parseIdent():null),this.parseFunctionParams(e),this.parseFunctionBody(e,n,!1,i),this.yieldPos=s,this.awaitPos=o,this.awaitIdentPos=a,this.finishNode(e,t&me?"FunctionDeclaration":"FunctionExpression")},ue.parseFunctionParams=function(e){this.expect(E.parenL),e.params=this.parseBindingList(E.parenR,!1,this.options.ecmaVersion>=8),this.checkYieldAwaitInDefaultParams()},ue.parseClass=function(e,t){this.next();var n=this.strict;this.strict=!0,this.parseClassId(e,t),this.parseClassSuper(e);var r=this.enterClassBody(),i=this.startNode(),s=!1;for(i.body=[],this.expect(E.braceL);this.type!==E.braceR;){var o=this.parseClassElement(null!==e.superClass);o&&(i.body.push(o),"MethodDefinition"===o.type&&"constructor"===o.kind?(s&&this.raiseRecoverable(o.start,"Duplicate constructor in the same class"),s=!0):o.key&&"PrivateIdentifier"===o.key.type&&ye(r,o)&&this.raiseRecoverable(o.key.start,"Identifier '#"+o.key.name+"' has already been declared"))}return this.strict=n,this.next(),e.body=this.finishNode(i,"ClassBody"),this.exitClassBody(),this.finishNode(e,t?"ClassDeclaration":"ClassExpression")},ue.parseClassElement=function(e){if(this.eat(E.semi))return null;var t=this.options.ecmaVersion,n=this.startNode(),r="",i=!1,s=!1,o="method",a=!1;if(this.eatContextual("static")){if(t>=13&&this.eat(E.braceL))return this.parseClassStaticBlock(n),n;this.isClassElementNameStart()||this.type===E.star?a=!0:r="static"}if(n.static=a,!r&&t>=8&&this.eatContextual("async")&&(!this.isClassElementNameStart()&&this.type!==E.star||this.canInsertSemicolon()?r="async":s=!0),!r&&(t>=9||!s)&&this.eat(E.star)&&(i=!0),!r&&!s&&!i){var c=this.value;(this.eatContextual("get")||this.eatContextual("set"))&&(this.isClassElementNameStart()?o=c:r=c)}if(r?(n.computed=!1,n.key=this.startNodeAt(this.lastTokStart,this.lastTokStartLoc),n.key.name=r,this.finishNode(n.key,"Identifier")):this.parseClassElementName(n),t<13||this.type===E.parenL||"method"!==o||i||s){var l=!n.static&&xe(n,"constructor"),p=l&&e;l&&"method"!==o&&this.raise(n.key.start,"Constructor can't have get/set modifier"),n.kind=l?"constructor":o,this.parseClassMethod(n,i,s,p)}else this.parseClassField(n);return n},ue.isClassElementNameStart=function(){return this.type===E.name||this.type===E.privateId||this.type===E.num||this.type===E.string||this.type===E.bracketL||this.type.keyword},ue.parseClassElementName=function(e){this.type===E.privateId?("constructor"===this.value&&this.raise(this.start,"Classes can't have an element named '#constructor'"),e.computed=!1,e.key=this.parsePrivateIdent()):this.parsePropertyName(e)},ue.parseClassMethod=function(e,t,n,r){var i=e.key;"constructor"===e.kind?(t&&this.raise(i.start,"Constructor can't be a generator"),n&&this.raise(i.start,"Constructor can't be an async method")):e.static&&xe(e,"prototype")&&this.raise(i.start,"Classes may not have a static property named prototype");var s=e.value=this.parseMethod(t,n,r);return"get"===e.kind&&0!==s.params.length&&this.raiseRecoverable(s.start,"getter should have no params"),"set"===e.kind&&1!==s.params.length&&this.raiseRecoverable(s.start,"setter should have exactly one param"),"set"===e.kind&&"RestElement"===s.params[0].type&&this.raiseRecoverable(s.params[0].start,"Setter cannot use rest params"),this.finishNode(e,"MethodDefinition")},ue.parseClassField=function(e){if(xe(e,"constructor")?this.raise(e.key.start,"Classes can't have a field named 'constructor'"):e.static&&xe(e,"prototype")&&this.raise(e.key.start,"Classes can't have a static field named 'prototype'"),this.eat(E.eq)){var t=this.currentThisScope(),n=t.inClassFieldInit;t.inClassFieldInit=!0,e.value=this.parseMaybeAssign(),t.inClassFieldInit=n}else e.value=null;return this.semicolon(),this.finishNode(e,"PropertyDefinition")},ue.parseClassStaticBlock=function(e){e.body=[];var t=this.labels;for(this.labels=[],this.enterScope(Q|J);this.type!==E.braceR;){var n=this.parseStatement(null);e.body.push(n)}return this.next(),this.exitScope(),this.labels=t,this.finishNode(e,"StaticBlock")},ue.parseClassId=function(e,t){this.type===E.name?(e.id=this.parseIdent(),t&&this.checkLValSimple(e.id,ne,!1)):(!0===t&&this.unexpected(),e.id=null)},ue.parseClassSuper=function(e){e.superClass=this.eat(E._extends)?this.parseExprSubscripts(null,!1):null},ue.enterClassBody=function(){var e={declared:Object.create(null),used:[]};return this.privateNameStack.push(e),e.declared},ue.exitClassBody=function(){var e=this.privateNameStack.pop(),t=e.declared,n=e.used;if(this.options.checkPrivateFields)for(var r=this.privateNameStack.length,i=0===r?null:this.privateNameStack[r-1],s=0;s<n.length;++s){var o=n[s];I(t,o.name)||(i?i.used.push(o):this.raiseRecoverable(o.start,"Private field '#"+o.name+"' must be declared in an enclosing class"))}},ue.parseExportAllDeclaration=function(e,t){return this.options.ecmaVersion>=11&&(this.eatContextual("as")?(e.exported=this.parseModuleExportName(),this.checkExport(t,e.exported,this.lastTokStart)):e.exported=null),this.expectContextual("from"),this.type!==E.string&&this.unexpected(),e.source=this.parseExprAtom(),this.options.ecmaVersion>=16&&(e.attributes=this.parseWithClause()),this.semicolon(),this.finishNode(e,"ExportAllDeclaration")},ue.parseExport=function(e,t){if(this.next(),this.eat(E.star))return this.parseExportAllDeclaration(e,t);if(this.eat(E._default))return this.checkExport(t,"default",this.lastTokStart),e.declaration=this.parseExportDefaultDeclaration(),this.finishNode(e,"ExportDefaultDeclaration");if(this.shouldParseExportStatement())e.declaration=this.parseExportDeclaration(e),"VariableDeclaration"===e.declaration.type?this.checkVariableExport(t,e.declaration.declarations):this.checkExport(t,e.declaration.id,e.declaration.id.start),e.specifiers=[],e.source=null;else{if(e.declaration=null,e.specifiers=this.parseExportSpecifiers(t),this.eatContextual("from"))this.type!==E.string&&this.unexpected(),e.source=this.parseExprAtom(),this.options.ecmaVersion>=16&&(e.attributes=this.parseWithClause());else{for(var n=0,r=e.specifiers;n<r.length;n+=1){var i=r[n];this.checkUnreserved(i.local),this.checkLocalExport(i.local),"Literal"===i.local.type&&this.raise(i.local.start,"A string literal cannot be used as an exported binding without `from`.")}e.source=null}this.semicolon()}return this.finishNode(e,"ExportNamedDeclaration")},ue.parseExportDeclaration=function(e){return this.parseStatement(null)},ue.parseExportDefaultDeclaration=function(){var e;if(this.type===E._function||(e=this.isAsyncFunction())){var t=this.startNode();return this.next(),e&&this.next(),this.parseFunction(t,me|ve,!1,e)}if(this.type===E._class){var n=this.startNode();return this.parseClass(n,"nullableID")}var r=this.parseMaybeAssign();return this.semicolon(),r},ue.checkExport=function(e,t,n){e&&("string"!=typeof t&&(t="Identifier"===t.type?t.name:t.value),I(e,t)&&this.raiseRecoverable(n,"Duplicate export '"+t+"'"),e[t]=!0)},ue.checkPatternExport=function(e,t){var n=t.type;if("Identifier"===n)this.checkExport(e,t,t.start);else if("ObjectPattern"===n)for(var r=0,i=t.properties;r<i.length;r+=1){var s=i[r];this.checkPatternExport(e,s)}else if("ArrayPattern"===n)for(var o=0,a=t.elements;o<a.length;o+=1){var c=a[o];c&&this.checkPatternExport(e,c)}else"Property"===n?this.checkPatternExport(e,t.value):"AssignmentPattern"===n?this.checkPatternExport(e,t.left):"RestElement"===n&&this.checkPatternExport(e,t.argument)},ue.checkVariableExport=function(e,t){if(e)for(var n=0,r=t;n<r.length;n+=1){var i=r[n];this.checkPatternExport(e,i.id)}},ue.shouldParseExportStatement=function(){return"var"===this.type.keyword||"const"===this.type.keyword||"class"===this.type.keyword||"function"===this.type.keyword||this.isLet()||this.isAsyncFunction()},ue.parseExportSpecifier=function(e){var t=this.startNode();return t.local=this.parseModuleExportName(),t.exported=this.eatContextual("as")?this.parseModuleExportName():t.local,this.checkExport(e,t.exported,t.exported.start),this.finishNode(t,"ExportSpecifier")},ue.parseExportSpecifiers=function(e){var t=[],n=!0;for(this.expect(E.braceL);!this.eat(E.braceR);){if(n)n=!1;else if(this.expect(E.comma),this.afterTrailingComma(E.braceR))break;t.push(this.parseExportSpecifier(e))}return t},ue.parseImport=function(e){return this.next(),this.type===E.string?(e.specifiers=fe,e.source=this.parseExprAtom()):(e.specifiers=this.parseImportSpecifiers(),this.expectContextual("from"),e.source=this.type===E.string?this.parseExprAtom():this.unexpected()),this.options.ecmaVersion>=16&&(e.attributes=this.parseWithClause()),this.semicolon(),this.finishNode(e,"ImportDeclaration")},ue.parseImportSpecifier=function(){var e=this.startNode();return e.imported=this.parseModuleExportName(),this.eatContextual("as")?e.local=this.parseIdent():(this.checkUnreserved(e.imported),e.local=e.imported),this.checkLValSimple(e.local,ne),this.finishNode(e,"ImportSpecifier")},ue.parseImportDefaultSpecifier=function(){var e=this.startNode();return e.local=this.parseIdent(),this.checkLValSimple(e.local,ne),this.finishNode(e,"ImportDefaultSpecifier")},ue.parseImportNamespaceSpecifier=function(){var e=this.startNode();return this.next(),this.expectContextual("as"),e.local=this.parseIdent(),this.checkLValSimple(e.local,ne),this.finishNode(e,"ImportNamespaceSpecifier")},ue.parseImportSpecifiers=function(){var e=[],t=!0;if(this.type===E.name&&(e.push(this.parseImportDefaultSpecifier()),!this.eat(E.comma)))return e;if(this.type===E.star)return e.push(this.parseImportNamespaceSpecifier()),e;for(this.expect(E.braceL);!this.eat(E.braceR);){if(t)t=!1;else if(this.expect(E.comma),this.afterTrailingComma(E.braceR))break;e.push(this.parseImportSpecifier())}return e},ue.parseWithClause=function(){var e=[];if(!this.eat(E._with))return e;this.expect(E.braceL);for(var t={},n=!0;!this.eat(E.braceR);){if(n)n=!1;else if(this.expect(E.comma),this.afterTrailingComma(E.braceR))break;var r=this.parseImportAttribute(),i="Identifier"===r.key.type?r.key.name:r.key.value;I(t,i)&&this.raiseRecoverable(r.key.start,"Duplicate attribute key '"+i+"'"),t[i]=!0,e.push(r)}return e},ue.parseImportAttribute=function(){var e=this.startNode();return e.key=this.type===E.string?this.parseExprAtom():this.parseIdent("never"!==this.options.allowReserved),this.expect(E.colon),this.type!==E.string&&this.unexpected(),e.value=this.parseExprAtom(),this.finishNode(e,"ImportAttribute")},ue.parseModuleExportName=function(){if(this.options.ecmaVersion>=13&&this.type===E.string){var e=this.parseLiteral(this.value);return D.test(e.value)&&this.raise(e.start,"An export name cannot include a lone surrogate."),e}return this.parseIdent(!0)},ue.adaptDirectivePrologue=function(e){for(var t=0;t<e.length&&this.isDirectiveCandidate(e[t]);++t)e[t].directive=e[t].expression.raw.slice(1,-1)},ue.isDirectiveCandidate=function(e){return this.options.ecmaVersion>=5&&"ExpressionStatement"===e.type&&"Literal"===e.expression.type&&"string"==typeof e.expression.value&&('"'===this.input[e.start]||"'"===this.input[e.start])};var Ee=oe.prototype;Ee.toAssignable=function(e,t,n){if(this.options.ecmaVersion>=6&&e)switch(e.type){case"Identifier":this.inAsync&&"await"===e.name&&this.raise(e.start,"Cannot use 'await' as identifier inside an async function");break;case"ObjectPattern":case"ArrayPattern":case"AssignmentPattern":case"RestElement":break;case"ObjectExpression":e.type="ObjectPattern",n&&this.checkPatternErrors(n,!0);for(var r=0,i=e.properties;r<i.length;r+=1){var s=i[r];this.toAssignable(s,t),"RestElement"!==s.type||"ArrayPattern"!==s.argument.type&&"ObjectPattern"!==s.argument.type||this.raise(s.argument.start,"Unexpected token")}break;case"Property":"init"!==e.kind&&this.raise(e.key.start,"Object pattern can't contain getter or setter"),this.toAssignable(e.value,t);break;case"ArrayExpression":e.type="ArrayPattern",n&&this.checkPatternErrors(n,!0),this.toAssignableList(e.elements,t);break;case"SpreadElement":e.type="RestElement",this.toAssignable(e.argument,t),"AssignmentPattern"===e.argument.type&&this.raise(e.argument.start,"Rest elements cannot have a default value");break;case"AssignmentExpression":"="!==e.operator&&this.raise(e.left.end,"Only '=' operator can be used for specifying default value."),e.type="AssignmentPattern",delete e.operator,this.toAssignable(e.left,t);break;case"ParenthesizedExpression":this.toAssignable(e.expression,t,n);break;case"ChainExpression":this.raiseRecoverable(e.start,"Optional chaining cannot appear in left-hand side");break;case"MemberExpression":if(!t)break;default:this.raise(e.start,"Assigning to rvalue")}else n&&this.checkPatternErrors(n,!0);return e},Ee.toAssignableList=function(e,t){for(var n=e.length,r=0;r<n;r++){var i=e[r];i&&this.toAssignable(i,t)}if(n){var s=e[n-1];6===this.options.ecmaVersion&&t&&s&&"RestElement"===s.type&&"Identifier"!==s.argument.type&&this.unexpected(s.argument.start)}return e},Ee.parseSpread=function(e){var t=this.startNode();return this.next(),t.argument=this.parseMaybeAssign(!1,e),this.finishNode(t,"SpreadElement")},Ee.parseRestBinding=function(){var e=this.startNode();return this.next(),6===this.options.ecmaVersion&&this.type!==E.name&&this.unexpected(),e.argument=this.parseBindingAtom(),this.finishNode(e,"RestElement")},Ee.parseBindingAtom=function(){if(this.options.ecmaVersion>=6)switch(this.type){case E.bracketL:var e=this.startNode();return this.next(),e.elements=this.parseBindingList(E.bracketR,!0,!0),this.finishNode(e,"ArrayPattern");case E.braceL:return this.parseObj(!0)}return this.parseIdent()},Ee.parseBindingList=function(e,t,n,r){for(var i=[],s=!0;!this.eat(e);)if(s?s=!1:this.expect(E.comma),t&&this.type===E.comma)i.push(null);else{if(n&&this.afterTrailingComma(e))break;if(this.type===E.ellipsis){var o=this.parseRestBinding();this.parseBindingListItem(o),i.push(o),this.type===E.comma&&this.raiseRecoverable(this.start,"Comma is not permitted after the rest element"),this.expect(e);break}i.push(this.parseAssignableListItem(r))}return i},Ee.parseAssignableListItem=function(e){var t=this.parseMaybeDefault(this.start,this.startLoc);return this.parseBindingListItem(t),t},Ee.parseBindingListItem=function(e){return e},Ee.parseMaybeDefault=function(e,t,n){if(n=n||this.parseBindingAtom(),this.options.ecmaVersion<6||!this.eat(E.eq))return n;var r=this.startNodeAt(e,t);return r.left=n,r.right=this.parseMaybeAssign(),this.finishNode(r,"AssignmentPattern")},Ee.checkLValSimple=function(e,t,n){void 0===t&&(t=ee);var r=t!==ee;switch(e.type){case"Identifier":this.strict&&this.reservedWordsStrictBind.test(e.name)&&this.raiseRecoverable(e.start,(r?"Binding ":"Assigning to ")+e.name+" in strict mode"),r&&(t===ne&&"let"===e.name&&this.raiseRecoverable(e.start,"let is disallowed as a lexically bound name"),n&&(I(n,e.name)&&this.raiseRecoverable(e.start,"Argument name clash"),n[e.name]=!0),t!==se&&this.declareName(e.name,t,e.start));break;case"ChainExpression":this.raiseRecoverable(e.start,"Optional chaining cannot appear in left-hand side");break;case"MemberExpression":r&&this.raiseRecoverable(e.start,"Binding member expression");break;case"ParenthesizedExpression":return r&&this.raiseRecoverable(e.start,"Binding parenthesized expression"),this.checkLValSimple(e.expression,t,n);default:this.raise(e.start,(r?"Binding":"Assigning to")+" rvalue")}},Ee.checkLValPattern=function(e,t,n){switch(void 0===t&&(t=ee),e.type){case"ObjectPattern":for(var r=0,i=e.properties;r<i.length;r+=1){var s=i[r];this.checkLValInnerPattern(s,t,n)}break;case"ArrayPattern":for(var o=0,a=e.elements;o<a.length;o+=1){var c=a[o];c&&this.checkLValInnerPattern(c,t,n)}break;default:this.checkLValSimple(e,t,n)}},Ee.checkLValInnerPattern=function(e,t,n){switch(void 0===t&&(t=ee),e.type){case"Property":this.checkLValInnerPattern(e.value,t,n);break;case"AssignmentPattern":this.checkLValPattern(e.left,t,n);break;case"RestElement":this.checkLValPattern(e.argument,t,n);break;default:this.checkLValPattern(e,t,n)}};var Se=function(e,t,n,r,i){this.token=e,this.isExpr=!!t,this.preserveSpace=!!n,this.override=r,this.generator=!!i},we={b_stat:new Se("{",!1),b_expr:new Se("{",!0),b_tmpl:new Se("${",!1),p_stat:new Se("(",!1),p_expr:new Se("(",!0),q_tmpl:new Se("`",!0,!0,(function(e){return e.tryReadTemplateToken()})),f_stat:new Se("function",!1),f_expr:new Se("function",!0),f_expr_gen:new Se("function",!0,!1,null,!0),f_gen:new Se("function",!1,!1,null,!0)},be=oe.prototype;be.initialContext=function(){return[we.b_stat]},be.curContext=function(){return this.context[this.context.length-1]},be.braceIsBlock=function(e){var t=this.curContext();return t===we.f_expr||t===we.f_stat||(e!==E.colon||t!==we.b_stat&&t!==we.b_expr?e===E._return||e===E.name&&this.exprAllowed?S.test(this.input.slice(this.lastTokEnd,this.start)):e===E._else||e===E.semi||e===E.eof||e===E.parenR||e===E.arrow||(e===E.braceL?t===we.b_stat:e!==E._var&&e!==E._const&&e!==E.name&&!this.exprAllowed):!t.isExpr)},be.inGeneratorContext=function(){for(var e=this.context.length-1;e>=1;e--){var t=this.context[e];if("function"===t.token)return t.generator}return!1},be.updateContext=function(e){var t,n=this.type;n.keyword&&e===E.dot?this.exprAllowed=!1:(t=n.updateContext)?t.call(this,e):this.exprAllowed=n.beforeExpr},be.overrideContext=function(e){this.curContext()!==e&&(this.context[this.context.length-1]=e)},E.parenR.updateContext=E.braceR.updateContext=function(){if(1!==this.context.length){var e=this.context.pop();e===we.b_stat&&"function"===this.curContext().token&&(e=this.context.pop()),this.exprAllowed=!e.isExpr}else this.exprAllowed=!0},E.braceL.updateContext=function(e){this.context.push(this.braceIsBlock(e)?we.b_stat:we.b_expr),this.exprAllowed=!0},E.dollarBraceL.updateContext=function(){this.context.push(we.b_tmpl),this.exprAllowed=!0},E.parenL.updateContext=function(e){var t=e===E._if||e===E._for||e===E._with||e===E._while;this.context.push(t?we.p_stat:we.p_expr),this.exprAllowed=!0},E.incDec.updateContext=function(){},E._function.updateContext=E._class.updateContext=function(e){!e.beforeExpr||e===E._else||e===E.semi&&this.curContext()!==we.p_stat||e===E._return&&S.test(this.input.slice(this.lastTokEnd,this.start))||(e===E.colon||e===E.braceL)&&this.curContext()===we.b_stat?this.context.push(we.f_stat):this.context.push(we.f_expr),this.exprAllowed=!1},E.colon.updateContext=function(){"function"===this.curContext().token&&this.context.pop(),this.exprAllowed=!0},E.backQuote.updateContext=function(){this.curContext()===we.q_tmpl?this.context.pop():this.context.push(we.q_tmpl),this.exprAllowed=!1},E.star.updateContext=function(e){if(e===E._function){var t=this.context.length-1;this.context[t]===we.f_expr?this.context[t]=we.f_expr_gen:this.context[t]=we.f_gen}this.exprAllowed=!0},E.name.updateContext=function(e){var t=!1;this.options.ecmaVersion>=6&&e!==E.dot&&("of"===this.value&&!this.exprAllowed||"yield"===this.value&&this.inGeneratorContext())&&(t=!0),this.exprAllowed=t};var _e=oe.prototype;function ke(e){return"Identifier"===e.type||"ParenthesizedExpression"===e.type&&ke(e.expression)}function Ce(e){return"MemberExpression"===e.type&&"PrivateIdentifier"===e.property.type||"ChainExpression"===e.type&&Ce(e.expression)||"ParenthesizedExpression"===e.type&&Ce(e.expression)}_e.checkPropClash=function(e,t,n){if(!(this.options.ecmaVersion>=9&&"SpreadElement"===e.type||this.options.ecmaVersion>=6&&(e.computed||e.method||e.shorthand))){var r,i=e.key;switch(i.type){case"Identifier":r=i.name;break;case"Literal":r=String(i.value);break;default:return}var s=e.kind;if(this.options.ecmaVersion>=6)"__proto__"===r&&"init"===s&&(t.proto&&(n?n.doubleProto<0&&(n.doubleProto=i.start):this.raiseRecoverable(i.start,"Redefinition of __proto__ property")),t.proto=!0);else{var o=t[r="$"+r];o?("init"===s?this.strict&&o.init||o.get||o.set:o.init||o[s])&&this.raiseRecoverable(i.start,"Redefinition of property"):o=t[r]={init:!1,get:!1,set:!1},o[s]=!0}}},_e.parseExpression=function(e,t){var n=this.start,r=this.startLoc,i=this.parseMaybeAssign(e,t);if(this.type===E.comma){var s=this.startNodeAt(n,r);for(s.expressions=[i];this.eat(E.comma);)s.expressions.push(this.parseMaybeAssign(e,t));return this.finishNode(s,"SequenceExpression")}return i},_e.parseMaybeAssign=function(e,t,n){if(this.isContextual("yield")){if(this.inGenerator)return this.parseYield(e);this.exprAllowed=!1}var r=!1,i=-1,s=-1,o=-1;t?(i=t.parenthesizedAssign,s=t.trailingComma,o=t.doubleProto,t.parenthesizedAssign=t.trailingComma=-1):(t=new pe,r=!0);var a=this.start,c=this.startLoc;this.type!==E.parenL&&this.type!==E.name||(this.potentialArrowAt=this.start,this.potentialArrowInForAwait="await"===e);var l=this.parseMaybeConditional(e,t);if(n&&(l=n.call(this,l,a,c)),this.type.isAssign){var p=this.startNodeAt(a,c);return p.operator=this.value,this.type===E.eq&&(l=this.toAssignable(l,!1,t)),r||(t.parenthesizedAssign=t.trailingComma=t.doubleProto=-1),t.shorthandAssign>=l.start&&(t.shorthandAssign=-1),this.type===E.eq?this.checkLValPattern(l):this.checkLValSimple(l),p.left=l,this.next(),p.right=this.parseMaybeAssign(e),o>-1&&(t.doubleProto=o),this.finishNode(p,"AssignmentExpression")}return r&&this.checkExpressionErrors(t,!0),i>-1&&(t.parenthesizedAssign=i),s>-1&&(t.trailingComma=s),l},_e.parseMaybeConditional=function(e,t){var n=this.start,r=this.startLoc,i=this.parseExprOps(e,t);if(this.checkExpressionErrors(t))return i;if(this.eat(E.question)){var s=this.startNodeAt(n,r);return s.test=i,s.consequent=this.parseMaybeAssign(),this.expect(E.colon),s.alternate=this.parseMaybeAssign(e),this.finishNode(s,"ConditionalExpression")}return i},_e.parseExprOps=function(e,t){var n=this.start,r=this.startLoc,i=this.parseMaybeUnary(t,!1,!1,e);return this.checkExpressionErrors(t)||i.start===n&&"ArrowFunctionExpression"===i.type?i:this.parseExprOp(i,n,r,-1,e)},_e.parseExprOp=function(e,t,n,r,i){var s=this.type.binop;if(null!=s&&(!i||this.type!==E._in)&&s>r){var o=this.type===E.logicalOR||this.type===E.logicalAND,a=this.type===E.coalesce;a&&(s=E.logicalAND.binop);var c=this.value;this.next();var l=this.start,p=this.startLoc,u=this.parseExprOp(this.parseMaybeUnary(null,!1,!1,i),l,p,s,i),h=this.buildBinary(t,n,e,u,c,o||a);return(o&&this.type===E.coalesce||a&&(this.type===E.logicalOR||this.type===E.logicalAND))&&this.raiseRecoverable(this.start,"Logical expressions and coalesce expressions cannot be mixed. Wrap either by parentheses"),this.parseExprOp(h,t,n,r,i)}return e},_e.buildBinary=function(e,t,n,r,i,s){"PrivateIdentifier"===r.type&&this.raise(r.start,"Private identifier can only be left side of binary expression");var o=this.startNodeAt(e,t);return o.left=n,o.operator=i,o.right=r,this.finishNode(o,s?"LogicalExpression":"BinaryExpression")},_e.parseMaybeUnary=function(e,t,n,r){var i,s=this.start,o=this.startLoc;if(this.isContextual("await")&&this.canAwait)i=this.parseAwait(r),t=!0;else if(this.type.prefix){var a=this.startNode(),c=this.type===E.incDec;a.operator=this.value,a.prefix=!0,this.next(),a.argument=this.parseMaybeUnary(null,!0,c,r),this.checkExpressionErrors(e,!0),c?this.checkLValSimple(a.argument):this.strict&&"delete"===a.operator&&ke(a.argument)?this.raiseRecoverable(a.start,"Deleting local variable in strict mode"):"delete"===a.operator&&Ce(a.argument)?this.raiseRecoverable(a.start,"Private fields can not be deleted"):t=!0,i=this.finishNode(a,c?"UpdateExpression":"UnaryExpression")}else if(t||this.type!==E.privateId){if(i=this.parseExprSubscripts(e,r),this.checkExpressionErrors(e))return i;for(;this.type.postfix&&!this.canInsertSemicolon();){var l=this.startNodeAt(s,o);l.operator=this.value,l.prefix=!1,l.argument=i,this.checkLValSimple(i),this.next(),i=this.finishNode(l,"UpdateExpression")}}else(r||0===this.privateNameStack.length)&&this.options.checkPrivateFields&&this.unexpected(),i=this.parsePrivateIdent(),this.type!==E._in&&this.unexpected();return n||!this.eat(E.starstar)?i:t?void this.unexpected(this.lastTokStart):this.buildBinary(s,o,i,this.parseMaybeUnary(null,!1,!1,r),"**",!1)},_e.parseExprSubscripts=function(e,t){var n=this.start,r=this.startLoc,i=this.parseExprAtom(e,t);if("ArrowFunctionExpression"===i.type&&")"!==this.input.slice(this.lastTokStart,this.lastTokEnd))return i;var s=this.parseSubscripts(i,n,r,!1,t);return e&&"MemberExpression"===s.type&&(e.parenthesizedAssign>=s.start&&(e.parenthesizedAssign=-1),e.parenthesizedBind>=s.start&&(e.parenthesizedBind=-1),e.trailingComma>=s.start&&(e.trailingComma=-1)),s},_e.parseSubscripts=function(e,t,n,r,i){for(var s=this.options.ecmaVersion>=8&&"Identifier"===e.type&&"async"===e.name&&this.lastTokEnd===e.end&&!this.canInsertSemicolon()&&e.end-e.start==5&&this.potentialArrowAt===e.start,o=!1;;){var a=this.parseSubscript(e,t,n,r,s,o,i);if(a.optional&&(o=!0),a===e||"ArrowFunctionExpression"===a.type){if(o){var c=this.startNodeAt(t,n);c.expression=a,a=this.finishNode(c,"ChainExpression")}return a}e=a}},_e.shouldParseAsyncArrow=function(){return!this.canInsertSemicolon()&&this.eat(E.arrow)},_e.parseSubscriptAsyncArrow=function(e,t,n,r){return this.parseArrowExpression(this.startNodeAt(e,t),n,!0,r)},_e.parseSubscript=function(e,t,n,r,i,s,o){var a=this.options.ecmaVersion>=11,c=a&&this.eat(E.questionDot);r&&c&&this.raise(this.lastTokStart,"Optional chaining cannot appear in the callee of new expressions");var l=this.eat(E.bracketL);if(l||c&&this.type!==E.parenL&&this.type!==E.backQuote||this.eat(E.dot)){var p=this.startNodeAt(t,n);p.object=e,l?(p.property=this.parseExpression(),this.expect(E.bracketR)):this.type===E.privateId&&"Super"!==e.type?p.property=this.parsePrivateIdent():p.property=this.parseIdent("never"!==this.options.allowReserved),p.computed=!!l,a&&(p.optional=c),e=this.finishNode(p,"MemberExpression")}else if(!r&&this.eat(E.parenL)){var u=new pe,h=this.yieldPos,d=this.awaitPos,f=this.awaitIdentPos;this.yieldPos=0,this.awaitPos=0,this.awaitIdentPos=0;var m=this.parseExprList(E.parenR,this.options.ecmaVersion>=8,!1,u);if(i&&!c&&this.shouldParseAsyncArrow())return this.checkPatternErrors(u,!1),this.checkYieldAwaitInDefaultParams(),this.awaitIdentPos>0&&this.raise(this.awaitIdentPos,"Cannot use 'await' as identifier inside an async function"),this.yieldPos=h,this.awaitPos=d,this.awaitIdentPos=f,this.parseSubscriptAsyncArrow(t,n,m,o);this.checkExpressionErrors(u,!0),this.yieldPos=h||this.yieldPos,this.awaitPos=d||this.awaitPos,this.awaitIdentPos=f||this.awaitIdentPos;var g=this.startNodeAt(t,n);g.callee=e,g.arguments=m,a&&(g.optional=c),e=this.finishNode(g,"CallExpression")}else if(this.type===E.backQuote){(c||s)&&this.raise(this.start,"Optional chaining cannot appear in the tag of tagged template expressions");var v=this.startNodeAt(t,n);v.tag=e,v.quasi=this.parseTemplate({isTagged:!0}),e=this.finishNode(v,"TaggedTemplateExpression")}return e},_e.parseExprAtom=function(e,t,n){this.type===E.slash&&this.readRegexp();var r,i=this.potentialArrowAt===this.start;switch(this.type){case E._super:return this.allowSuper||this.raise(this.start,"'super' keyword outside a method"),r=this.startNode(),this.next(),this.type!==E.parenL||this.allowDirectSuper||this.raise(r.start,"super() call outside constructor of a subclass"),this.type!==E.dot&&this.type!==E.bracketL&&this.type!==E.parenL&&this.unexpected(),this.finishNode(r,"Super");case E._this:return r=this.startNode(),this.next(),this.finishNode(r,"ThisExpression");case E.name:var s=this.start,o=this.startLoc,a=this.containsEsc,c=this.parseIdent(!1);if(this.options.ecmaVersion>=8&&!a&&"async"===c.name&&!this.canInsertSemicolon()&&this.eat(E._function))return this.overrideContext(we.f_expr),this.parseFunction(this.startNodeAt(s,o),0,!1,!0,t);if(i&&!this.canInsertSemicolon()){if(this.eat(E.arrow))return this.parseArrowExpression(this.startNodeAt(s,o),[c],!1,t);if(this.options.ecmaVersion>=8&&"async"===c.name&&this.type===E.name&&!a&&(!this.potentialArrowInForAwait||"of"!==this.value||this.containsEsc))return c=this.parseIdent(!1),!this.canInsertSemicolon()&&this.eat(E.arrow)||this.unexpected(),this.parseArrowExpression(this.startNodeAt(s,o),[c],!0,t)}return c;case E.regexp:var l=this.value;return(r=this.parseLiteral(l.value)).regex={pattern:l.pattern,flags:l.flags},r;case E.num:case E.string:return this.parseLiteral(this.value);case E._null:case E._true:case E._false:return(r=this.startNode()).value=this.type===E._null?null:this.type===E._true,r.raw=this.type.keyword,this.next(),this.finishNode(r,"Literal");case E.parenL:var p=this.start,u=this.parseParenAndDistinguishExpression(i,t);return e&&(e.parenthesizedAssign<0&&!this.isSimpleAssignTarget(u)&&(e.parenthesizedAssign=p),e.parenthesizedBind<0&&(e.parenthesizedBind=p)),u;case E.bracketL:return r=this.startNode(),this.next(),r.elements=this.parseExprList(E.bracketR,!0,!0,e),this.finishNode(r,"ArrayExpression");case E.braceL:return this.overrideContext(we.b_expr),this.parseObj(!1,e);case E._function:return r=this.startNode(),this.next(),this.parseFunction(r,0);case E._class:return this.parseClass(this.startNode(),!1);case E._new:return this.parseNew();case E.backQuote:return this.parseTemplate();case E._import:return this.options.ecmaVersion>=11?this.parseExprImport(n):this.unexpected();default:return this.parseExprAtomDefault()}},_e.parseExprAtomDefault=function(){this.unexpected()},_e.parseExprImport=function(e){var t=this.startNode();if(this.containsEsc&&this.raiseRecoverable(this.start,"Escape sequence in keyword import"),this.next(),this.type===E.parenL&&!e)return this.parseDynamicImport(t);if(this.type===E.dot){var n=this.startNodeAt(t.start,t.loc&&t.loc.start);return n.name="import",t.meta=this.finishNode(n,"Identifier"),this.parseImportMeta(t)}this.unexpected()},_e.parseDynamicImport=function(e){if(this.next(),e.source=this.parseMaybeAssign(),this.options.ecmaVersion>=16)this.eat(E.parenR)?e.options=null:(this.expect(E.comma),this.afterTrailingComma(E.parenR)?e.options=null:(e.options=this.parseMaybeAssign(),this.eat(E.parenR)||(this.expect(E.comma),this.afterTrailingComma(E.parenR)||this.unexpected())));else if(!this.eat(E.parenR)){var t=this.start;this.eat(E.comma)&&this.eat(E.parenR)?this.raiseRecoverable(t,"Trailing comma is not allowed in import()"):this.unexpected(t)}return this.finishNode(e,"ImportExpression")},_e.parseImportMeta=function(e){this.next();var t=this.containsEsc;return e.property=this.parseIdent(!0),"meta"!==e.property.name&&this.raiseRecoverable(e.property.start,"The only valid meta property for import is 'import.meta'"),t&&this.raiseRecoverable(e.start,"'import.meta' must not contain escaped characters"),"module"===this.options.sourceType||this.options.allowImportExportEverywhere||this.raiseRecoverable(e.start,"Cannot use 'import.meta' outside a module"),this.finishNode(e,"MetaProperty")},_e.parseLiteral=function(e){var t=this.startNode();return t.value=e,t.raw=this.input.slice(this.start,this.end),110===t.raw.charCodeAt(t.raw.length-1)&&(t.bigint=t.raw.slice(0,-1).replace(/_/g,"")),this.next(),this.finishNode(t,"Literal")},_e.parseParenExpression=function(){this.expect(E.parenL);var e=this.parseExpression();return this.expect(E.parenR),e},_e.shouldParseArrow=function(e){return!this.canInsertSemicolon()},_e.parseParenAndDistinguishExpression=function(e,t){var n,r=this.start,i=this.startLoc,s=this.options.ecmaVersion>=8;if(this.options.ecmaVersion>=6){this.next();var o,a=this.start,c=this.startLoc,l=[],p=!0,u=!1,h=new pe,d=this.yieldPos,f=this.awaitPos;for(this.yieldPos=0,this.awaitPos=0;this.type!==E.parenR;){if(p?p=!1:this.expect(E.comma),s&&this.afterTrailingComma(E.parenR,!0)){u=!0;break}if(this.type===E.ellipsis){o=this.start,l.push(this.parseParenItem(this.parseRestBinding())),this.type===E.comma&&this.raiseRecoverable(this.start,"Comma is not permitted after the rest element");break}l.push(this.parseMaybeAssign(!1,h,this.parseParenItem))}var m=this.lastTokEnd,g=this.lastTokEndLoc;if(this.expect(E.parenR),e&&this.shouldParseArrow(l)&&this.eat(E.arrow))return this.checkPatternErrors(h,!1),this.checkYieldAwaitInDefaultParams(),this.yieldPos=d,this.awaitPos=f,this.parseParenArrowList(r,i,l,t);l.length&&!u||this.unexpected(this.lastTokStart),o&&this.unexpected(o),this.checkExpressionErrors(h,!0),this.yieldPos=d||this.yieldPos,this.awaitPos=f||this.awaitPos,l.length>1?((n=this.startNodeAt(a,c)).expressions=l,this.finishNodeAt(n,"SequenceExpression",m,g)):n=l[0]}else n=this.parseParenExpression();if(this.options.preserveParens){var v=this.startNodeAt(r,i);return v.expression=n,this.finishNode(v,"ParenthesizedExpression")}return n},_e.parseParenItem=function(e){return e},_e.parseParenArrowList=function(e,t,n,r){return this.parseArrowExpression(this.startNodeAt(e,t),n,!1,r)};var Pe=[];_e.parseNew=function(){this.containsEsc&&this.raiseRecoverable(this.start,"Escape sequence in keyword new");var e=this.startNode();if(this.next(),this.options.ecmaVersion>=6&&this.type===E.dot){var t=this.startNodeAt(e.start,e.loc&&e.loc.start);t.name="new",e.meta=this.finishNode(t,"Identifier"),this.next();var n=this.containsEsc;return e.property=this.parseIdent(!0),"target"!==e.property.name&&this.raiseRecoverable(e.property.start,"The only valid meta property for new is 'new.target'"),n&&this.raiseRecoverable(e.start,"'new.target' must not contain escaped characters"),this.allowNewDotTarget||this.raiseRecoverable(e.start,"'new.target' can only be used in functions and class static block"),this.finishNode(e,"MetaProperty")}var r=this.start,i=this.startLoc;return e.callee=this.parseSubscripts(this.parseExprAtom(null,!1,!0),r,i,!0,!1),this.eat(E.parenL)?e.arguments=this.parseExprList(E.parenR,this.options.ecmaVersion>=8,!1):e.arguments=Pe,this.finishNode(e,"NewExpression")},_e.parseTemplateElement=function(e){var t=e.isTagged,n=this.startNode();return this.type===E.invalidTemplate?(t||this.raiseRecoverable(this.start,"Bad escape sequence in untagged template literal"),n.value={raw:this.value.replace(/\r\n?/g,"\n"),cooked:null}):n.value={raw:this.input.slice(this.start,this.end).replace(/\r\n?/g,"\n"),cooked:this.value},this.next(),n.tail=this.type===E.backQuote,this.finishNode(n,"TemplateElement")},_e.parseTemplate=function(e){void 0===e&&(e={});var t=e.isTagged;void 0===t&&(t=!1);var n=this.startNode();this.next(),n.expressions=[];var r=this.parseTemplateElement({isTagged:t});for(n.quasis=[r];!r.tail;)this.type===E.eof&&this.raise(this.pos,"Unterminated template literal"),this.expect(E.dollarBraceL),n.expressions.push(this.parseExpression()),this.expect(E.braceR),n.quasis.push(r=this.parseTemplateElement({isTagged:t}));return this.next(),this.finishNode(n,"TemplateLiteral")},_e.isAsyncProp=function(e){return!e.computed&&"Identifier"===e.key.type&&"async"===e.key.name&&(this.type===E.name||this.type===E.num||this.type===E.string||this.type===E.bracketL||this.type.keyword||this.options.ecmaVersion>=9&&this.type===E.star)&&!S.test(this.input.slice(this.lastTokEnd,this.start))},_e.parseObj=function(e,t){var n=this.startNode(),r=!0,i={};for(n.properties=[],this.next();!this.eat(E.braceR);){if(r)r=!1;else if(this.expect(E.comma),this.options.ecmaVersion>=5&&this.afterTrailingComma(E.braceR))break;var s=this.parseProperty(e,t);e||this.checkPropClash(s,i,t),n.properties.push(s)}return this.finishNode(n,e?"ObjectPattern":"ObjectExpression")},_e.parseProperty=function(e,t){var n,r,i,s,o=this.startNode();if(this.options.ecmaVersion>=9&&this.eat(E.ellipsis))return e?(o.argument=this.parseIdent(!1),this.type===E.comma&&this.raiseRecoverable(this.start,"Comma is not permitted after the rest element"),this.finishNode(o,"RestElement")):(o.argument=this.parseMaybeAssign(!1,t),this.type===E.comma&&t&&t.trailingComma<0&&(t.trailingComma=this.start),this.finishNode(o,"SpreadElement"));this.options.ecmaVersion>=6&&(o.method=!1,o.shorthand=!1,(e||t)&&(i=this.start,s=this.startLoc),e||(n=this.eat(E.star)));var a=this.containsEsc;return this.parsePropertyName(o),!e&&!a&&this.options.ecmaVersion>=8&&!n&&this.isAsyncProp(o)?(r=!0,n=this.options.ecmaVersion>=9&&this.eat(E.star),this.parsePropertyName(o)):r=!1,this.parsePropertyValue(o,e,n,r,i,s,t,a),this.finishNode(o,"Property")},_e.parseGetterSetter=function(e){e.kind=e.key.name,this.parsePropertyName(e),e.value=this.parseMethod(!1);var t="get"===e.kind?0:1;if(e.value.params.length!==t){var n=e.value.start;"get"===e.kind?this.raiseRecoverable(n,"getter should have no params"):this.raiseRecoverable(n,"setter should have exactly one param")}else"set"===e.kind&&"RestElement"===e.value.params[0].type&&this.raiseRecoverable(e.value.params[0].start,"Setter cannot use rest params")},_e.parsePropertyValue=function(e,t,n,r,i,s,o,a){(n||r)&&this.type===E.colon&&this.unexpected(),this.eat(E.colon)?(e.value=t?this.parseMaybeDefault(this.start,this.startLoc):this.parseMaybeAssign(!1,o),e.kind="init"):this.options.ecmaVersion>=6&&this.type===E.parenL?(t&&this.unexpected(),e.kind="init",e.method=!0,e.value=this.parseMethod(n,r)):t||a||!(this.options.ecmaVersion>=5)||e.computed||"Identifier"!==e.key.type||"get"!==e.key.name&&"set"!==e.key.name||this.type===E.comma||this.type===E.braceR||this.type===E.eq?this.options.ecmaVersion>=6&&!e.computed&&"Identifier"===e.key.type?((n||r)&&this.unexpected(),this.checkUnreserved(e.key),"await"!==e.key.name||this.awaitIdentPos||(this.awaitIdentPos=i),e.kind="init",t?e.value=this.parseMaybeDefault(i,s,this.copyNode(e.key)):this.type===E.eq&&o?(o.shorthandAssign<0&&(o.shorthandAssign=this.start),e.value=this.parseMaybeDefault(i,s,this.copyNode(e.key))):e.value=this.copyNode(e.key),e.shorthand=!0):this.unexpected():((n||r)&&this.unexpected(),this.parseGetterSetter(e))},_e.parsePropertyName=function(e){if(this.options.ecmaVersion>=6){if(this.eat(E.bracketL))return e.computed=!0,e.key=this.parseMaybeAssign(),this.expect(E.bracketR),e.key;e.computed=!1}return e.key=this.type===E.num||this.type===E.string?this.parseExprAtom():this.parseIdent("never"!==this.options.allowReserved)},_e.initFunction=function(e){e.id=null,this.options.ecmaVersion>=6&&(e.generator=e.expression=!1),this.options.ecmaVersion>=8&&(e.async=!1)},_e.parseMethod=function(e,t,n){var r=this.startNode(),i=this.yieldPos,s=this.awaitPos,o=this.awaitIdentPos;return this.initFunction(r),this.options.ecmaVersion>=6&&(r.generator=e),this.options.ecmaVersion>=8&&(r.async=!!t),this.yieldPos=0,this.awaitPos=0,this.awaitIdentPos=0,this.enterScope(Z(t,r.generator)|J|(n?Y:0)),this.expect(E.parenL),r.params=this.parseBindingList(E.parenR,!1,this.options.ecmaVersion>=8),this.checkYieldAwaitInDefaultParams(),this.parseFunctionBody(r,!1,!0,!1),this.yieldPos=i,this.awaitPos=s,this.awaitIdentPos=o,this.finishNode(r,"FunctionExpression")},_e.parseArrowExpression=function(e,t,n,r){var i=this.yieldPos,s=this.awaitPos,o=this.awaitIdentPos;return this.enterScope(Z(n,!1)|K),this.initFunction(e),this.options.ecmaVersion>=8&&(e.async=!!n),this.yieldPos=0,this.awaitPos=0,this.awaitIdentPos=0,e.params=this.toAssignableList(t,!0),this.parseFunctionBody(e,!0,!1,r),this.yieldPos=i,this.awaitPos=s,this.awaitIdentPos=o,this.finishNode(e,"ArrowFunctionExpression")},_e.parseFunctionBody=function(e,t,n,r){var i=t&&this.type!==E.braceL,s=this.strict,o=!1;if(i)e.body=this.parseMaybeAssign(r),e.expression=!0,this.checkParams(e,!1);else{var a=this.options.ecmaVersion>=7&&!this.isSimpleParamList(e.params);s&&!a||(o=this.strictDirective(this.end))&&a&&this.raiseRecoverable(e.start,"Illegal 'use strict' directive in function with non-simple parameter list");var c=this.labels;this.labels=[],o&&(this.strict=!0),this.checkParams(e,!s&&!o&&!t&&!n&&this.isSimpleParamList(e.params)),this.strict&&e.id&&this.checkLValSimple(e.id,se),e.body=this.parseBlock(!1,void 0,o&&!s),e.expression=!1,this.adaptDirectivePrologue(e.body.body),this.labels=c}this.exitScope()},_e.isSimpleParamList=function(e){for(var t=0,n=e;t<n.length;t+=1)if("Identifier"!==n[t].type)return!1;return!0},_e.checkParams=function(e,t){for(var n=Object.create(null),r=0,i=e.params;r<i.length;r+=1){var s=i[r];this.checkLValInnerPattern(s,te,t?null:n)}},_e.parseExprList=function(e,t,n,r){for(var i=[],s=!0;!this.eat(e);){if(s)s=!1;else if(this.expect(E.comma),t&&this.afterTrailingComma(e))break;var o=void 0;n&&this.type===E.comma?o=null:this.type===E.ellipsis?(o=this.parseSpread(r),r&&this.type===E.comma&&r.trailingComma<0&&(r.trailingComma=this.start)):o=this.parseMaybeAssign(!1,r),i.push(o)}return i},_e.checkUnreserved=function(e){var t=e.start,n=e.end,r=e.name;this.inGenerator&&"yield"===r&&this.raiseRecoverable(t,"Cannot use 'yield' as identifier inside a generator"),this.inAsync&&"await"===r&&this.raiseRecoverable(t,"Cannot use 'await' as identifier inside an async function"),this.currentThisScope().inClassFieldInit&&"arguments"===r&&this.raiseRecoverable(t,"Cannot use 'arguments' in class field initializer"),!this.inClassStaticBlock||"arguments"!==r&&"await"!==r||this.raise(t,"Cannot use "+r+" in class static initialization block"),this.keywords.test(r)&&this.raise(t,"Unexpected keyword '"+r+"'"),this.options.ecmaVersion<6&&-1!==this.input.slice(t,n).indexOf("\\")||(this.strict?this.reservedWordsStrict:this.reservedWords).test(r)&&(this.inAsync||"await"!==r||this.raiseRecoverable(t,"Cannot use keyword 'await' outside an async function"),this.raiseRecoverable(t,"The keyword '"+r+"' is reserved"))},_e.parseIdent=function(e){var t=this.parseIdentNode();return this.next(!!e),this.finishNode(t,"Identifier"),e||(this.checkUnreserved(t),"await"!==t.name||this.awaitIdentPos||(this.awaitIdentPos=t.start)),t},_e.parseIdentNode=function(){var e=this.startNode();return this.type===E.name?e.name=this.value:this.type.keyword?(e.name=this.type.keyword,"class"!==e.name&&"function"!==e.name||this.lastTokEnd===this.lastTokStart+1&&46===this.input.charCodeAt(this.lastTokStart)||this.context.pop(),this.type=E.name):this.unexpected(),e},_e.parsePrivateIdent=function(){var e=this.startNode();return this.type===E.privateId?e.name=this.value:this.unexpected(),this.next(),this.finishNode(e,"PrivateIdentifier"),this.options.checkPrivateFields&&(0===this.privateNameStack.length?this.raise(e.start,"Private field '#"+e.name+"' must be declared in an enclosing class"):this.privateNameStack[this.privateNameStack.length-1].used.push(e)),e},_e.parseYield=function(e){this.yieldPos||(this.yieldPos=this.start);var t=this.startNode();return this.next(),this.type===E.semi||this.canInsertSemicolon()||this.type!==E.star&&!this.type.startsExpr?(t.delegate=!1,t.argument=null):(t.delegate=this.eat(E.star),t.argument=this.parseMaybeAssign(e)),this.finishNode(t,"YieldExpression")},_e.parseAwait=function(e){this.awaitPos||(this.awaitPos=this.start);var t=this.startNode();return this.next(),t.argument=this.parseMaybeUnary(null,!0,!1,e),this.finishNode(t,"AwaitExpression")};var Ae=oe.prototype;Ae.raise=function(e,t){var n=M(this.input,e);t+=" ("+n.line+":"+n.column+")";var r=new SyntaxError(t);throw r.pos=e,r.loc=n,r.raisedAt=this.pos,r},Ae.raiseRecoverable=Ae.raise,Ae.curPosition=function(){if(this.options.locations)return new j(this.curLine,this.pos-this.lineStart)};var Ne=oe.prototype,Ie=function(e){this.flags=e,this.var=[],this.lexical=[],this.functions=[],this.inClassFieldInit=!1};Ne.enterScope=function(e){this.scopeStack.push(new Ie(e))},Ne.exitScope=function(){this.scopeStack.pop()},Ne.treatFunctionsAsVarInScope=function(e){return e.flags&$||!this.inModule&&e.flags&q},Ne.declareName=function(e,t,n){var r=!1;if(t===ne){var i=this.currentScope();r=i.lexical.indexOf(e)>-1||i.functions.indexOf(e)>-1||i.var.indexOf(e)>-1,i.lexical.push(e),this.inModule&&i.flags&q&&delete this.undefinedExports[e]}else if(t===ie)this.currentScope().lexical.push(e);else if(t===re){var s=this.currentScope();r=this.treatFunctionsAsVar?s.lexical.indexOf(e)>-1:s.lexical.indexOf(e)>-1||s.var.indexOf(e)>-1,s.functions.push(e)}else for(var o=this.scopeStack.length-1;o>=0;--o){var a=this.scopeStack[o];if(a.lexical.indexOf(e)>-1&&!(a.flags&z&&a.lexical[0]===e)||!this.treatFunctionsAsVarInScope(a)&&a.functions.indexOf(e)>-1){r=!0;break}if(a.var.push(e),this.inModule&&a.flags&q&&delete this.undefinedExports[e],a.flags&X)break}r&&this.raiseRecoverable(n,"Identifier '"+e+"' has already been declared")},Ne.checkLocalExport=function(e){-1===this.scopeStack[0].lexical.indexOf(e.name)&&-1===this.scopeStack[0].var.indexOf(e.name)&&(this.undefinedExports[e.name]=e)},Ne.currentScope=function(){return this.scopeStack[this.scopeStack.length-1]},Ne.currentVarScope=function(){for(var e=this.scopeStack.length-1;;e--){var t=this.scopeStack[e];if(t.flags&X)return t}},Ne.currentThisScope=function(){for(var e=this.scopeStack.length-1;;e--){var t=this.scopeStack[e];if(t.flags&X&&!(t.flags&K))return t}};var Te=function(e,t,n){this.type="",this.start=t,this.end=0,e.options.locations&&(this.loc=new F(e,n)),e.options.directSourceFile&&(this.sourceFile=e.options.directSourceFile),e.options.ranges&&(this.range=[t,0])},Re=oe.prototype;function Oe(e,t,n,r){return e.type=t,e.end=n,this.options.locations&&(e.loc.end=r),this.options.ranges&&(e.range[1]=n),e}Re.startNode=function(){return new Te(this,this.start,this.startLoc)},Re.startNodeAt=function(e,t){return new Te(this,e,t)},Re.finishNode=function(e,t){return Oe.call(this,e,t,this.lastTokEnd,this.lastTokEndLoc)},Re.finishNodeAt=function(e,t,n,r){return Oe.call(this,e,t,n,r)},Re.copyNode=function(e){var t=new Te(this,e.start,this.startLoc);for(var n in e)t[n]=e[n];return t};var Le="ASCII ASCII_Hex_Digit AHex Alphabetic Alpha Any Assigned Bidi_Control Bidi_C Bidi_Mirrored Bidi_M Case_Ignorable CI Cased Changes_When_Casefolded CWCF Changes_When_Casemapped CWCM Changes_When_Lowercased CWL Changes_When_NFKC_Casefolded CWKCF Changes_When_Titlecased CWT Changes_When_Uppercased CWU Dash Default_Ignorable_Code_Point DI Deprecated Dep Diacritic Dia Emoji Emoji_Component Emoji_Modifier Emoji_Modifier_Base Emoji_Presentation Extender Ext Grapheme_Base Gr_Base Grapheme_Extend Gr_Ext Hex_Digit Hex IDS_Binary_Operator IDSB IDS_Trinary_Operator IDST ID_Continue IDC ID_Start IDS Ideographic Ideo Join_Control Join_C Logical_Order_Exception LOE Lowercase Lower Math Noncharacter_Code_Point NChar Pattern_Syntax Pat_Syn Pattern_White_Space Pat_WS Quotation_Mark QMark Radical Regional_Indicator RI Sentence_Terminal STerm Soft_Dotted SD Terminal_Punctuation Term Unified_Ideograph UIdeo Uppercase Upper Variation_Selector VS White_Space space XID_Continue XIDC XID_Start XIDS",De=Le+" Extended_Pictographic",je=De+" EBase EComp EMod EPres ExtPict",Fe={9:Le,10:De,11:De,12:je,13:je,14:je},Me={9:"",10:"",11:"",12:"",13:"",14:"Basic_Emoji Emoji_Keycap_Sequence RGI_Emoji_Modifier_Sequence RGI_Emoji_Flag_Sequence RGI_Emoji_Tag_Sequence RGI_Emoji_ZWJ_Sequence RGI_Emoji"},Ve="Cased_Letter LC Close_Punctuation Pe Connector_Punctuation Pc Control Cc cntrl Currency_Symbol Sc Dash_Punctuation Pd Decimal_Number Nd digit Enclosing_Mark Me Final_Punctuation Pf Format Cf Initial_Punctuation Pi Letter L Letter_Number Nl Line_Separator Zl Lowercase_Letter Ll Mark M Combining_Mark Math_Symbol Sm Modifier_Letter Lm Modifier_Symbol Sk Nonspacing_Mark Mn Number N Open_Punctuation Ps Other C Other_Letter Lo Other_Number No Other_Punctuation Po Other_Symbol So Paragraph_Separator Zp Private_Use Co Punctuation P punct Separator Z Space_Separator Zs Spacing_Mark Mc Surrogate Cs Symbol S Titlecase_Letter Lt Unassigned Cn Uppercase_Letter Lu",Be="Adlam Adlm Ahom Anatolian_Hieroglyphs Hluw Arabic Arab Armenian Armn Avestan Avst Balinese Bali Bamum Bamu Bassa_Vah Bass Batak Batk Bengali Beng Bhaiksuki Bhks Bopomofo Bopo Brahmi Brah Braille Brai Buginese Bugi Buhid Buhd Canadian_Aboriginal Cans Carian Cari Caucasian_Albanian Aghb Chakma Cakm Cham Cham Cherokee Cher Common Zyyy Coptic Copt Qaac Cuneiform Xsux Cypriot Cprt Cyrillic Cyrl Deseret Dsrt Devanagari Deva Duployan Dupl Egyptian_Hieroglyphs Egyp Elbasan Elba Ethiopic Ethi Georgian Geor Glagolitic Glag Gothic Goth Grantha Gran Greek Grek Gujarati Gujr Gurmukhi Guru Han Hani Hangul Hang Hanunoo Hano Hatran Hatr Hebrew Hebr Hiragana Hira Imperial_Aramaic Armi Inherited Zinh Qaai Inscriptional_Pahlavi Phli Inscriptional_Parthian Prti Javanese Java Kaithi Kthi Kannada Knda Katakana Kana Kayah_Li Kali Kharoshthi Khar Khmer Khmr Khojki Khoj Khudawadi Sind Lao Laoo Latin Latn Lepcha Lepc Limbu Limb Linear_A Lina Linear_B Linb Lisu Lisu Lycian Lyci Lydian Lydi Mahajani Mahj Malayalam Mlym Mandaic Mand Manichaean Mani Marchen Marc Masaram_Gondi Gonm Meetei_Mayek Mtei Mende_Kikakui Mend Meroitic_Cursive Merc Meroitic_Hieroglyphs Mero Miao Plrd Modi Mongolian Mong Mro Mroo Multani Mult Myanmar Mymr Nabataean Nbat New_Tai_Lue Talu Newa Newa Nko Nkoo Nushu Nshu Ogham Ogam Ol_Chiki Olck Old_Hungarian Hung Old_Italic Ital Old_North_Arabian Narb Old_Permic Perm Old_Persian Xpeo Old_South_Arabian Sarb Old_Turkic Orkh Oriya Orya Osage Osge Osmanya Osma Pahawh_Hmong Hmng Palmyrene Palm Pau_Cin_Hau Pauc Phags_Pa Phag Phoenician Phnx Psalter_Pahlavi Phlp Rejang Rjng Runic Runr Samaritan Samr Saurashtra Saur Sharada Shrd Shavian Shaw Siddham Sidd SignWriting Sgnw Sinhala Sinh Sora_Sompeng Sora Soyombo Soyo Sundanese Sund Syloti_Nagri Sylo Syriac Syrc Tagalog Tglg Tagbanwa Tagb Tai_Le Tale Tai_Tham Lana Tai_Viet Tavt Takri Takr Tamil Taml Tangut Tang Telugu Telu Thaana Thaa Thai Thai Tibetan Tibt Tifinagh Tfng Tirhuta Tirh Ugaritic Ugar Vai Vaii Warang_Citi Wara Yi Yiii Zanabazar_Square Zanb",Ue=Be+" Dogra Dogr Gunjala_Gondi Gong Hanifi_Rohingya Rohg Makasar Maka Medefaidrin Medf Old_Sogdian Sogo Sogdian Sogd",He=Ue+" Elymaic Elym Nandinagari Nand Nyiakeng_Puachue_Hmong Hmnp Wancho Wcho",qe=He+" Chorasmian Chrs Diak Dives_Akuru Khitan_Small_Script Kits Yezi Yezidi",$e=qe+" Cypro_Minoan Cpmn Old_Uyghur Ougr Tangsa Tnsa Toto Vithkuqi Vith",We={9:Be,10:Ue,11:He,12:qe,13:$e,14:$e+" Gara Garay Gukh Gurung_Khema Hrkt Katakana_Or_Hiragana Kawi Kirat_Rai Krai Nag_Mundari Nagm Ol_Onal Onao Sunu Sunuwar Todhri Todr Tulu_Tigalari Tutg Unknown Zzzz"},Ge={};function Ke(e){var t=Ge[e]={binary:O(Fe[e]+" "+Ve),binaryOfStrings:O(Me[e]),nonBinary:{General_Category:O(Ve),Script:O(We[e])}};t.nonBinary.Script_Extensions=t.nonBinary.Script,t.nonBinary.gc=t.nonBinary.General_Category,t.nonBinary.sc=t.nonBinary.Script,t.nonBinary.scx=t.nonBinary.Script_Extensions}for(var ze=0,Je=[9,10,11,12,13,14];ze<Je.length;ze+=1)Ke(Je[ze]);var Ye=oe.prototype,Qe=function(e,t){this.parent=e,this.base=t||this};Qe.prototype.separatedFrom=function(e){for(var t=this;t;t=t.parent)for(var n=e;n;n=n.parent)if(t.base===n.base&&t!==n)return!0;return!1},Qe.prototype.sibling=function(){return new Qe(this.parent,this.base)};var Xe=function(e){this.parser=e,this.validFlags="gim"+(e.options.ecmaVersion>=6?"uy":"")+(e.options.ecmaVersion>=9?"s":"")+(e.options.ecmaVersion>=13?"d":"")+(e.options.ecmaVersion>=15?"v":""),this.unicodeProperties=Ge[e.options.ecmaVersion>=14?14:e.options.ecmaVersion],this.source="",this.flags="",this.start=0,this.switchU=!1,this.switchV=!1,this.switchN=!1,this.pos=0,this.lastIntValue=0,this.lastStringValue="",this.lastAssertionIsQuantifiable=!1,this.numCapturingParens=0,this.maxBackReference=0,this.groupNames=Object.create(null),this.backReferenceNames=[],this.branchID=null};function Ze(e){for(var t in e)return!0;return!1}function et(e){return 105===e||109===e||115===e}function tt(e){return 36===e||e>=40&&e<=43||46===e||63===e||e>=91&&e<=94||e>=123&&e<=125}function nt(e){return h(e,!0)||36===e||95===e}function rt(e){return d(e,!0)||36===e||95===e||8204===e||8205===e}function it(e){return e>=65&&e<=90||e>=97&&e<=122}function st(e){return e>=0&&e<=1114111}Xe.prototype.reset=function(e,t,n){var r=-1!==n.indexOf("v"),i=-1!==n.indexOf("u");this.start=0|e,this.source=t+"",this.flags=n,r&&this.parser.options.ecmaVersion>=15?(this.switchU=!0,this.switchV=!0,this.switchN=!0):(this.switchU=i&&this.parser.options.ecmaVersion>=6,this.switchV=!1,this.switchN=i&&this.parser.options.ecmaVersion>=9)},Xe.prototype.raise=function(e){this.parser.raiseRecoverable(this.start,"Invalid regular expression: /"+this.source+"/: "+e)},Xe.prototype.at=function(e,t){void 0===t&&(t=!1);var n=this.source,r=n.length;if(e>=r)return-1;var i=n.charCodeAt(e);if(!t&&!this.switchU||i<=55295||i>=57344||e+1>=r)return i;var s=n.charCodeAt(e+1);return s>=56320&&s<=57343?(i<<10)+s-56613888:i},Xe.prototype.nextIndex=function(e,t){void 0===t&&(t=!1);var n=this.source,r=n.length;if(e>=r)return r;var i,s=n.charCodeAt(e);return!t&&!this.switchU||s<=55295||s>=57344||e+1>=r||(i=n.charCodeAt(e+1))<56320||i>57343?e+1:e+2},Xe.prototype.current=function(e){return void 0===e&&(e=!1),this.at(this.pos,e)},Xe.prototype.lookahead=function(e){return void 0===e&&(e=!1),this.at(this.nextIndex(this.pos,e),e)},Xe.prototype.advance=function(e){void 0===e&&(e=!1),this.pos=this.nextIndex(this.pos,e)},Xe.prototype.eat=function(e,t){return void 0===t&&(t=!1),this.current(t)===e&&(this.advance(t),!0)},Xe.prototype.eatChars=function(e,t){void 0===t&&(t=!1);for(var n=this.pos,r=0,i=e;r<i.length;r+=1){var s=i[r],o=this.at(n,t);if(-1===o||o!==s)return!1;n=this.nextIndex(n,t)}return this.pos=n,!0},Ye.validateRegExpFlags=function(e){for(var t=e.validFlags,n=e.flags,r=!1,i=!1,s=0;s<n.length;s++){var o=n.charAt(s);-1===t.indexOf(o)&&this.raise(e.start,"Invalid regular expression flag"),n.indexOf(o,s+1)>-1&&this.raise(e.start,"Duplicate regular expression flag"),"u"===o&&(r=!0),"v"===o&&(i=!0)}this.options.ecmaVersion>=15&&r&&i&&this.raise(e.start,"Invalid regular expression flag")},Ye.validateRegExpPattern=function(e){this.regexp_pattern(e),!e.switchN&&this.options.ecmaVersion>=9&&Ze(e.groupNames)&&(e.switchN=!0,this.regexp_pattern(e))},Ye.regexp_pattern=function(e){e.pos=0,e.lastIntValue=0,e.lastStringValue="",e.lastAssertionIsQuantifiable=!1,e.numCapturingParens=0,e.maxBackReference=0,e.groupNames=Object.create(null),e.backReferenceNames.length=0,e.branchID=null,this.regexp_disjunction(e),e.pos!==e.source.length&&(e.eat(41)&&e.raise("Unmatched ')'"),(e.eat(93)||e.eat(125))&&e.raise("Lone quantifier brackets")),e.maxBackReference>e.numCapturingParens&&e.raise("Invalid escape");for(var t=0,n=e.backReferenceNames;t<n.length;t+=1){var r=n[t];e.groupNames[r]||e.raise("Invalid named capture referenced")}},Ye.regexp_disjunction=function(e){var t=this.options.ecmaVersion>=16;for(t&&(e.branchID=new Qe(e.branchID,null)),this.regexp_alternative(e);e.eat(124);)t&&(e.branchID=e.branchID.sibling()),this.regexp_alternative(e);t&&(e.branchID=e.branchID.parent),this.regexp_eatQuantifier(e,!0)&&e.raise("Nothing to repeat"),e.eat(123)&&e.raise("Lone quantifier brackets")},Ye.regexp_alternative=function(e){for(;e.pos<e.source.length&&this.regexp_eatTerm(e););},Ye.regexp_eatTerm=function(e){return this.regexp_eatAssertion(e)?(e.lastAssertionIsQuantifiable&&this.regexp_eatQuantifier(e)&&e.switchU&&e.raise("Invalid quantifier"),!0):!!(e.switchU?this.regexp_eatAtom(e):this.regexp_eatExtendedAtom(e))&&(this.regexp_eatQuantifier(e),!0)},Ye.regexp_eatAssertion=function(e){var t=e.pos;if(e.lastAssertionIsQuantifiable=!1,e.eat(94)||e.eat(36))return!0;if(e.eat(92)){if(e.eat(66)||e.eat(98))return!0;e.pos=t}if(e.eat(40)&&e.eat(63)){var n=!1;if(this.options.ecmaVersion>=9&&(n=e.eat(60)),e.eat(61)||e.eat(33))return this.regexp_disjunction(e),e.eat(41)||e.raise("Unterminated group"),e.lastAssertionIsQuantifiable=!n,!0}return e.pos=t,!1},Ye.regexp_eatQuantifier=function(e,t){return void 0===t&&(t=!1),!!this.regexp_eatQuantifierPrefix(e,t)&&(e.eat(63),!0)},Ye.regexp_eatQuantifierPrefix=function(e,t){return e.eat(42)||e.eat(43)||e.eat(63)||this.regexp_eatBracedQuantifier(e,t)},Ye.regexp_eatBracedQuantifier=function(e,t){var n=e.pos;if(e.eat(123)){var r=0,i=-1;if(this.regexp_eatDecimalDigits(e)&&(r=e.lastIntValue,e.eat(44)&&this.regexp_eatDecimalDigits(e)&&(i=e.lastIntValue),e.eat(125)))return-1!==i&&i<r&&!t&&e.raise("numbers out of order in {} quantifier"),!0;e.switchU&&!t&&e.raise("Incomplete quantifier"),e.pos=n}return!1},Ye.regexp_eatAtom=function(e){return this.regexp_eatPatternCharacters(e)||e.eat(46)||this.regexp_eatReverseSolidusAtomEscape(e)||this.regexp_eatCharacterClass(e)||this.regexp_eatUncapturingGroup(e)||this.regexp_eatCapturingGroup(e)},Ye.regexp_eatReverseSolidusAtomEscape=function(e){var t=e.pos;if(e.eat(92)){if(this.regexp_eatAtomEscape(e))return!0;e.pos=t}return!1},Ye.regexp_eatUncapturingGroup=function(e){var t=e.pos;if(e.eat(40)){if(e.eat(63)){if(this.options.ecmaVersion>=16){var n=this.regexp_eatModifiers(e),r=e.eat(45);if(n||r){for(var i=0;i<n.length;i++){var s=n.charAt(i);n.indexOf(s,i+1)>-1&&e.raise("Duplicate regular expression modifiers")}if(r){var o=this.regexp_eatModifiers(e);n||o||58!==e.current()||e.raise("Invalid regular expression modifiers");for(var a=0;a<o.length;a++){var c=o.charAt(a);(o.indexOf(c,a+1)>-1||n.indexOf(c)>-1)&&e.raise("Duplicate regular expression modifiers")}}}}if(e.eat(58)){if(this.regexp_disjunction(e),e.eat(41))return!0;e.raise("Unterminated group")}}e.pos=t}return!1},Ye.regexp_eatCapturingGroup=function(e){if(e.eat(40)){if(this.options.ecmaVersion>=9?this.regexp_groupSpecifier(e):63===e.current()&&e.raise("Invalid group"),this.regexp_disjunction(e),e.eat(41))return e.numCapturingParens+=1,!0;e.raise("Unterminated group")}return!1},Ye.regexp_eatModifiers=function(e){for(var t="",n=0;-1!==(n=e.current())&&et(n);)t+=L(n),e.advance();return t},Ye.regexp_eatExtendedAtom=function(e){return e.eat(46)||this.regexp_eatReverseSolidusAtomEscape(e)||this.regexp_eatCharacterClass(e)||this.regexp_eatUncapturingGroup(e)||this.regexp_eatCapturingGroup(e)||this.regexp_eatInvalidBracedQuantifier(e)||this.regexp_eatExtendedPatternCharacter(e)},Ye.regexp_eatInvalidBracedQuantifier=function(e){return this.regexp_eatBracedQuantifier(e,!0)&&e.raise("Nothing to repeat"),!1},Ye.regexp_eatSyntaxCharacter=function(e){var t=e.current();return!!tt(t)&&(e.lastIntValue=t,e.advance(),!0)},Ye.regexp_eatPatternCharacters=function(e){for(var t=e.pos,n=0;-1!==(n=e.current())&&!tt(n);)e.advance();return e.pos!==t},Ye.regexp_eatExtendedPatternCharacter=function(e){var t=e.current();return!(-1===t||36===t||t>=40&&t<=43||46===t||63===t||91===t||94===t||124===t||(e.advance(),0))},Ye.regexp_groupSpecifier=function(e){if(e.eat(63)){this.regexp_eatGroupName(e)||e.raise("Invalid group");var t=this.options.ecmaVersion>=16,n=e.groupNames[e.lastStringValue];if(n)if(t)for(var r=0,i=n;r<i.length;r+=1)i[r].separatedFrom(e.branchID)||e.raise("Duplicate capture group name");else e.raise("Duplicate capture group name");t?(n||(e.groupNames[e.lastStringValue]=[])).push(e.branchID):e.groupNames[e.lastStringValue]=!0}},Ye.regexp_eatGroupName=function(e){if(e.lastStringValue="",e.eat(60)){if(this.regexp_eatRegExpIdentifierName(e)&&e.eat(62))return!0;e.raise("Invalid capture group name")}return!1},Ye.regexp_eatRegExpIdentifierName=function(e){if(e.lastStringValue="",this.regexp_eatRegExpIdentifierStart(e)){for(e.lastStringValue+=L(e.lastIntValue);this.regexp_eatRegExpIdentifierPart(e);)e.lastStringValue+=L(e.lastIntValue);return!0}return!1},Ye.regexp_eatRegExpIdentifierStart=function(e){var t=e.pos,n=this.options.ecmaVersion>=11,r=e.current(n);return e.advance(n),92===r&&this.regexp_eatRegExpUnicodeEscapeSequence(e,n)&&(r=e.lastIntValue),nt(r)?(e.lastIntValue=r,!0):(e.pos=t,!1)},Ye.regexp_eatRegExpIdentifierPart=function(e){var t=e.pos,n=this.options.ecmaVersion>=11,r=e.current(n);return e.advance(n),92===r&&this.regexp_eatRegExpUnicodeEscapeSequence(e,n)&&(r=e.lastIntValue),rt(r)?(e.lastIntValue=r,!0):(e.pos=t,!1)},Ye.regexp_eatAtomEscape=function(e){return!!(this.regexp_eatBackReference(e)||this.regexp_eatCharacterClassEscape(e)||this.regexp_eatCharacterEscape(e)||e.switchN&&this.regexp_eatKGroupName(e))||(e.switchU&&(99===e.current()&&e.raise("Invalid unicode escape"),e.raise("Invalid escape")),!1)},Ye.regexp_eatBackReference=function(e){var t=e.pos;if(this.regexp_eatDecimalEscape(e)){var n=e.lastIntValue;if(e.switchU)return n>e.maxBackReference&&(e.maxBackReference=n),!0;if(n<=e.numCapturingParens)return!0;e.pos=t}return!1},Ye.regexp_eatKGroupName=function(e){if(e.eat(107)){if(this.regexp_eatGroupName(e))return e.backReferenceNames.push(e.lastStringValue),!0;e.raise("Invalid named reference")}return!1},Ye.regexp_eatCharacterEscape=function(e){return this.regexp_eatControlEscape(e)||this.regexp_eatCControlLetter(e)||this.regexp_eatZero(e)||this.regexp_eatHexEscapeSequence(e)||this.regexp_eatRegExpUnicodeEscapeSequence(e,!1)||!e.switchU&&this.regexp_eatLegacyOctalEscapeSequence(e)||this.regexp_eatIdentityEscape(e)},Ye.regexp_eatCControlLetter=function(e){var t=e.pos;if(e.eat(99)){if(this.regexp_eatControlLetter(e))return!0;e.pos=t}return!1},Ye.regexp_eatZero=function(e){return 48===e.current()&&!mt(e.lookahead())&&(e.lastIntValue=0,e.advance(),!0)},Ye.regexp_eatControlEscape=function(e){var t=e.current();return 116===t?(e.lastIntValue=9,e.advance(),!0):110===t?(e.lastIntValue=10,e.advance(),!0):118===t?(e.lastIntValue=11,e.advance(),!0):102===t?(e.lastIntValue=12,e.advance(),!0):114===t&&(e.lastIntValue=13,e.advance(),!0)},Ye.regexp_eatControlLetter=function(e){var t=e.current();return!!it(t)&&(e.lastIntValue=t%32,e.advance(),!0)},Ye.regexp_eatRegExpUnicodeEscapeSequence=function(e,t){void 0===t&&(t=!1);var n=e.pos,r=t||e.switchU;if(e.eat(117)){if(this.regexp_eatFixedHexDigits(e,4)){var i=e.lastIntValue;if(r&&i>=55296&&i<=56319){var s=e.pos;if(e.eat(92)&&e.eat(117)&&this.regexp_eatFixedHexDigits(e,4)){var o=e.lastIntValue;if(o>=56320&&o<=57343)return e.lastIntValue=1024*(i-55296)+(o-56320)+65536,!0}e.pos=s,e.lastIntValue=i}return!0}if(r&&e.eat(123)&&this.regexp_eatHexDigits(e)&&e.eat(125)&&st(e.lastIntValue))return!0;r&&e.raise("Invalid unicode escape"),e.pos=n}return!1},Ye.regexp_eatIdentityEscape=function(e){if(e.switchU)return!!this.regexp_eatSyntaxCharacter(e)||!!e.eat(47)&&(e.lastIntValue=47,!0);var t=e.current();return!(99===t||e.switchN&&107===t||(e.lastIntValue=t,e.advance(),0))},Ye.regexp_eatDecimalEscape=function(e){e.lastIntValue=0;var t=e.current();if(t>=49&&t<=57){do{e.lastIntValue=10*e.lastIntValue+(t-48),e.advance()}while((t=e.current())>=48&&t<=57);return!0}return!1};var ot=0,at=1,ct=2;function lt(e){return 100===e||68===e||115===e||83===e||119===e||87===e}function pt(e){return it(e)||95===e}function ut(e){return pt(e)||mt(e)}function ht(e){return 33===e||e>=35&&e<=38||e>=42&&e<=44||46===e||e>=58&&e<=64||94===e||96===e||126===e}function dt(e){return 40===e||41===e||45===e||47===e||e>=91&&e<=93||e>=123&&e<=125}function ft(e){return 33===e||35===e||37===e||38===e||44===e||45===e||e>=58&&e<=62||64===e||96===e||126===e}function mt(e){return e>=48&&e<=57}function gt(e){return e>=48&&e<=57||e>=65&&e<=70||e>=97&&e<=102}function vt(e){return e>=65&&e<=70?e-65+10:e>=97&&e<=102?e-97+10:e-48}function yt(e){return e>=48&&e<=55}Ye.regexp_eatCharacterClassEscape=function(e){var t=e.current();if(lt(t))return e.lastIntValue=-1,e.advance(),at;var n=!1;if(e.switchU&&this.options.ecmaVersion>=9&&((n=80===t)||112===t)){var r;if(e.lastIntValue=-1,e.advance(),e.eat(123)&&(r=this.regexp_eatUnicodePropertyValueExpression(e))&&e.eat(125))return n&&r===ct&&e.raise("Invalid property name"),r;e.raise("Invalid property name")}return ot},Ye.regexp_eatUnicodePropertyValueExpression=function(e){var t=e.pos;if(this.regexp_eatUnicodePropertyName(e)&&e.eat(61)){var n=e.lastStringValue;if(this.regexp_eatUnicodePropertyValue(e)){var r=e.lastStringValue;return this.regexp_validateUnicodePropertyNameAndValue(e,n,r),at}}if(e.pos=t,this.regexp_eatLoneUnicodePropertyNameOrValue(e)){var i=e.lastStringValue;return this.regexp_validateUnicodePropertyNameOrValue(e,i)}return ot},Ye.regexp_validateUnicodePropertyNameAndValue=function(e,t,n){I(e.unicodeProperties.nonBinary,t)||e.raise("Invalid property name"),e.unicodeProperties.nonBinary[t].test(n)||e.raise("Invalid property value")},Ye.regexp_validateUnicodePropertyNameOrValue=function(e,t){return e.unicodeProperties.binary.test(t)?at:e.switchV&&e.unicodeProperties.binaryOfStrings.test(t)?ct:void e.raise("Invalid property name")},Ye.regexp_eatUnicodePropertyName=function(e){var t=0;for(e.lastStringValue="";pt(t=e.current());)e.lastStringValue+=L(t),e.advance();return""!==e.lastStringValue},Ye.regexp_eatUnicodePropertyValue=function(e){var t=0;for(e.lastStringValue="";ut(t=e.current());)e.lastStringValue+=L(t),e.advance();return""!==e.lastStringValue},Ye.regexp_eatLoneUnicodePropertyNameOrValue=function(e){return this.regexp_eatUnicodePropertyValue(e)},Ye.regexp_eatCharacterClass=function(e){if(e.eat(91)){var t=e.eat(94),n=this.regexp_classContents(e);return e.eat(93)||e.raise("Unterminated character class"),t&&n===ct&&e.raise("Negated character class may contain strings"),!0}return!1},Ye.regexp_classContents=function(e){return 93===e.current()?at:e.switchV?this.regexp_classSetExpression(e):(this.regexp_nonEmptyClassRanges(e),at)},Ye.regexp_nonEmptyClassRanges=function(e){for(;this.regexp_eatClassAtom(e);){var t=e.lastIntValue;if(e.eat(45)&&this.regexp_eatClassAtom(e)){var n=e.lastIntValue;!e.switchU||-1!==t&&-1!==n||e.raise("Invalid character class"),-1!==t&&-1!==n&&t>n&&e.raise("Range out of order in character class")}}},Ye.regexp_eatClassAtom=function(e){var t=e.pos;if(e.eat(92)){if(this.regexp_eatClassEscape(e))return!0;if(e.switchU){var n=e.current();(99===n||yt(n))&&e.raise("Invalid class escape"),e.raise("Invalid escape")}e.pos=t}var r=e.current();return 93!==r&&(e.lastIntValue=r,e.advance(),!0)},Ye.regexp_eatClassEscape=function(e){var t=e.pos;if(e.eat(98))return e.lastIntValue=8,!0;if(e.switchU&&e.eat(45))return e.lastIntValue=45,!0;if(!e.switchU&&e.eat(99)){if(this.regexp_eatClassControlLetter(e))return!0;e.pos=t}return this.regexp_eatCharacterClassEscape(e)||this.regexp_eatCharacterEscape(e)},Ye.regexp_classSetExpression=function(e){var t,n=at;if(this.regexp_eatClassSetRange(e));else if(t=this.regexp_eatClassSetOperand(e)){t===ct&&(n=ct);for(var r=e.pos;e.eatChars([38,38]);)38!==e.current()&&(t=this.regexp_eatClassSetOperand(e))?t!==ct&&(n=at):e.raise("Invalid character in character class");if(r!==e.pos)return n;for(;e.eatChars([45,45]);)this.regexp_eatClassSetOperand(e)||e.raise("Invalid character in character class");if(r!==e.pos)return n}else e.raise("Invalid character in character class");for(;;)if(!this.regexp_eatClassSetRange(e)){if(!(t=this.regexp_eatClassSetOperand(e)))return n;t===ct&&(n=ct)}},Ye.regexp_eatClassSetRange=function(e){var t=e.pos;if(this.regexp_eatClassSetCharacter(e)){var n=e.lastIntValue;if(e.eat(45)&&this.regexp_eatClassSetCharacter(e)){var r=e.lastIntValue;return-1!==n&&-1!==r&&n>r&&e.raise("Range out of order in character class"),!0}e.pos=t}return!1},Ye.regexp_eatClassSetOperand=function(e){return this.regexp_eatClassSetCharacter(e)?at:this.regexp_eatClassStringDisjunction(e)||this.regexp_eatNestedClass(e)},Ye.regexp_eatNestedClass=function(e){var t=e.pos;if(e.eat(91)){var n=e.eat(94),r=this.regexp_classContents(e);if(e.eat(93))return n&&r===ct&&e.raise("Negated character class may contain strings"),r;e.pos=t}if(e.eat(92)){var i=this.regexp_eatCharacterClassEscape(e);if(i)return i;e.pos=t}return null},Ye.regexp_eatClassStringDisjunction=function(e){var t=e.pos;if(e.eatChars([92,113])){if(e.eat(123)){var n=this.regexp_classStringDisjunctionContents(e);if(e.eat(125))return n}else e.raise("Invalid escape");e.pos=t}return null},Ye.regexp_classStringDisjunctionContents=function(e){for(var t=this.regexp_classString(e);e.eat(124);)this.regexp_classString(e)===ct&&(t=ct);return t},Ye.regexp_classString=function(e){for(var t=0;this.regexp_eatClassSetCharacter(e);)t++;return 1===t?at:ct},Ye.regexp_eatClassSetCharacter=function(e){var t=e.pos;if(e.eat(92))return!(!this.regexp_eatCharacterEscape(e)&&!this.regexp_eatClassSetReservedPunctuator(e)&&(e.eat(98)?(e.lastIntValue=8,0):(e.pos=t,1)));var n=e.current();return!(n<0||n===e.lookahead()&&ht(n)||dt(n)||(e.advance(),e.lastIntValue=n,0))},Ye.regexp_eatClassSetReservedPunctuator=function(e){var t=e.current();return!!ft(t)&&(e.lastIntValue=t,e.advance(),!0)},Ye.regexp_eatClassControlLetter=function(e){var t=e.current();return!(!mt(t)&&95!==t||(e.lastIntValue=t%32,e.advance(),0))},Ye.regexp_eatHexEscapeSequence=function(e){var t=e.pos;if(e.eat(120)){if(this.regexp_eatFixedHexDigits(e,2))return!0;e.switchU&&e.raise("Invalid escape"),e.pos=t}return!1},Ye.regexp_eatDecimalDigits=function(e){var t=e.pos,n=0;for(e.lastIntValue=0;mt(n=e.current());)e.lastIntValue=10*e.lastIntValue+(n-48),e.advance();return e.pos!==t},Ye.regexp_eatHexDigits=function(e){var t=e.pos,n=0;for(e.lastIntValue=0;gt(n=e.current());)e.lastIntValue=16*e.lastIntValue+vt(n),e.advance();return e.pos!==t},Ye.regexp_eatLegacyOctalEscapeSequence=function(e){if(this.regexp_eatOctalDigit(e)){var t=e.lastIntValue;if(this.regexp_eatOctalDigit(e)){var n=e.lastIntValue;t<=3&&this.regexp_eatOctalDigit(e)?e.lastIntValue=64*t+8*n+e.lastIntValue:e.lastIntValue=8*t+n}else e.lastIntValue=t;return!0}return!1},Ye.regexp_eatOctalDigit=function(e){var t=e.current();return yt(t)?(e.lastIntValue=t-48,e.advance(),!0):(e.lastIntValue=0,!1)},Ye.regexp_eatFixedHexDigits=function(e,t){var n=e.pos;e.lastIntValue=0;for(var r=0;r<t;++r){var i=e.current();if(!gt(i))return e.pos=n,!1;e.lastIntValue=16*e.lastIntValue+vt(i),e.advance()}return!0};var xt=function(e){this.type=e.type,this.value=e.value,this.start=e.start,this.end=e.end,e.options.locations&&(this.loc=new F(e,e.startLoc,e.endLoc)),e.options.ranges&&(this.range=[e.start,e.end])},Et=oe.prototype;function St(e,t){return t?parseInt(e,8):parseFloat(e.replace(/_/g,""))}function wt(e){return"function"!=typeof BigInt?null:BigInt(e.replace(/_/g,""))}Et.next=function(e){!e&&this.type.keyword&&this.containsEsc&&this.raiseRecoverable(this.start,"Escape sequence in keyword "+this.type.keyword),this.options.onToken&&this.options.onToken(new xt(this)),this.lastTokEnd=this.end,this.lastTokStart=this.start,this.lastTokEndLoc=this.endLoc,this.lastTokStartLoc=this.startLoc,this.nextToken()},Et.getToken=function(){return this.next(),new xt(this)},"undefined"!=typeof Symbol&&(Et[Symbol.iterator]=function(){var e=this;return{next:function(){var t=e.getToken();return{done:t.type===E.eof,value:t}}}}),Et.nextToken=function(){var e=this.curContext();return e&&e.preserveSpace||this.skipSpace(),this.start=this.pos,this.options.locations&&(this.startLoc=this.curPosition()),this.pos>=this.input.length?this.finishToken(E.eof):e.override?e.override(this):void this.readToken(this.fullCharCodeAtPos())},Et.readToken=function(e){return h(e,this.options.ecmaVersion>=6)||92===e?this.readWord():this.getTokenFromCode(e)},Et.fullCharCodeAtPos=function(){var e=this.input.charCodeAt(this.pos);if(e<=55295||e>=56320)return e;var t=this.input.charCodeAt(this.pos+1);return t<=56319||t>=57344?e:(e<<10)+t-56613888},Et.skipBlockComment=function(){var e=this.options.onComment&&this.curPosition(),t=this.pos,n=this.input.indexOf("*/",this.pos+=2);if(-1===n&&this.raise(this.pos-2,"Unterminated comment"),this.pos=n+2,this.options.locations)for(var r=void 0,i=t;(r=_(this.input,i,this.pos))>-1;)++this.curLine,i=this.lineStart=r;this.options.onComment&&this.options.onComment(!0,this.input.slice(t+2,n),t,this.pos,e,this.curPosition())},Et.skipLineComment=function(e){for(var t=this.pos,n=this.options.onComment&&this.curPosition(),r=this.input.charCodeAt(this.pos+=e);this.pos<this.input.length&&!b(r);)r=this.input.charCodeAt(++this.pos);this.options.onComment&&this.options.onComment(!1,this.input.slice(t+e,this.pos),t,this.pos,n,this.curPosition())},Et.skipSpace=function(){e:for(;this.pos<this.input.length;){var e=this.input.charCodeAt(this.pos);switch(e){case 32:case 160:++this.pos;break;case 13:10===this.input.charCodeAt(this.pos+1)&&++this.pos;case 10:case 8232:case 8233:++this.pos,this.options.locations&&(++this.curLine,this.lineStart=this.pos);break;case 47:switch(this.input.charCodeAt(this.pos+1)){case 42:this.skipBlockComment();break;case 47:this.skipLineComment(2);break;default:break e}break;default:if(!(e>8&&e<14||e>=5760&&k.test(String.fromCharCode(e))))break e;++this.pos}}},Et.finishToken=function(e,t){this.end=this.pos,this.options.locations&&(this.endLoc=this.curPosition());var n=this.type;this.type=e,this.value=t,this.updateContext(n)},Et.readToken_dot=function(){var e=this.input.charCodeAt(this.pos+1);if(e>=48&&e<=57)return this.readNumber(!0);var t=this.input.charCodeAt(this.pos+2);return this.options.ecmaVersion>=6&&46===e&&46===t?(this.pos+=3,this.finishToken(E.ellipsis)):(++this.pos,this.finishToken(E.dot))},Et.readToken_slash=function(){var e=this.input.charCodeAt(this.pos+1);return this.exprAllowed?(++this.pos,this.readRegexp()):61===e?this.finishOp(E.assign,2):this.finishOp(E.slash,1)},Et.readToken_mult_modulo_exp=function(e){var t=this.input.charCodeAt(this.pos+1),n=1,r=42===e?E.star:E.modulo;return this.options.ecmaVersion>=7&&42===e&&42===t&&(++n,r=E.starstar,t=this.input.charCodeAt(this.pos+2)),61===t?this.finishOp(E.assign,n+1):this.finishOp(r,n)},Et.readToken_pipe_amp=function(e){var t=this.input.charCodeAt(this.pos+1);return t===e?this.options.ecmaVersion>=12&&61===this.input.charCodeAt(this.pos+2)?this.finishOp(E.assign,3):this.finishOp(124===e?E.logicalOR:E.logicalAND,2):61===t?this.finishOp(E.assign,2):this.finishOp(124===e?E.bitwiseOR:E.bitwiseAND,1)},Et.readToken_caret=function(){return 61===this.input.charCodeAt(this.pos+1)?this.finishOp(E.assign,2):this.finishOp(E.bitwiseXOR,1)},Et.readToken_plus_min=function(e){var t=this.input.charCodeAt(this.pos+1);return t===e?45!==t||this.inModule||62!==this.input.charCodeAt(this.pos+2)||0!==this.lastTokEnd&&!S.test(this.input.slice(this.lastTokEnd,this.pos))?this.finishOp(E.incDec,2):(this.skipLineComment(3),this.skipSpace(),this.nextToken()):61===t?this.finishOp(E.assign,2):this.finishOp(E.plusMin,1)},Et.readToken_lt_gt=function(e){var t=this.input.charCodeAt(this.pos+1),n=1;return t===e?(n=62===e&&62===this.input.charCodeAt(this.pos+2)?3:2,61===this.input.charCodeAt(this.pos+n)?this.finishOp(E.assign,n+1):this.finishOp(E.bitShift,n)):33!==t||60!==e||this.inModule||45!==this.input.charCodeAt(this.pos+2)||45!==this.input.charCodeAt(this.pos+3)?(61===t&&(n=2),this.finishOp(E.relational,n)):(this.skipLineComment(4),this.skipSpace(),this.nextToken())},Et.readToken_eq_excl=function(e){var t=this.input.charCodeAt(this.pos+1);return 61===t?this.finishOp(E.equality,61===this.input.charCodeAt(this.pos+2)?3:2):61===e&&62===t&&this.options.ecmaVersion>=6?(this.pos+=2,this.finishToken(E.arrow)):this.finishOp(61===e?E.eq:E.prefix,1)},Et.readToken_question=function(){var e=this.options.ecmaVersion;if(e>=11){var t=this.input.charCodeAt(this.pos+1);if(46===t){var n=this.input.charCodeAt(this.pos+2);if(n<48||n>57)return this.finishOp(E.questionDot,2)}if(63===t)return e>=12&&61===this.input.charCodeAt(this.pos+2)?this.finishOp(E.assign,3):this.finishOp(E.coalesce,2)}return this.finishOp(E.question,1)},Et.readToken_numberSign=function(){var e=35;if(this.options.ecmaVersion>=13&&(++this.pos,h(e=this.fullCharCodeAtPos(),!0)||92===e))return this.finishToken(E.privateId,this.readWord1());this.raise(this.pos,"Unexpected character '"+L(e)+"'")},Et.getTokenFromCode=function(e){switch(e){case 46:return this.readToken_dot();case 40:return++this.pos,this.finishToken(E.parenL);case 41:return++this.pos,this.finishToken(E.parenR);case 59:return++this.pos,this.finishToken(E.semi);case 44:return++this.pos,this.finishToken(E.comma);case 91:return++this.pos,this.finishToken(E.bracketL);case 93:return++this.pos,this.finishToken(E.bracketR);case 123:return++this.pos,this.finishToken(E.braceL);case 125:return++this.pos,this.finishToken(E.braceR);case 58:return++this.pos,this.finishToken(E.colon);case 96:if(this.options.ecmaVersion<6)break;return++this.pos,this.finishToken(E.backQuote);case 48:var t=this.input.charCodeAt(this.pos+1);if(120===t||88===t)return this.readRadixNumber(16);if(this.options.ecmaVersion>=6){if(111===t||79===t)return this.readRadixNumber(8);if(98===t||66===t)return this.readRadixNumber(2)}case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return this.readNumber(!1);case 34:case 39:return this.readString(e);case 47:return this.readToken_slash();case 37:case 42:return this.readToken_mult_modulo_exp(e);case 124:case 38:return this.readToken_pipe_amp(e);case 94:return this.readToken_caret();case 43:case 45:return this.readToken_plus_min(e);case 60:case 62:return this.readToken_lt_gt(e);case 61:case 33:return this.readToken_eq_excl(e);case 63:return this.readToken_question();case 126:return this.finishOp(E.prefix,1);case 35:return this.readToken_numberSign()}this.raise(this.pos,"Unexpected character '"+L(e)+"'")},Et.finishOp=function(e,t){var n=this.input.slice(this.pos,this.pos+t);return this.pos+=t,this.finishToken(e,n)},Et.readRegexp=function(){for(var e,t,n=this.pos;;){this.pos>=this.input.length&&this.raise(n,"Unterminated regular expression");var r=this.input.charAt(this.pos);if(S.test(r)&&this.raise(n,"Unterminated regular expression"),e)e=!1;else{if("["===r)t=!0;else if("]"===r&&t)t=!1;else if("/"===r&&!t)break;e="\\"===r}++this.pos}var i=this.input.slice(n,this.pos);++this.pos;var s=this.pos,o=this.readWord1();this.containsEsc&&this.unexpected(s);var a=this.regexpState||(this.regexpState=new Xe(this));a.reset(n,i,o),this.validateRegExpFlags(a),this.validateRegExpPattern(a);var c=null;try{c=new RegExp(i,o)}catch(e){}return this.finishToken(E.regexp,{pattern:i,flags:o,value:c})},Et.readInt=function(e,t,n){for(var r=this.options.ecmaVersion>=12&&void 0===t,i=n&&48===this.input.charCodeAt(this.pos),s=this.pos,o=0,a=0,c=0,l=null==t?1/0:t;c<l;++c,++this.pos){var p=this.input.charCodeAt(this.pos),u=void 0;if(r&&95===p)i&&this.raiseRecoverable(this.pos,"Numeric separator is not allowed in legacy octal numeric literals"),95===a&&this.raiseRecoverable(this.pos,"Numeric separator must be exactly one underscore"),0===c&&this.raiseRecoverable(this.pos,"Numeric separator is not allowed at the first of digits"),a=p;else{if((u=p>=97?p-97+10:p>=65?p-65+10:p>=48&&p<=57?p-48:1/0)>=e)break;a=p,o=o*e+u}}return r&&95===a&&this.raiseRecoverable(this.pos-1,"Numeric separator is not allowed at the last of digits"),this.pos===s||null!=t&&this.pos-s!==t?null:o},Et.readRadixNumber=function(e){var t=this.pos;this.pos+=2;var n=this.readInt(e);return null==n&&this.raise(this.start+2,"Expected number in radix "+e),this.options.ecmaVersion>=11&&110===this.input.charCodeAt(this.pos)?(n=wt(this.input.slice(t,this.pos)),++this.pos):h(this.fullCharCodeAtPos())&&this.raise(this.pos,"Identifier directly after number"),this.finishToken(E.num,n)},Et.readNumber=function(e){var t=this.pos;e||null!==this.readInt(10,void 0,!0)||this.raise(t,"Invalid number");var n=this.pos-t>=2&&48===this.input.charCodeAt(t);n&&this.strict&&this.raise(t,"Invalid number");var r=this.input.charCodeAt(this.pos);if(!n&&!e&&this.options.ecmaVersion>=11&&110===r){var i=wt(this.input.slice(t,this.pos));return++this.pos,h(this.fullCharCodeAtPos())&&this.raise(this.pos,"Identifier directly after number"),this.finishToken(E.num,i)}n&&/[89]/.test(this.input.slice(t,this.pos))&&(n=!1),46!==r||n||(++this.pos,this.readInt(10),r=this.input.charCodeAt(this.pos)),69!==r&&101!==r||n||(43!==(r=this.input.charCodeAt(++this.pos))&&45!==r||++this.pos,null===this.readInt(10)&&this.raise(t,"Invalid number")),h(this.fullCharCodeAtPos())&&this.raise(this.pos,"Identifier directly after number");var s=St(this.input.slice(t,this.pos),n);return this.finishToken(E.num,s)},Et.readCodePoint=function(){var e;if(123===this.input.charCodeAt(this.pos)){this.options.ecmaVersion<6&&this.unexpected();var t=++this.pos;e=this.readHexChar(this.input.indexOf("}",this.pos)-this.pos),++this.pos,e>1114111&&this.invalidStringToken(t,"Code point out of bounds")}else e=this.readHexChar(4);return e},Et.readString=function(e){for(var t="",n=++this.pos;;){this.pos>=this.input.length&&this.raise(this.start,"Unterminated string constant");var r=this.input.charCodeAt(this.pos);if(r===e)break;92===r?(t+=this.input.slice(n,this.pos),t+=this.readEscapedChar(!1),n=this.pos):8232===r||8233===r?(this.options.ecmaVersion<10&&this.raise(this.start,"Unterminated string constant"),++this.pos,this.options.locations&&(this.curLine++,this.lineStart=this.pos)):(b(r)&&this.raise(this.start,"Unterminated string constant"),++this.pos)}return t+=this.input.slice(n,this.pos++),this.finishToken(E.string,t)};var bt={};Et.tryReadTemplateToken=function(){this.inTemplateElement=!0;try{this.readTmplToken()}catch(e){if(e!==bt)throw e;this.readInvalidTemplateToken()}this.inTemplateElement=!1},Et.invalidStringToken=function(e,t){if(this.inTemplateElement&&this.options.ecmaVersion>=9)throw bt;this.raise(e,t)},Et.readTmplToken=function(){for(var e="",t=this.pos;;){this.pos>=this.input.length&&this.raise(this.start,"Unterminated template");var n=this.input.charCodeAt(this.pos);if(96===n||36===n&&123===this.input.charCodeAt(this.pos+1))return this.pos!==this.start||this.type!==E.template&&this.type!==E.invalidTemplate?(e+=this.input.slice(t,this.pos),this.finishToken(E.template,e)):36===n?(this.pos+=2,this.finishToken(E.dollarBraceL)):(++this.pos,this.finishToken(E.backQuote));if(92===n)e+=this.input.slice(t,this.pos),e+=this.readEscapedChar(!0),t=this.pos;else if(b(n)){switch(e+=this.input.slice(t,this.pos),++this.pos,n){case 13:10===this.input.charCodeAt(this.pos)&&++this.pos;case 10:e+="\n";break;default:e+=String.fromCharCode(n)}this.options.locations&&(++this.curLine,this.lineStart=this.pos),t=this.pos}else++this.pos}},Et.readInvalidTemplateToken=function(){for(;this.pos<this.input.length;this.pos++)switch(this.input[this.pos]){case"\\":++this.pos;break;case"$":if("{"!==this.input[this.pos+1])break;case"`":return this.finishToken(E.invalidTemplate,this.input.slice(this.start,this.pos));case"\r":"\n"===this.input[this.pos+1]&&++this.pos;case"\n":case"\u2028":case"\u2029":++this.curLine,this.lineStart=this.pos+1}this.raise(this.start,"Unterminated template")},Et.readEscapedChar=function(e){var t=this.input.charCodeAt(++this.pos);switch(++this.pos,t){case 110:return"\n";case 114:return"\r";case 120:return String.fromCharCode(this.readHexChar(2));case 117:return L(this.readCodePoint());case 116:return"\t";case 98:return"\b";case 118:return"\v";case 102:return"\f";case 13:10===this.input.charCodeAt(this.pos)&&++this.pos;case 10:return this.options.locations&&(this.lineStart=this.pos,++this.curLine),"";case 56:case 57:if(this.strict&&this.invalidStringToken(this.pos-1,"Invalid escape sequence"),e){var n=this.pos-1;this.invalidStringToken(n,"Invalid escape sequence in template string")}default:if(t>=48&&t<=55){var r=this.input.substr(this.pos-1,3).match(/^[0-7]+/)[0],i=parseInt(r,8);return i>255&&(r=r.slice(0,-1),i=parseInt(r,8)),this.pos+=r.length-1,t=this.input.charCodeAt(this.pos),"0"===r&&56!==t&&57!==t||!this.strict&&!e||this.invalidStringToken(this.pos-1-r.length,e?"Octal literal in template string":"Octal literal in strict mode"),String.fromCharCode(i)}return b(t)?(this.options.locations&&(this.lineStart=this.pos,++this.curLine),""):String.fromCharCode(t)}},Et.readHexChar=function(e){var t=this.pos,n=this.readInt(16,e);return null===n&&this.invalidStringToken(t,"Bad character escape sequence"),n},Et.readWord1=function(){this.containsEsc=!1;for(var e="",t=!0,n=this.pos,r=this.options.ecmaVersion>=6;this.pos<this.input.length;){var i=this.fullCharCodeAtPos();if(d(i,r))this.pos+=i<=65535?1:2;else{if(92!==i)break;this.containsEsc=!0,e+=this.input.slice(n,this.pos);var s=this.pos;117!==this.input.charCodeAt(++this.pos)&&this.invalidStringToken(this.pos,"Expecting Unicode escape sequence \\uXXXX"),++this.pos;var o=this.readCodePoint();(t?h:d)(o,r)||this.invalidStringToken(s,"Invalid Unicode escape"),e+=L(o),n=this.pos}t=!1}return e+this.input.slice(n,this.pos)},Et.readWord=function(){var e=this.readWord1(),t=E.name;return this.keywords.test(e)&&(t=y[e]),this.finishToken(t,e)};var _t="8.14.0";function kt(e,t){return oe.parse(e,t)}function Ct(e,t,n){return oe.parseExpressionAt(e,t,n)}function Pt(e,t){return oe.tokenizer(e,t)}oe.acorn={Parser:oe,version:_t,defaultOptions:V,Position:j,SourceLocation:F,getLineInfo:M,Node:Te,TokenType:f,tokTypes:E,keywordTypes:y,TokContext:Se,tokContexts:we,isIdentifierChar:d,isIdentifierStart:h,Token:xt,isNewLine:b,lineBreak:S,lineBreakG:w,nonASCIIwhitespace:k},e.Node=Te,e.Parser=oe,e.Position=j,e.SourceLocation=F,e.TokContext=Se,e.Token=xt,e.TokenType=f,e.defaultOptions=V,e.getLineInfo=M,e.isIdentifierChar=d,e.isIdentifierStart=h,e.isNewLine=b,e.keywordTypes=y,e.lineBreak=S,e.lineBreakG=w,e.nonASCIIwhitespace=k,e.parse=kt,e.parseExpressionAt=Ct,e.tokContexts=we,e.tokTypes=E,e.tokenizer=Pt,e.version=_t}(je.exports)),je.exports}var Me,Ve,Be,Ue={exports:{}};Ue.exports;function He(){return Me||(Me=1,function(e){function t(e,t,n,r,i){n||(n=m),function e(r,i,s){var o=s||r.type;n[o](r,i,e),t[o]&&t[o](r,i)}(e,r,i)}function n(e,t,n,r,i){var s=[];n||(n=m),function e(r,i,o){var a=o||r.type,c=r!==s[s.length-1];c&&s.push(r),n[a](r,i,e),t[a]&&t[a](r,i||s,s),c&&s.pop()}(e,r,i)}function r(e,t,n,r,i){var s=n?h(n,r||void 0):r;!function e(t,n,r){s[r||t.type](t,n,e)}(e,t,i)}function i(e){return"string"==typeof e?function(t){return t===e}:e||function(){return!0}}var s=function(e,t){this.node=e,this.state=t};function o(e,t,n,r,i){var s;n||(n=m),function e(r,i,o){var a=o||r.type;n[a](r,i,e),s!==r&&(t(r,i,a),s=r)}(e,r,i)}function a(e,t,n,r){n||(n=m);var i,s=[];!function e(r,o,a){var c=a||r.type,l=r!==s[s.length-1];l&&s.push(r),n[c](r,o,e),i!==r&&(t(r,o||s,s,c),i=r),l&&s.pop()}(e,r)}function c(e,t,n,r,o,a){o||(o=m),r=i(r);try{!function e(i,a,c){var l=c||i.type;if((null==t||i.start<=t)&&(null==n||i.end>=n)&&o[l](i,a,e),(null==t||i.start===t)&&(null==n||i.end===n)&&r(l,i))throw new s(i,a)}(e,a)}catch(e){if(e instanceof s)return e;throw e}}function l(e,t,n,r,o){n=i(n),r||(r=m);try{!function e(i,o,a){var c=a||i.type;if(!(i.start>t||i.end<t)&&(r[c](i,o,e),n(c,i)))throw new s(i,o)}(e,o)}catch(e){if(e instanceof s)return e;throw e}}function p(e,t,n,r,o){n=i(n),r||(r=m);try{!function e(i,o,a){if(!(i.end<t)){var c=a||i.type;if(i.start>=t&&n(c,i))throw new s(i,o);r[c](i,o,e)}}(e,o)}catch(e){if(e instanceof s)return e;throw e}}function u(e,t,n,r,o){var a;return n=i(n),r||(r=m),function e(i,o,c){if(!(i.start>t)){var l=c||i.type;i.end<=t&&(!a||a.node.end<i.end)&&n(l,i)&&(a=new s(i,o)),r[l](i,o,e)}}(e,o),a}function h(e,t){var n=Object.create(t||m);for(var r in e)n[r]=e[r];return n}function d(e,t,n){n(e,t)}function f(e,t,n){}var m={};m.Program=m.BlockStatement=m.StaticBlock=function(e,t,n){for(var r=0,i=e.body;r<i.length;r+=1)n(i[r],t,"Statement")},m.Statement=d,m.EmptyStatement=f,m.ExpressionStatement=m.ParenthesizedExpression=m.ChainExpression=function(e,t,n){return n(e.expression,t,"Expression")},m.IfStatement=function(e,t,n){n(e.test,t,"Expression"),n(e.consequent,t,"Statement"),e.alternate&&n(e.alternate,t,"Statement")},m.LabeledStatement=function(e,t,n){return n(e.body,t,"Statement")},m.BreakStatement=m.ContinueStatement=f,m.WithStatement=function(e,t,n){n(e.object,t,"Expression"),n(e.body,t,"Statement")},m.SwitchStatement=function(e,t,n){n(e.discriminant,t,"Expression");for(var r=0,i=e.cases;r<i.length;r+=1)n(i[r],t)},m.SwitchCase=function(e,t,n){e.test&&n(e.test,t,"Expression");for(var r=0,i=e.consequent;r<i.length;r+=1)n(i[r],t,"Statement")},m.ReturnStatement=m.YieldExpression=m.AwaitExpression=function(e,t,n){e.argument&&n(e.argument,t,"Expression")},m.ThrowStatement=m.SpreadElement=function(e,t,n){return n(e.argument,t,"Expression")},m.TryStatement=function(e,t,n){n(e.block,t,"Statement"),e.handler&&n(e.handler,t),e.finalizer&&n(e.finalizer,t,"Statement")},m.CatchClause=function(e,t,n){e.param&&n(e.param,t,"Pattern"),n(e.body,t,"Statement")},m.WhileStatement=m.DoWhileStatement=function(e,t,n){n(e.test,t,"Expression"),n(e.body,t,"Statement")},m.ForStatement=function(e,t,n){e.init&&n(e.init,t,"ForInit"),e.test&&n(e.test,t,"Expression"),e.update&&n(e.update,t,"Expression"),n(e.body,t,"Statement")},m.ForInStatement=m.ForOfStatement=function(e,t,n){n(e.left,t,"ForInit"),n(e.right,t,"Expression"),n(e.body,t,"Statement")},m.ForInit=function(e,t,n){"VariableDeclaration"===e.type?n(e,t):n(e,t,"Expression")},m.DebuggerStatement=f,m.FunctionDeclaration=function(e,t,n){return n(e,t,"Function")},m.VariableDeclaration=function(e,t,n){for(var r=0,i=e.declarations;r<i.length;r+=1)n(i[r],t)},m.VariableDeclarator=function(e,t,n){n(e.id,t,"Pattern"),e.init&&n(e.init,t,"Expression")},m.Function=function(e,t,n){e.id&&n(e.id,t,"Pattern");for(var r=0,i=e.params;r<i.length;r+=1)n(i[r],t,"Pattern");n(e.body,t,e.expression?"Expression":"Statement")},m.Pattern=function(e,t,n){"Identifier"===e.type?n(e,t,"VariablePattern"):"MemberExpression"===e.type?n(e,t,"MemberPattern"):n(e,t)},m.VariablePattern=f,m.MemberPattern=d,m.RestElement=function(e,t,n){return n(e.argument,t,"Pattern")},m.ArrayPattern=function(e,t,n){for(var r=0,i=e.elements;r<i.length;r+=1){var s=i[r];s&&n(s,t,"Pattern")}},m.ObjectPattern=function(e,t,n){for(var r=0,i=e.properties;r<i.length;r+=1){var s=i[r];"Property"===s.type?(s.computed&&n(s.key,t,"Expression"),n(s.value,t,"Pattern")):"RestElement"===s.type&&n(s.argument,t,"Pattern")}},m.Expression=d,m.ThisExpression=m.Super=m.MetaProperty=f,m.ArrayExpression=function(e,t,n){for(var r=0,i=e.elements;r<i.length;r+=1){var s=i[r];s&&n(s,t,"Expression")}},m.ObjectExpression=function(e,t,n){for(var r=0,i=e.properties;r<i.length;r+=1)n(i[r],t)},m.FunctionExpression=m.ArrowFunctionExpression=m.FunctionDeclaration,m.SequenceExpression=function(e,t,n){for(var r=0,i=e.expressions;r<i.length;r+=1)n(i[r],t,"Expression")},m.TemplateLiteral=function(e,t,n){for(var r=0,i=e.quasis;r<i.length;r+=1)n(i[r],t);for(var s=0,o=e.expressions;s<o.length;s+=1)n(o[s],t,"Expression")},m.TemplateElement=f,m.UnaryExpression=m.UpdateExpression=function(e,t,n){n(e.argument,t,"Expression")},m.BinaryExpression=m.LogicalExpression=function(e,t,n){n(e.left,t,"Expression"),n(e.right,t,"Expression")},m.AssignmentExpression=m.AssignmentPattern=function(e,t,n){n(e.left,t,"Pattern"),n(e.right,t,"Expression")},m.ConditionalExpression=function(e,t,n){n(e.test,t,"Expression"),n(e.consequent,t,"Expression"),n(e.alternate,t,"Expression")},m.NewExpression=m.CallExpression=function(e,t,n){if(n(e.callee,t,"Expression"),e.arguments)for(var r=0,i=e.arguments;r<i.length;r+=1)n(i[r],t,"Expression")},m.MemberExpression=function(e,t,n){n(e.object,t,"Expression"),e.computed&&n(e.property,t,"Expression")},m.ExportNamedDeclaration=m.ExportDefaultDeclaration=function(e,t,n){e.declaration&&n(e.declaration,t,"ExportNamedDeclaration"===e.type||e.declaration.id?"Statement":"Expression"),e.source&&n(e.source,t,"Expression")},m.ExportAllDeclaration=function(e,t,n){e.exported&&n(e.exported,t),n(e.source,t,"Expression")},m.ImportDeclaration=function(e,t,n){for(var r=0,i=e.specifiers;r<i.length;r+=1)n(i[r],t);n(e.source,t,"Expression")},m.ImportExpression=function(e,t,n){n(e.source,t,"Expression")},m.ImportSpecifier=m.ImportDefaultSpecifier=m.ImportNamespaceSpecifier=m.Identifier=m.PrivateIdentifier=m.Literal=f,m.TaggedTemplateExpression=function(e,t,n){n(e.tag,t,"Expression"),n(e.quasi,t,"Expression")},m.ClassDeclaration=m.ClassExpression=function(e,t,n){return n(e,t,"Class")},m.Class=function(e,t,n){e.id&&n(e.id,t,"Pattern"),e.superClass&&n(e.superClass,t,"Expression"),n(e.body,t)},m.ClassBody=function(e,t,n){for(var r=0,i=e.body;r<i.length;r+=1)n(i[r],t)},m.MethodDefinition=m.PropertyDefinition=m.Property=function(e,t,n){e.computed&&n(e.key,t,"Expression"),e.value&&n(e.value,t,"Expression")},e.ancestor=n,e.base=m,e.findNodeAfter=p,e.findNodeAround=l,e.findNodeAt=c,e.findNodeBefore=u,e.full=o,e.fullAncestor=a,e.make=h,e.recursive=r,e.simple=t}(Ue.exports)),Ue.exports}function qe(){}function $e(e,t,n,r,i){for(var s=0,o=t.length,a=0,c=0;s<o;s++){var l=t[s];if(l.removed){if(l.value=e.join(r.slice(c,c+l.count)),c+=l.count,s&&t[s-1].added){var p=t[s-1];t[s-1]=t[s],t[s]=p}}else{if(!l.added&&i){var u=n.slice(a,a+l.count);u=u.map((function(e,t){var n=r[c+t];return n.length>e.length?n:e})),l.value=e.join(u)}else l.value=e.join(n.slice(a,a+l.count));a+=l.count,l.added||(c+=l.count)}}var h=t[o-1];return o>1&&"string"==typeof h.value&&(h.added||h.removed)&&e.equals("",h.value)&&(t[o-2].value+=h.value,t.pop()),t}qe.prototype={diff:function(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},r=n.callback;"function"==typeof n&&(r=n,n={}),this.options=n;var i=this;function s(e){return r?(setTimeout((function(){r(void 0,e)}),0),!0):e}e=this.castInput(e),t=this.castInput(t),e=this.removeEmpty(this.tokenize(e));var o=(t=this.removeEmpty(this.tokenize(t))).length,a=e.length,c=1,l=o+a,p=[{newPos:-1,components:[]}],u=this.extractCommon(p[0],t,e,0);if(p[0].newPos+1>=o&&u+1>=a)return s([{value:this.join(t),count:t.length}]);function h(){for(var n=-1*c;n<=c;n+=2){var r=void 0,l=p[n-1],u=p[n+1],h=(u?u.newPos:0)-n;l&&(p[n-1]=void 0);var d=l&&l.newPos+1<o,f=u&&0<=h&&h<a;if(d||f){if(!d||f&&l.newPos<u.newPos?(r={newPos:(m=u).newPos,components:m.components.slice(0)},i.pushComponent(r.components,void 0,!0)):((r=l).newPos++,i.pushComponent(r.components,!0,void 0)),h=i.extractCommon(r,t,e,n),r.newPos+1>=o&&h+1>=a)return s($e(i,r.components,t,e,i.useLongestToken));p[n]=r}else p[n]=void 0}var m;c++}if(r)!function e(){setTimeout((function(){if(c>l)return r();h()||e()}),0)}();else for(;c<=l;){var d=h();if(d)return d}},pushComponent:function(e,t,n){var r=e[e.length-1];r&&r.added===t&&r.removed===n?e[e.length-1]={count:r.count+1,added:t,removed:n}:e.push({count:1,added:t,removed:n})},extractCommon:function(e,t,n,r){for(var i=t.length,s=n.length,o=e.newPos,a=o-r,c=0;o+1<i&&a+1<s&&this.equals(t[o+1],n[a+1]);)o++,a++,c++;return c&&e.components.push({count:c}),e.newPos=o,a},equals:function(e,t){return this.options.comparator?this.options.comparator(e,t):e===t||this.options.ignoreCase&&e.toLowerCase()===t.toLowerCase()},removeEmpty:function(e){for(var t=[],n=0;n<e.length;n++)e[n]&&t.push(e[n]);return t},castInput:function(e){return e},tokenize:function(e){return e.split("")},join:function(e){return e.join("")}};var We=new qe;function Ge(e,t){if("function"==typeof e)t.callback=e;else if(e)for(var n in e)e.hasOwnProperty(n)&&(t[n]=e[n]);return t}var Ke=/^[A-Za-z\xC0-\u02C6\u02C8-\u02D7\u02DE-\u02FF\u1E00-\u1EFF]+$/,ze=/\S/,Je=new qe;Je.equals=function(e,t){return this.options.ignoreCase&&(e=e.toLowerCase(),t=t.toLowerCase()),e===t||this.options.ignoreWhitespace&&!ze.test(e)&&!ze.test(t)},Je.tokenize=function(e){for(var t=e.split(/(\s+|[()[\]{}'"]|\b)/),n=0;n<t.length-1;n++)!t[n+1]&&t[n+2]&&Ke.test(t[n])&&Ke.test(t[n+2])&&(t[n]+=t[n+2],t.splice(n+1,2),n--);return t};var Ye=new qe;function Qe(e,t,n){return Ye.diff(e,t,n)}Ye.tokenize=function(e){var t=[],n=e.split(/(\n|\r\n)/);n[n.length-1]||n.pop();for(var r=0;r<n.length;r++){var i=n[r];r%2&&!this.options.newlineIsToken?t[t.length-1]+=i:(this.options.ignoreWhitespace&&(i=i.trim()),t.push(i))}return t};var Xe=new qe;Xe.tokenize=function(e){return e.split(/(\S.+?[.!?])(?=\s+|$)/)};var Ze=new qe;function et(e){return et="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},et(e)}function tt(e){return function(e){if(Array.isArray(e)){for(var t=0,n=new Array(e.length);t<e.length;t++)n[t]=e[t];return n}}(e)||function(e){if(Symbol.iterator in Object(e)||"[object Arguments]"===Object.prototype.toString.call(e))return Array.from(e)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance")}()}Ze.tokenize=function(e){return e.split(/([{}:;,]|\s+)/)};var nt=Object.prototype.toString,rt=new qe;function it(e,t,n,r,i){var s,o;for(t=t||[],n=n||[],r&&(e=r(i,e)),s=0;s<t.length;s+=1)if(t[s]===e)return n[s];if("[object Array]"===nt.call(e)){for(t.push(e),o=new Array(e.length),n.push(o),s=0;s<e.length;s+=1)o[s]=it(e[s],t,n,r,i);return t.pop(),n.pop(),o}if(e&&e.toJSON&&(e=e.toJSON()),"object"===et(e)&&null!==e){t.push(e),o={},n.push(o);var a,c=[];for(a in e)e.hasOwnProperty(a)&&c.push(a);for(c.sort(),s=0;s<c.length;s+=1)o[a=c[s]]=it(e[a],t,n,r,a);t.pop(),n.pop()}else o=e;return o}rt.useLongestToken=!0,rt.tokenize=Ye.tokenize,rt.castInput=function(e){var t=this.options,n=t.undefinedReplacement,r=t.stringifyReplacer,i=void 0===r?function(e,t){return void 0===t?n:t}:r;return"string"==typeof e?e:JSON.stringify(it(e,null,null,i),i,"  ")},rt.equals=function(e,t){return qe.prototype.equals.call(rt,e.replace(/,([\r\n])/g,"$1"),t.replace(/,([\r\n])/g,"$1"))};var st=new qe;function ot(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},n=e.split(/\r\n|[\n\v\f\r\x85]/),r=e.match(/\r\n|[\n\v\f\r\x85]/g)||[],i=[],s=0;function o(){var e={};for(i.push(e);s<n.length;){var r=n[s];if(/^(\-\-\-|\+\+\+|@@)\s/.test(r))break;var o=/^(?:Index:|diff(?: -r \w+)+)\s+(.+?)\s*$/.exec(r);o&&(e.index=o[1]),s++}for(a(e),a(e),e.hunks=[];s<n.length;){var l=n[s];if(/^(Index:|diff|\-\-\-|\+\+\+)\s/.test(l))break;if(/^@@/.test(l))e.hunks.push(c());else{if(l&&t.strict)throw new Error("Unknown line "+(s+1)+" "+JSON.stringify(l));s++}}}function a(e){var t=/^(---|\+\+\+)\s+(.*)$/.exec(n[s]);if(t){var r="---"===t[1]?"old":"new",i=t[2].split("\t",2),o=i[0].replace(/\\\\/g,"\\");/^".*"$/.test(o)&&(o=o.substr(1,o.length-2)),e[r+"FileName"]=o,e[r+"Header"]=(i[1]||"").trim(),s++}}function c(){for(var e=s,i=n[s++].split(/@@ -(\d+)(?:,(\d+))? \+(\d+)(?:,(\d+))? @@/),o={oldStart:+i[1],oldLines:+i[2]||1,newStart:+i[3],newLines:+i[4]||1,lines:[],linedelimiters:[]},a=0,c=0;s<n.length&&!(0===n[s].indexOf("--- ")&&s+2<n.length&&0===n[s+1].indexOf("+++ ")&&0===n[s+2].indexOf("@@"));s++){var l=0==n[s].length&&s!=n.length-1?" ":n[s][0];if("+"!==l&&"-"!==l&&" "!==l&&"\\"!==l)break;o.lines.push(n[s]),o.linedelimiters.push(r[s]||"\n"),"+"===l?a++:"-"===l?c++:" "===l&&(a++,c++)}if(a||1!==o.newLines||(o.newLines=0),c||1!==o.oldLines||(o.oldLines=0),t.strict){if(a!==o.newLines)throw new Error("Added line count did not match for hunk at line "+(e+1));if(c!==o.oldLines)throw new Error("Removed line count did not match for hunk at line "+(e+1))}return o}for(;s<n.length;)o();return i}function at(e,t,n){var r=!0,i=!1,s=!1,o=1;return function a(){if(r&&!s){if(i?o++:r=!1,e+o<=n)return o;s=!0}if(!i)return s||(r=!0),t<=e-o?-o++:(i=!0,a())}}function ct(e,t){var n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};if("string"==typeof t&&(t=ot(t)),Array.isArray(t)){if(t.length>1)throw new Error("applyPatch only works with a single input.");t=t[0]}var r,i,s=e.split(/\r\n|[\n\v\f\r\x85]/),o=e.match(/\r\n|[\n\v\f\r\x85]/g)||[],a=t.hunks,c=n.compareLine||function(e,t,n,r){return t===r},l=0,p=n.fuzzFactor||0,u=0,h=0;function d(e,t){for(var n=0;n<e.lines.length;n++){var r=e.lines[n],i=r.length>0?r[0]:" ",o=r.length>0?r.substr(1):r;if(" "===i||"-"===i){if(!c(t+1,s[t],i,o)&&++l>p)return!1;t++}}return!0}for(var f=0;f<a.length;f++){for(var m=a[f],g=s.length-m.oldLines,v=0,y=h+m.oldStart-1,x=at(y,u,g);void 0!==v;v=x())if(d(m,y+v)){m.offset=h+=v;break}if(void 0===v)return!1;u=m.offset+m.oldStart+m.oldLines}for(var E=0,S=0;S<a.length;S++){var w=a[S],b=w.oldStart+w.offset+E-1;E+=w.newLines-w.oldLines,b<0&&(b=0);for(var _=0;_<w.lines.length;_++){var k=w.lines[_],C=k.length>0?k[0]:" ",P=k.length>0?k.substr(1):k,A=w.linedelimiters[_];if(" "===C)b++;else if("-"===C)s.splice(b,1),o.splice(b,1);else if("+"===C)s.splice(b,0,P),o.splice(b,0,A),b++;else if("\\"===C){var N=w.lines[_-1]?w.lines[_-1][0]:null;"+"===N?r=!0:"-"===N&&(i=!0)}}}if(r)for(;!s[s.length-1];)s.pop(),o.pop();else i&&(s.push(""),o.push("\n"));for(var I=0;I<s.length-1;I++)s[I]=s[I]+o[I];return s.join("")}function lt(e,t,n,r,i,s,o){o||(o={}),void 0===o.context&&(o.context=4);var a=Qe(n,r,o);function c(e){return e.map((function(e){return" "+e}))}a.push({value:"",lines:[]});for(var l=[],p=0,u=0,h=[],d=1,f=1,m=function(e){var t=a[e],i=t.lines||t.value.replace(/\n$/,"").split("\n");if(t.lines=i,t.added||t.removed){var s;if(!p){var m=a[e-1];p=d,u=f,m&&(h=o.context>0?c(m.lines.slice(-o.context)):[],p-=h.length,u-=h.length)}(s=h).push.apply(s,tt(i.map((function(e){return(t.added?"+":"-")+e})))),t.added?f+=i.length:d+=i.length}else{if(p)if(i.length<=2*o.context&&e<a.length-2){var g;(g=h).push.apply(g,tt(c(i)))}else{var v,y=Math.min(i.length,o.context);(v=h).push.apply(v,tt(c(i.slice(0,y))));var x={oldStart:p,oldLines:d-p+y,newStart:u,newLines:f-u+y,lines:h};if(e>=a.length-2&&i.length<=o.context){var E=/\n$/.test(n),S=/\n$/.test(r),w=0==i.length&&h.length>x.oldLines;!E&&w&&h.splice(x.oldLines,0,"\\ No newline at end of file"),(E||w)&&S||h.push("\\ No newline at end of file")}l.push(x),p=0,u=0,h=[]}d+=i.length,f+=i.length}},g=0;g<a.length;g++)m(g);return{oldFileName:e,newFileName:t,oldHeader:i,newHeader:s,hunks:l}}function pt(e,t,n,r,i,s,o){var a=lt(e,t,n,r,i,s,o),c=[];e==t&&c.push("Index: "+e),c.push("==================================================================="),c.push("--- "+a.oldFileName+(void 0===a.oldHeader?"":"\t"+a.oldHeader)),c.push("+++ "+a.newFileName+(void 0===a.newHeader?"":"\t"+a.newHeader));for(var l=0;l<a.hunks.length;l++){var p=a.hunks[l];c.push("@@ -"+p.oldStart+","+p.oldLines+" +"+p.newStart+","+p.newLines+" @@"),c.push.apply(c,p.lines)}return c.join("\n")+"\n"}function ut(e,t){if(t.length>e.length)return!1;for(var n=0;n<t.length;n++)if(t[n]!==e[n])return!1;return!0}function ht(e){var t=Pt(e.lines),n=t.oldLines,r=t.newLines;void 0!==n?e.oldLines=n:delete e.oldLines,void 0!==r?e.newLines=r:delete e.newLines}function dt(e,t){if("string"==typeof e){if(/^@@/m.test(e)||/^Index:/m.test(e))return ot(e)[0];if(!t)throw new Error("Must provide a base reference or pass in a patch");return lt(void 0,void 0,t,e)}return e}function ft(e){return e.newFileName&&e.newFileName!==e.oldFileName}function mt(e,t,n){return t===n?t:(e.conflict=!0,{mine:t,theirs:n})}function gt(e,t){return e.oldStart<t.oldStart&&e.oldStart+e.oldLines<t.oldStart}function vt(e,t){return{oldStart:e.oldStart,oldLines:e.oldLines,newStart:e.newStart+t,newLines:e.newLines,lines:e.lines}}function yt(e,t,n,r,i){var s={offset:t,lines:n,index:0},o={offset:r,lines:i,index:0};for(wt(e,s,o),wt(e,o,s);s.index<s.lines.length&&o.index<o.lines.length;){var a=s.lines[s.index],c=o.lines[o.index];if("-"!==a[0]&&"+"!==a[0]||"-"!==c[0]&&"+"!==c[0])if("+"===a[0]&&" "===c[0]){var l;(l=e.lines).push.apply(l,tt(_t(s)))}else if("+"===c[0]&&" "===a[0]){var p;(p=e.lines).push.apply(p,tt(_t(o)))}else"-"===a[0]&&" "===c[0]?Et(e,s,o):"-"===c[0]&&" "===a[0]?Et(e,o,s,!0):a===c?(e.lines.push(a),s.index++,o.index++):St(e,_t(s),_t(o));else xt(e,s,o)}bt(e,s),bt(e,o),ht(e)}function xt(e,t,n){var r,i,s=_t(t),o=_t(n);if(kt(s)&&kt(o)){var a,c;if(ut(s,o)&&Ct(n,s,s.length-o.length))return void(a=e.lines).push.apply(a,tt(s));if(ut(o,s)&&Ct(t,o,o.length-s.length))return void(c=e.lines).push.apply(c,tt(o))}else if(i=o,(r=s).length===i.length&&ut(r,i)){var l;return void(l=e.lines).push.apply(l,tt(s))}St(e,s,o)}function Et(e,t,n,r){var i,s=_t(t),o=function(e,t){var n=[],r=[],i=0,s=!1,o=!1;for(;i<t.length&&e.index<e.lines.length;){var a=e.lines[e.index],c=t[i];if("+"===c[0])break;if(s=s||" "!==a[0],r.push(c),i++,"+"===a[0])for(o=!0;"+"===a[0];)n.push(a),a=e.lines[++e.index];c.substr(1)===a.substr(1)?(n.push(a),e.index++):o=!0}"+"===(t[i]||"")[0]&&s&&(o=!0);if(o)return n;for(;i<t.length;)r.push(t[i++]);return{merged:r,changes:n}}(n,s);o.merged?(i=e.lines).push.apply(i,tt(o.merged)):St(e,r?o:s,r?s:o)}function St(e,t,n){e.conflict=!0,e.lines.push({conflict:!0,mine:t,theirs:n})}function wt(e,t,n){for(;t.offset<n.offset&&t.index<t.lines.length;){var r=t.lines[t.index++];e.lines.push(r),t.offset++}}function bt(e,t){for(;t.index<t.lines.length;){var n=t.lines[t.index++];e.lines.push(n)}}function _t(e){for(var t=[],n=e.lines[e.index][0];e.index<e.lines.length;){var r=e.lines[e.index];if("-"===n&&"+"===r[0]&&(n="+"),n!==r[0])break;t.push(r),e.index++}return t}function kt(e){return e.reduce((function(e,t){return e&&"-"===t[0]}),!0)}function Ct(e,t,n){for(var r=0;r<n;r++){var i=t[t.length-n+r].substr(1);if(e.lines[e.index+r]!==" "+i)return!1}return e.index+=n,!0}function Pt(e){var t=0,n=0;return e.forEach((function(e){if("string"!=typeof e){var r=Pt(e.mine),i=Pt(e.theirs);void 0!==t&&(r.oldLines===i.oldLines?t+=r.oldLines:t=void 0),void 0!==n&&(r.newLines===i.newLines?n+=r.newLines:n=void 0)}else void 0===n||"+"!==e[0]&&" "!==e[0]||n++,void 0===t||"-"!==e[0]&&" "!==e[0]||t++})),{oldLines:t,newLines:n}}function At(e){var t=e;return t=(t=(t=(t=t.replace(/&/g,"&amp;")).replace(/</g,"&lt;")).replace(/>/g,"&gt;")).replace(/"/g,"&quot;")}st.tokenize=function(e){return e.slice()},st.join=st.removeEmpty=function(e){return e};var Nt,It=h(Object.freeze({__proto__:null,Diff:qe,applyPatch:ct,applyPatches:function(e,t){"string"==typeof e&&(e=ot(e));var n=0;!function r(){var i=e[n++];if(!i)return t.complete();t.loadFile(i,(function(e,n){if(e)return t.complete(e);var s=ct(n,i,t);t.patched(i,s,(function(e){if(e)return t.complete(e);r()}))}))}()},canonicalize:it,convertChangesToDMP:function(e){for(var t,n,r=[],i=0;i<e.length;i++)n=(t=e[i]).added?1:t.removed?-1:0,r.push([n,t.value]);return r},convertChangesToXML:function(e){for(var t=[],n=0;n<e.length;n++){var r=e[n];r.added?t.push("<ins>"):r.removed&&t.push("<del>"),t.push(At(r.value)),r.added?t.push("</ins>"):r.removed&&t.push("</del>")}return t.join("")},createPatch:function(e,t,n,r,i,s){return pt(e,e,t,n,r,i,s)},createTwoFilesPatch:pt,diffArrays:function(e,t,n){return st.diff(e,t,n)},diffChars:function(e,t,n){return We.diff(e,t,n)},diffCss:function(e,t,n){return Ze.diff(e,t,n)},diffJson:function(e,t,n){return rt.diff(e,t,n)},diffLines:Qe,diffSentences:function(e,t,n){return Xe.diff(e,t,n)},diffTrimmedLines:function(e,t,n){var r=Ge(n,{ignoreWhitespace:!0});return Ye.diff(e,t,r)},diffWords:function(e,t,n){return n=Ge(n,{ignoreWhitespace:!0}),Je.diff(e,t,n)},diffWordsWithSpace:function(e,t,n){return Je.diff(e,t,n)},merge:function(e,t,n){e=dt(e,n),t=dt(t,n);var r={};(e.index||t.index)&&(r.index=e.index||t.index),(e.newFileName||t.newFileName)&&(ft(e)?ft(t)?(r.oldFileName=mt(r,e.oldFileName,t.oldFileName),r.newFileName=mt(r,e.newFileName,t.newFileName),r.oldHeader=mt(r,e.oldHeader,t.oldHeader),r.newHeader=mt(r,e.newHeader,t.newHeader)):(r.oldFileName=e.oldFileName,r.newFileName=e.newFileName,r.oldHeader=e.oldHeader,r.newHeader=e.newHeader):(r.oldFileName=t.oldFileName||e.oldFileName,r.newFileName=t.newFileName||e.newFileName,r.oldHeader=t.oldHeader||e.oldHeader,r.newHeader=t.newHeader||e.newHeader)),r.hunks=[];for(var i=0,s=0,o=0,a=0;i<e.hunks.length||s<t.hunks.length;){var c=e.hunks[i]||{oldStart:1/0},l=t.hunks[s]||{oldStart:1/0};if(gt(c,l))r.hunks.push(vt(c,o)),i++,a+=c.newLines-c.oldLines;else if(gt(l,c))r.hunks.push(vt(l,a)),s++,o+=l.newLines-l.oldLines;else{var p={oldStart:Math.min(c.oldStart,l.oldStart),oldLines:0,newStart:Math.min(c.newStart+o,l.oldStart+a),newLines:0,lines:[]};yt(p,c.oldStart,c.lines,l.oldStart,l.lines),s++,i++,r.hunks.push(p)}}return r},parsePatch:ot,structuredPatch:lt}));function Tt(){return Nt||(Nt=1,function(r){Object.defineProperty(r,"__esModule",{value:!0}),r.setupContext=r.createEvalAwarePartialHost=r.EvalState=r.createRepl=r.REPL_NAME=r.REPL_FILENAME=r.STDIN_NAME=r.STDIN_FILENAME=r.EVAL_NAME=r.EVAL_FILENAME=void 0;const s=n,o=t,h=c,d=a,f=Zt(),m=e,g=l,v=p,y=i;let x,E;function S(){return void 0===x&&({processTopLevelAwait:x}=function(){if(Be)return Ve;Be=1;const{ArrayFrom:e,ArrayPrototypeForEach:t,ArrayPrototypeIncludes:n,ArrayPrototypeJoin:r,ArrayPrototypePop:i,ArrayPrototypePush:s,FunctionPrototype:o,ObjectKeys:a,RegExpPrototypeSymbolReplace:l,StringPrototypeEndsWith:p,StringPrototypeIncludes:u,StringPrototypeIndexOf:h,StringPrototypeRepeat:d,StringPrototypeSplit:f,StringPrototypeStartsWith:m,SyntaxError:g}=ie(),v=Fe().Parser,y=He(),{Recoverable:x}=c;function E(e){return e.ancestors[e.ancestors.length-2]===e.body}const S=o,w={ClassDeclaration(e,t,n){E(t)&&(t.prepend(e,`${e.id.name}=`),s(t.hoistedDeclarationStatements,`let ${e.id.name}; `)),y.base.ClassDeclaration(e,t,n)},ForOfStatement(e,t,n){!0===e.await&&(t.containsAwait=!0),y.base.ForOfStatement(e,t,n)},FunctionDeclaration(e,t,n){t.prepend(e,`${e.id.name}=`),s(t.hoistedDeclarationStatements,`var ${e.id.name}; `)},FunctionExpression:S,ArrowFunctionExpression:S,MethodDefinition:S,AwaitExpression(e,t,n){t.containsAwait=!0,y.base.AwaitExpression(e,t,n)},ReturnStatement(e,t,n){t.containsReturn=!0,y.base.ReturnStatement(e,t,n)},VariableDeclaration(e,i,o){const a=e.kind,c=n(["ForOfStatement","ForInStatement"],i.ancestors[i.ancestors.length-2].type);if("var"===a||E(i)){i.replace(e.start,e.start+a.length+(c?1:0),"var"===a&&c?"":"void"+(1===e.declarations.length?"":" (")),c||(t(e.declarations,(e=>{i.prepend(e,"("),i.append(e,e.init?")":"=undefined)")})),1!==e.declarations.length&&i.append(e.declarations[e.declarations.length-1],")"));const l=[["var",[]],["let",[]]];function p(e){switch(e.type){case"Identifier":s(l["var"===a?0:1][1],e.name);break;case"ObjectPattern":t(e.properties,(e=>{p(e.value)}));break;case"ArrayPattern":t(e.elements,(e=>{p(e)}))}}t(e.declarations,(e=>{p(e.id)})),t(l,(({0:e,1:t})=>{t.length>0&&s(i.hoistedDeclarationStatements,`${e} ${r(t,", ")}; `)}))}y.base.VariableDeclaration(e,i,o)}},b={};for(const e of a(y.base)){const t=w[e]||y.base[e];b[e]=(e,n,r)=>{const o=e!==n.ancestors[n.ancestors.length-1];o&&s(n.ancestors,e),t(e,n,r),o&&i(n.ancestors)}}return Ve={processTopLevelAwait:function(t){const n=`${"(async () => { "}${t} })()`,i=e(n);let s;try{s=v.parse(n,{ecmaVersion:"latest"})}catch(e){if(m(e.message,"Unterminated "))throw new x(e);const n=h(t,"await"),r=e.pos-15;if(n>r)return null;if(r===n+6&&u(e.message,"Expecting Unicode escape sequence"))return null;if(r===n+7&&u(e.message,"Unexpected token"))return null;const i=e.loc.line,s=1===i?e.loc.column-15:e.loc.column;let o="\n"+f(t,"\n")[i-1]+"\n"+d(" ",s)+"^\n\n"+l(/ \([^)]+\)/,e.message,"");throw p(o,"Unexpected token")&&(o+=" '"+(t.length-1>=e.pos-15?t[e.pos-15]:t[t.length-1])+"'"),new g(o)}const o=s.body[0].expression.callee.body,a={body:o,ancestors:[],hoistedDeclarationStatements:[],replace(e,t,n){for(let n=e;n<t;n++)i[n]="";e===t&&(n+=i[e]),i[e]=n},prepend(e,t){i[e.start]=t+i[e.start]},append(e,t){i[e.end-1]+=t},containsAwait:!1,containsReturn:!1};if(y.recursive(o,a,b),!a.containsAwait||a.containsReturn)return null;const c=o.body[o.body.length-1];return"ExpressionStatement"===c.type&&(a.prepend(c,"return ("),a.append(c.expression,")")),r(a.hoistedDeclarationStatements,"")+r(i,"")}}}()),x}r.EVAL_FILENAME="[eval].ts",r.EVAL_NAME="[eval]",r.STDIN_FILENAME="[stdin].ts",r.STDIN_NAME="[stdin]",r.REPL_FILENAME="<repl>.ts",r.REPL_NAME="<repl>",r.createRepl=function(e={}){var t,n,i,a,c;const{ignoreDiagnosticsThatAreAnnoyingInInteractiveRepl:l=!0}=e;let p,u=e.service;const d=null!==(t=e.state)&&void 0!==t?t:new w((0,o.join)(process.cwd(),r.REPL_FILENAME)),m=b(d,e.composeWithEvalAwarePartialHost),x=null!==(n=e.stdin)&&void 0!==n?n:process.stdin,E=null!==(i=e.stdout)&&void 0!==i?i:process.stdout,S=null!==(a=e.stderr)&&void 0!==a?a:process.stderr,_=E===process.stdout&&S===process.stderr?console:new g.Console(E,S),I={state:null!==(c=e.state)&&void 0!==c?c:new w((0,o.join)(process.cwd(),r.EVAL_FILENAME)),setService:function(e){u=e,l&&u.addDiagnosticFilter({appliesToAllFiles:!1,filenamesAbsolute:[d.path],diagnosticsIgnored:[2393,6133,7027,...u.shouldReplAwait?N:[]]})},evalCode:T,evalCodeInternal:R,nodeEval:O,evalAwarePartialHost:m,start:function(e){L({code:e})},startInternal:L,stdin:x,stdout:E,stderr:S,console:_};return I;function T(e){const t=k({service:u,state:d,input:e,context:p,overrideIsCompletion:!1});return v(!1===t.containsTopLevelAwait),t.value}function R(e){const{code:t,enableTopLevelAwait:n,context:r}=e;return k({service:u,state:d,input:t,enableTopLevelAwait:n,context:r})}function O(e,t,n,r){if(".scope"!==e)try{const n=R({code:e,enableTopLevelAwait:!0,context:t});n.containsTopLevelAwait?(async()=>{try{r(null,await n.valuePromise)}catch(e){i(e)}})():r(null,n.value)}catch(e){i(e)}else r(null);function i(e){var t,n;const i=!1!==u.options.experimentalReplAwait&&!u.shouldReplAwait;if(e instanceof f.TSError){if(h.Recoverable&&function(e){return e.diagnosticCodes.every((t=>{const n=A.get(t);return null===n||n&&e.diagnosticCodes.some((e=>n.has(e)))}))}(e))return void r(new h.Recoverable(e));_.error(e),i&&e.diagnosticCodes.some((e=>N.includes(e)))&&_.error(s()),r(null)}else{let o=e;if(i&&o instanceof SyntaxError&&(null===(t=o.message)||void 0===t?void 0:t.includes("await is only valid")))try{o.message+=`\n\n${s()}`,o.stack=null===(n=o.stack)||void 0===n?void 0:n.replace(/(SyntaxError:.*)/,((e,t)=>`${t}\n\n${s()}`))}catch{}r(o)}}function s(){return`Hint: REPL top-level await requires TypeScript version 3.8 or higher and target ES2018 or higher. You are using TypeScript ${u.ts.version} and target ${u.ts.ScriptTarget[u.config.options.target]}.`}}function L(e){const{code:t,forceToBeModule:n=!0,...r}=null!=e?e:{};if(t)try{T(`${t}\n`)}catch(e){_.error(e),process.exit(1)}null==u||u.compile("",d.path);const i=(0,h.start)({prompt:"> ",input:I.stdin,output:I.stdout,terminal:E.isTTY&&!parseInt(f.env.NODE_NO_READLINE,10),eval:O,useGlobal:!0,...r});p=i.context;const a=P(d,"");function c(){a(),C("exports = module.exports",d.path,p),n&&(d.input+="export {};void 0;\n"),(null==u?void 0:u.transpileOnly)||(d.input+=`// @ts-ignore\n${y.builtinModules.filter((e=>!e.startsWith("_")&&!e.includes("/")&&!["console","module","process"].includes(e))).map((e=>`declare import ${e} = require('${e}')`)).join(";")}\n`)}if(c(),i.on("reset",c),i.defineCommand("type",{help:"Check the type of a TypeScript identifier",action:function(e){if(!e)return void i.displayPrompt();const t=P(d,e),{name:n,comment:r}=u.getTypeInfo(d.input,d.path,d.input.length);t(),n&&i.outputStream.write(`${n}\n`),r&&i.outputStream.write(`${r}\n`),i.displayPrompt()}}),i.setupHistory){const e=f.env.TS_NODE_HISTORY||(0,o.join)((0,s.homedir)(),".ts_node_repl_history");i.setupHistory(e,(e=>{e&&(_.error(e),process.exit(1))}))}return i}};class w{constructor(e){this.path=e,this.input="",this.output="",this.version=0,this.lines=0}}function b(e,t){return{readFile:function(n){if(n===e.path)return e.input;if(null==t?void 0:t.readFile)return t.readFile(n);try{return(0,m.readFileSync)(n,"utf8")}catch(e){}},fileExists:function(n){if(n===e.path)return!0;if(null==t?void 0:t.fileExists)return t.fileExists(n);try{const e=(0,m.statSync)(n);return e.isFile()||e.isFIFO()}catch(e){return!1}}}}r.EvalState=w,r.createEvalAwarePartialHost=b;const _=/\/\/# ?sourceMappingURL=\S+[\s\r\n]*$/;function k(e){const{service:t,state:n,wrappedErr:r,enableTopLevelAwait:i=!1,context:s,overrideIsCompletion:o}=e;let{input:a}=e,c=!1;r||!/^\s*{/.test(a)||/;\s*$/.test(a)||(a=`(${a.trim()})\n`,c=!0);const l=n.lines,p=null!=o?o:!/\n$/.test(a),u=P(n,a);let h;try{h=t.compile(n.input,n.path,-l)}catch(t){if(u(),c){if(t instanceof f.TSError&&2339===t.diagnosticCodes[0])throw t;return k({...e,wrappedErr:t})}if(r)throw r;throw t}h=h.replace(/^"use strict";/,'"use strict"; void 0;');const d=h.replace(_,""),m=n.output.replace(_,""),g=(void 0===E&&(E=It),E.diffLines)(m,d);p?u():(n.output=h,n.input=n.input.replace(/([^\n\s])([\n\s]*)$/,((e,t,n)=>";"!==t?`${t};${n}`:e)));let v=[],y=!1;for(const e of g)if(e.added){if(i&&t.shouldReplAwait&&e.value.indexOf("await")>-1){const t=S()(e.value+"\n");if(null!==t){y=!0,v.push({mustAwait:!0,execCommand:()=>C(t,n.path,s)});continue}}v.push({execCommand:()=>C(e.value,n.path,s)})}return y?{containsTopLevelAwait:y,valuePromise:(async()=>{let e;for(const t of v){const n=t.execCommand();e=t.mustAwait?await n:n}return e})()}:{containsTopLevelAwait:!1,value:v.reduce(((e,t)=>t.execCommand()),void 0)}}function C(e,t,n){const r=new d.Script(e,{filename:t});return void 0===n||n===u?r.runInThisContext():r.runInContext(n)}function P(e,t){const n=e.input,r=e.version,i=e.output,s=e.lines;return e.input+=t,e.lines+=function(e){let t=0;for(const n of e)"\n"===n&&t++;return t}(t),e.version++,function(){e.input=n,e.output=i,e.version=r,e.lines=s}}const A=new Map([[1003,null],[1005,null],[1109,null],[1126,null],[1136,new Set([1005])],[1160,null],[1161,null],[2355,null],[2391,null],[7010,new Set([1005])]]),N=[1375,1378,1431,1432];r.setupContext=function(e,t,n){n&&(e.__dirname=".",e.__filename=`[${n}]`),e.module=t,e.exports=t.exports,e.require=t.require.bind(t)}}(De)),De}var Rt,Ot={name:"ts-node",version:"10.9.2",description:"TypeScript execution environment and REPL for node.js, with source map support",main:"dist/index.js",exports:{".":"./dist/index.js","./package":"./package.json","./package.json":"./package.json","./dist/bin":"./dist/bin.js","./dist/bin.js":"./dist/bin.js","./dist/bin-transpile":"./dist/bin-transpile.js","./dist/bin-transpile.js":"./dist/bin-transpile.js","./dist/bin-script":"./dist/bin-script.js","./dist/bin-script.js":"./dist/bin-script.js","./dist/bin-cwd":"./dist/bin-cwd.js","./dist/bin-cwd.js":"./dist/bin-cwd.js","./dist/bin-esm":"./dist/bin-esm.js","./dist/bin-esm.js":"./dist/bin-esm.js","./register":"./register/index.js","./register/files":"./register/files.js","./register/transpile-only":"./register/transpile-only.js","./register/type-check":"./register/type-check.js","./esm":"./esm.mjs","./esm.mjs":"./esm.mjs","./esm/transpile-only":"./esm/transpile-only.mjs","./esm/transpile-only.mjs":"./esm/transpile-only.mjs","./child-loader.mjs":"./child-loader.mjs","./transpilers/swc":"./transpilers/swc.js","./transpilers/swc-experimental":"./transpilers/swc-experimental.js","./node10/tsconfig.json":"./node10/tsconfig.json","./node12/tsconfig.json":"./node12/tsconfig.json","./node14/tsconfig.json":"./node14/tsconfig.json","./node16/tsconfig.json":"./node16/tsconfig.json"},types:"dist/index.d.ts",bin:{"ts-node":"dist/bin.js","ts-node-cwd":"dist/bin-cwd.js","ts-node-esm":"dist/bin-esm.js","ts-node-script":"dist/bin-script.js","ts-node-transpile-only":"dist/bin-transpile.js","ts-script":"dist/bin-script-deprecated.js"},files:["/transpilers/","/dist/","!/dist/test","/dist-raw/NODE-LICENSE.md","/dist-raw/**.js","/register/","/esm/","/esm.mjs","/child-loader.mjs","/LICENSE","/tsconfig.schema.json","/tsconfig.schemastore-schema.json","/node10/","/node12/","/node14/","/node16/"],scripts:{lint:"dprint check","lint-fix":"dprint fmt",clean:"rimraf temp dist tsconfig.schema.json tsconfig.schemastore-schema.json tsconfig.tsbuildinfo tests/ts-node-packed.tgz tests/node_modules tests/tmp",rebuild:"npm run clean && npm run build",build:"npm run build-nopack && npm run build-pack","build-nopack":"npm run build-tsc && npm run build-configSchema","build-tsc":"tsc -b ./tsconfig.build-dist.json","build-configSchema":"typescript-json-schema --topRef --refs --validationKeywords allOf --out tsconfig.schema.json tsconfig.build-schema.json TsConfigSchema && node --require ./register ./scripts/create-merged-schema","build-pack":"node ./scripts/build-pack.js","test-spec":"ava","test-cov":"nyc ava",test:"npm run build && npm run lint && npm run test-cov --","test-local":"npm run lint-fix && npm run build-tsc && npm run build-pack && npm run test-spec --","pre-debug":"npm run build-tsc && npm run build-pack","coverage-report":"nyc report --reporter=lcov",prepare:"npm run clean && npm run build-nopack","api-extractor":"api-extractor run --local --verbose","esm-usage-example":"npm run build-tsc && cd esm-usage-example && node --experimental-specifier-resolution node --loader ../esm.mjs ./index","esm-usage-example2":"npm run build-tsc && cd tests && TS_NODE_PROJECT=./module-types/override-to-cjs/tsconfig.json node --loader ../esm.mjs ./module-types/override-to-cjs/test.cjs"},repository:{type:"git",url:"git://github.com/TypeStrong/ts-node.git"},keywords:["typescript","node","runtime","environment","ts","compiler"],author:{name:"Blake Embrey",email:"hello@blakeembrey.com",url:"http://blakeembrey.me"},contributors:[{name:"Andrew Bradley",email:"cspotcode@gmail.com",url:"https://github.com/cspotcode"}],license:"MIT",bugs:{url:"https://github.com/TypeStrong/ts-node/issues"},homepage:"https://typestrong.org/ts-node",devDependencies:{"@microsoft/api-extractor":"^7.19.4","@swc/core":"^1.3.100","@swc/wasm":"^1.3.100","@types/diff":"^4.0.2","@types/lodash":"^4.14.151","@types/node":"13.13.5","@types/proper-lockfile":"^4.1.2","@types/proxyquire":"^1.3.28","@types/react":"^16.14.19","@types/rimraf":"^3.0.0","@types/semver":"^7.1.0","@yarnpkg/fslib":"^2.4.0",ava:"^3.15.0",axios:"^0.21.1",dprint:"^0.25.0",expect:"^27.0.2","get-stream":"^6.0.0",lodash:"^4.17.15",ntypescript:"^1.201507091536.1",nyc:"^15.0.1",outdent:"^0.8.0","proper-lockfile":"^4.1.2",proxyquire:"^2.0.0",react:"^16.14.0",rimraf:"^3.0.0",semver:"^7.1.3",throat:"^6.0.1",typedoc:"^0.22.10",typescript:"4.7.4","typescript-json-schema":"^0.53.0","util.promisify":"^1.0.1"},peerDependencies:{"@swc/core":">=1.2.50","@swc/wasm":">=1.2.50","@types/node":"*",typescript:">=2.7"},peerDependenciesMeta:{"@swc/core":{optional:!0},"@swc/wasm":{optional:!0}},dependencies:{"@cspotcode/source-map-support":"^0.8.0","@tsconfig/node10":"^1.0.7","@tsconfig/node12":"^1.0.7","@tsconfig/node14":"^1.0.0","@tsconfig/node16":"^1.0.2",acorn:"^8.4.1","acorn-walk":"^8.1.1",arg:"^4.1.0","create-require":"^1.1.0",diff:"^4.0.1","make-error":"^1.1.1","v8-compile-cache-lib":"^3.0.1",yn:"3.1.1"},prettier:{singleQuote:!0},volta:{node:"18.1.0",npm:"6.14.15"}},Lt={exports:{}},Dt={exports:{}},jt={exports:{}};jt.exports;function Ft(){return Rt||(Rt=1,function(e){const t=",".charCodeAt(0),n=";".charCodeAt(0),r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",i=new Uint8Array(64),s=new Uint8Array(128);for(let e=0;e<r.length;e++){const t=r.charCodeAt(e);i[e]=t,s[t]=e}function o(e,t){let n=0,r=0,i=0;do{const t=e.next();i=s[t],n|=(31&i)<<r,r+=5}while(32&i);const o=1&n;return n>>>=1,o&&(n=-2147483648|-n),t+n}function a(e,t,n){let r=t-n;r=r<0?-r<<1|1:r<<1;do{let t=31&r;r>>>=5,r>0&&(t|=32),e.write(i[t])}while(r>0);return t}function c(e,n){return!(e.pos>=n)&&e.peek()!==t}const l=16384,p="undefined"!=typeof TextDecoder?new TextDecoder:"undefined"!=typeof Buffer?{decode:e=>Buffer.from(e.buffer,e.byteOffset,e.byteLength).toString()}:{decode(e){let t="";for(let n=0;n<e.length;n++)t+=String.fromCharCode(e[n]);return t}};class u{constructor(){this.pos=0,this.out="",this.buffer=new Uint8Array(l)}write(e){const{buffer:t}=this;t[this.pos++]=e,this.pos===l&&(this.out+=p.decode(t),this.pos=0)}flush(){const{buffer:e,out:t,pos:n}=this;return n>0?t+p.decode(e.subarray(0,n)):t}}class h{constructor(e){this.pos=0,this.buffer=e}next(){return this.buffer.charCodeAt(this.pos++)}peek(){return this.buffer.charCodeAt(this.pos)}indexOf(e){const{buffer:t,pos:n}=this,r=t.indexOf(e,n);return-1===r?t.length:r}}const d=[];function f(e){const{length:t}=e,n=new h(e),r=[],i=[];let s=0;for(;n.pos<t;n.pos++){s=o(n,s);const e=o(n,0);if(!c(n,t)){const t=i.pop();t[2]=s,t[3]=e;continue}const a=o(n,0),l=1&o(n,0)?[s,e,0,0,a,o(n,0)]:[s,e,0,0,a];let p=d;if(c(n,t)){p=[];do{const e=o(n,0);p.push(e)}while(c(n,t))}l.vars=p,r.push(l),i.push(l)}return r}function m(e){const t=new u;for(let n=0;n<e.length;)n=g(e,n,t,[0]);return t.flush()}function g(e,n,r,i){const s=e[n],{0:o,1:c,2:l,3:p,4:u,vars:h}=s;n>0&&r.write(t),i[0]=a(r,o,i[0]),a(r,c,0),a(r,u,0),a(r,6===s.length?1:0,0),6===s.length&&a(r,s[5],0);for(const e of h)a(r,e,0);for(n++;n<e.length;){const t=e[n],{0:s,1:o}=t;if(s>l||s===l&&o>=p)break;n=g(e,n,r,i)}return r.write(t),i[0]=a(r,l,i[0]),a(r,p,0),n}function v(e){const{length:t}=e,n=new h(e),r=[],i=[];let s=0,a=0,l=0,p=0,u=0,f=0,m=0,g=0;do{const e=n.indexOf(";");let t=0;for(;n.pos<e;n.pos++){if(t=o(n,t),!c(n,e)){const e=i.pop();e[2]=s,e[3]=t;continue}const h=o(n,0),v=2&h,y=4&h;let x,E=null,S=d;if(1&h){const e=o(n,a);l=o(n,a===e?l:0),a=e,x=[s,t,0,0,e,l]}else x=[s,t,0,0];if(x.isScope=!!y,v){const e=p,t=u;p=o(n,p);const r=e===p;u=o(n,r?u:0),f=o(n,r&&t===u?f:0),E=[p,u,f]}if(x.callsite=E,c(n,e)){S=[];do{m=s,g=t;const e=o(n,0);let r;if(e<-1){r=[[o(n,0)]];for(let t=-1;t>e;t--){const e=m;m=o(n,m),g=o(n,m===e?g:0);const t=o(n,0);r.push([t,m,g])}}else r=[[e]];S.push(r)}while(c(n,e))}x.bindings=S,r.push(x),i.push(x)}s++,n.pos=e+1}while(n.pos<t);return r}function y(e){if(0===e.length)return"";const t=new u;for(let n=0;n<e.length;)n=x(e,n,t,[0,0,0,0,0,0,0]);return t.flush()}function x(e,n,r,i){const s=e[n],{0:o,1:c,2:l,3:p,isScope:u,callsite:h,bindings:d}=s;if(i[0]<o?(E(r,i[0],o),i[0]=o,i[1]=0):n>0&&r.write(t),i[1]=a(r,s[1],i[1]),a(r,(6===s.length?1:0)|(h?2:0)|(u?4:0),0),6===s.length){const{4:e,5:t}=s;e!==i[2]&&(i[3]=0),i[2]=a(r,e,i[2]),i[3]=a(r,t,i[3])}if(h){const{0:e,1:t,2:n}=s.callsite;e!==i[4]?(i[5]=0,i[6]=0):t!==i[5]&&(i[6]=0),i[4]=a(r,e,i[4]),i[5]=a(r,t,i[5]),i[6]=a(r,n,i[6])}if(d)for(const e of d){e.length>1&&a(r,-e.length,0),a(r,e[0][0],0);let t=o,n=c;for(let i=1;i<e.length;i++){const s=e[i];t=a(r,s[1],t),n=a(r,s[2],n),a(r,s[0],0)}}for(n++;n<e.length;){const t=e[n],{0:s,1:o}=t;if(s>l||s===l&&o>=p)break;n=x(e,n,r,i)}return i[0]<l?(E(r,i[0],l),i[0]=l,i[1]=0):r.write(t),i[1]=a(r,p,i[1]),n}function E(e,t,r){do{e.write(n)}while(++t<r)}function S(e){const{length:t}=e,n=new h(e),r=[];let i=0,s=0,a=0,l=0,p=0;do{const e=n.indexOf(";"),t=[];let u=!0,h=0;for(i=0;n.pos<e;){let r;i=o(n,i),i<h&&(u=!1),h=i,c(n,e)?(s=o(n,s),a=o(n,a),l=o(n,l),c(n,e)?(p=o(n,p),r=[i,s,a,l,p]):r=[i,s,a,l]):r=[i],t.push(r),n.pos++}u||w(t),r.push(t),n.pos=e+1}while(n.pos<=t);return r}function w(e){e.sort(b)}function b(e,t){return e[0]-t[0]}function _(e){const r=new u;let i=0,s=0,o=0,c=0;for(let l=0;l<e.length;l++){const p=e[l];if(l>0&&r.write(n),0===p.length)continue;let u=0;for(let e=0;e<p.length;e++){const n=p[e];e>0&&r.write(t),u=a(r,n[0],u),1!==n.length&&(i=a(r,n[1],i),s=a(r,n[2],s),o=a(r,n[3],o),4!==n.length&&(c=a(r,n[4],c)))}}return r.flush()}e.decode=S,e.decodeGeneratedRanges=v,e.decodeOriginalScopes=f,e.encode=_,e.encodeGeneratedRanges=y,e.encodeOriginalScopes=m,Object.defineProperty(e,"__esModule",{value:!0})}(jt.exports)),jt.exports}var Mt,Vt={exports:{}};Vt.exports;function Bt(){return Mt||(Mt=1,Vt.exports=function(){const e=/^[\w+.-]+:\/\//,t=/^([\w+.-]+:)\/\/([^@/#?]*@)?([^:/#?]*)(:\d+)?(\/[^#?]*)?(\?[^#]*)?(#.*)?/,n=/^file:(?:\/\/((?![a-z]:)[^/#?]*)?)?(\/?[^#?]*)(\?[^#]*)?(#.*)?/i;function r(t){return e.test(t)}function i(e){return e.startsWith("//")}function s(e){return e.startsWith("/")}function o(e){return e.startsWith("file:")}function a(e){return/^[.?#]/.test(e)}function c(e){const n=t.exec(e);return p(n[1],n[2]||"",n[3],n[4]||"",n[5]||"/",n[6]||"",n[7]||"")}function l(e){const t=n.exec(e),r=t[2];return p("file:","",t[1]||"","",s(r)?r:"/"+r,t[3]||"",t[4]||"")}function p(e,t,n,r,i,s,o){return{scheme:e,user:t,host:n,port:r,path:i,query:s,hash:o,type:7}}function u(e){if(i(e)){const t=c("http:"+e);return t.scheme="",t.type=6,t}if(s(e)){const t=c("http://foo.com"+e);return t.scheme="",t.host="",t.type=5,t}if(o(e))return l(e);if(r(e))return c(e);const t=c("http://foo.com/"+e);return t.scheme="",t.host="",t.type=e?e.startsWith("?")?3:e.startsWith("#")?2:4:1,t}function h(e){if(e.endsWith("/.."))return e;const t=e.lastIndexOf("/");return e.slice(0,t+1)}function d(e,t){f(t,t.type),"/"===e.path?e.path=t.path:e.path=h(t.path)+e.path}function f(e,t){const n=t<=4,r=e.path.split("/");let i=1,s=0,o=!1;for(let e=1;e<r.length;e++){const t=r[e];t?(o=!1,"."!==t&&(".."!==t?(r[i++]=t,s++):s?(o=!0,s--,i--):n&&(r[i++]=t))):o=!0}let a="";for(let e=1;e<i;e++)a+="/"+r[e];(!a||o&&!a.endsWith("/.."))&&(a+="/"),e.path=a}function m(e,t){if(!e&&!t)return"";const n=u(e);let r=n.type;if(t&&7!==r){const e=u(t),i=e.type;switch(r){case 1:n.hash=e.hash;case 2:n.query=e.query;case 3:case 4:d(n,e);case 5:n.user=e.user,n.host=e.host,n.port=e.port;case 6:n.scheme=e.scheme}i>r&&(r=i)}f(n,r);const i=n.query+n.hash;switch(r){case 2:case 3:return i;case 4:{const r=n.path.slice(1);return r?a(t||e)&&!a(r)?"./"+r+i:r+i:i||"."}case 5:return n.path+i;default:return n.scheme+"//"+n.user+n.host+n.port+n.path+i}}return m}()),Vt.exports}var Ut,Ht,qt,$t,Wt,Gt;Dt.exports;function Kt(){return Ut||(Ut=1,function(e,t,n){function r(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}var i=r(n);function s(e,t){return t&&!t.endsWith("/")&&(t+="/"),i.default(e,t)}function o(e){if(!e)return"";const t=e.lastIndexOf("/");return e.slice(0,t+1)}const a=0,c=1,l=2,p=3,u=4,h=1,d=2;function f(e,t){const n=m(e,0);if(n===e.length)return e;t||(e=e.slice());for(let r=n;r<e.length;r=m(e,r+1))e[r]=v(e[r],t);return e}function m(e,t){for(let n=t;n<e.length;n++)if(!g(e[n]))return n;return e.length}function g(e){for(let t=1;t<e.length;t++)if(e[t][a]<e[t-1][a])return!1;return!0}function v(e,t){return t||(e=e.slice()),e.sort(y)}function y(e,t){return e[a]-t[a]}let x=!1;function E(e,t,n,r){for(;n<=r;){const i=n+(r-n>>1),s=e[i][a]-t;if(0===s)return x=!0,i;s<0?n=i+1:r=i-1}return x=!1,n-1}function S(e,t,n){for(let r=n+1;r<e.length&&e[r][a]===t;r++,n++);return n}function w(e,t,n){for(let r=n-1;r>=0&&e[r][a]===t;r--,n--);return n}function b(){return{lastKey:-1,lastNeedle:-1,lastIndex:-1}}function _(e,t,n,r){const{lastKey:i,lastNeedle:s,lastIndex:o}=n;let c=0,l=e.length-1;if(r===i){if(t===s)return x=-1!==o&&e[o][a]===t,o;t>=s?c=-1===o?0:o:l=o}return n.lastKey=r,n.lastNeedle=t,n.lastIndex=E(e,t,c,l)}function k(e,t){const n=t.map(P);for(let r=0;r<e.length;r++){const i=e[r];for(let e=0;e<i.length;e++){const s=i[e];if(1===s.length)continue;const o=s[c],u=s[l],h=s[p],d=n[o],f=d[u]||(d[u]=[]),m=t[o],g=S(f,h,_(f,h,m,u));C(f,m.lastIndex=g+1,[h,r,s[a]])}}return n}function C(e,t,n){for(let n=e.length;n>t;n--)e[n]=e[n-1];e[t]=n}function P(){return{__proto__:null}}const A=function(t,n){const r="string"==typeof t?JSON.parse(t):t;if(!("sections"in r))return new M(r,n);const i=[],s=[],o=[],a=[],{sections:c}=r;let l=0;for(;l<c.length-1;l++){const e=c[l+1].offset;N(c[l],n,i,s,o,a,e.line,e.column)}c.length>0&&N(c[l],n,i,s,o,a,1/0,1/0);const p={version:3,file:r.file,names:a,sources:s,sourcesContent:o,mappings:i};return e.presortedDecodedMap(p)};function N(t,n,r,i,s,o,h,d){const f=A(t.map,n),{line:m,column:g}=t.offset,v=i.length,y=o.length,x=e.decodedMappings(f),{resolvedSources:E}=f;I(i,E),I(s,f.sourcesContent||T(E.length)),I(o,f.names);for(let e=r.length;e<=m;e++)r.push([]);const S=h-m,w=Math.min(x.length,S+1);for(let e=0;e<w;e++){const t=x[e],n=0===e?r[m]:r[m+e]=[],i=0===e?g:0;for(let r=0;r<t.length;r++){const s=t[r],o=i+s[a];if(e===S&&o>=d)break;if(1===s.length){n.push([o]);continue}const h=v+s[c],f=s[l],m=s[p];4!==s.length?n.push([o,h,f,m,y+s[u]]):n.push([o,h,f,m])}}}function I(e,t){for(let n=0;n<t.length;n++)e.push(t[n])}function T(e){const t=[];for(let n=0;n<e;n++)t[n]=null;return t}const R=Object.freeze({source:null,line:null,column:null,name:null}),O=Object.freeze({line:null,column:null}),L="`line` must be greater than 0 (lines start at line 1)",D="`column` must be greater than or equal to 0 (columns start at column 0)",j=-1,F=1;e.encodedMappings=void 0,e.decodedMappings=void 0,e.traceSegment=void 0,e.originalPositionFor=void 0,e.generatedPositionFor=void 0,e.eachMapping=void 0,e.presortedDecodedMap=void 0,e.decodedMap=void 0,e.encodedMap=void 0;class M{constructor(e,t){this._decodedMemo=b(),this._bySources=void 0,this._bySourceMemos=void 0;const n="string"==typeof e;if(!n&&e.constructor===M)return e;const r=n?JSON.parse(e):e,{version:i,file:a,names:c,sourceRoot:l,sources:p,sourcesContent:u}=r;if(this.version=i,this.file=a,this.names=c,this.sourceRoot=l,this.sources=p,this.sourcesContent=u,l||t){const e=s(l||"",o(t));this.resolvedSources=p.map((t=>s(t||"",e)))}else this.resolvedSources=p.map((e=>e||""));const{mappings:h}=r;"string"==typeof h?(this._encoded=h,this._decoded=void 0):(this._encoded=void 0,this._decoded=f(h,n))}}function V(e,t,n,r,i){let s=_(e,r,t,n);return x?s=(i===j?S:w)(e,r,s):i===j&&s++,-1===s||s===e.length?null:e[s]}e.encodedMappings=e=>{var n;return null!==(n=e._encoded)&&void 0!==n?n:e._encoded=t.encode(e._decoded)},e.decodedMappings=e=>e._decoded||(e._decoded=t.decode(e._encoded)),e.traceSegment=(t,n,r)=>{const i=e.decodedMappings(t);return n>=i.length?null:V(i[n],t._decodedMemo,n,r,F)},e.originalPositionFor=(t,{line:n,column:r,bias:i})=>{if(--n<0)throw new Error(L);if(r<0)throw new Error(D);const s=e.decodedMappings(t);if(n>=s.length)return R;const o=V(s[n],t._decodedMemo,n,r,i||F);if(null==o)return R;if(1==o.length)return R;const{names:a,resolvedSources:h}=t;return{source:h[o[c]],line:o[l]+1,column:o[p],name:5===o.length?a[o[u]]:null}},e.generatedPositionFor=(t,{source:n,line:r,column:i,bias:s})=>{if(--r<0)throw new Error(L);if(i<0)throw new Error(D);const{sources:o,resolvedSources:a}=t;let c=o.indexOf(n);if(-1===c&&(c=a.indexOf(n)),-1===c)return O;const l=t._bySources||(t._bySources=k(e.decodedMappings(t),t._bySourceMemos=o.map(b))),p=t._bySourceMemos,u=l[c][r];if(null==u)return O;const f=V(u,p[c],r,i,s||F);return null==f?O:{line:f[h]+1,column:f[d]}},e.eachMapping=(t,n)=>{const r=e.decodedMappings(t),{names:i,resolvedSources:s}=t;for(let e=0;e<r.length;e++){const t=r[e];for(let r=0;r<t.length;r++){const o=t[r],a=e+1,c=o[0];let l=null,p=null,u=null,h=null;1!==o.length&&(l=s[o[1]],p=o[2]+1,u=o[3]),5===o.length&&(h=i[o[4]]),n({generatedLine:a,generatedColumn:c,source:l,originalLine:p,originalColumn:u,name:h})}}},e.presortedDecodedMap=(e,t)=>{const n=Object.assign({},e);n.mappings=[];const r=new M(n,t);return r._decoded=e.mappings,r},e.decodedMap=t=>({version:3,file:t.file,names:t.names,sourceRoot:t.sourceRoot,sources:t.sources,sourcesContent:t.sourcesContent,mappings:e.decodedMappings(t)}),e.encodedMap=t=>({version:3,file:t.file,names:t.names,sourceRoot:t.sourceRoot,sources:t.sources,sourcesContent:t.sourcesContent,mappings:e.encodedMappings(t)}),e.AnyMap=A,e.GREATEST_LOWER_BOUND=F,e.LEAST_UPPER_BOUND=j,e.TraceMap=M,Object.defineProperty(e,"__esModule",{value:!0})}(Dt.exports,Ft(),Bt())),Dt.exports}function zt(){return Ht||(Ht=1,function(e,n){const{TraceMap:r,originalPositionFor:i,AnyMap:a}=Kt();var c=t;const{fileURLToPath:l,pathToFileURL:p}=o;var u,h=s;try{(u=require("fs")).existsSync&&u.readFileSync||(u=null)}catch(e){}function d(e,t){return e.require(t)}var f=function(e){var t="source-map-support/sharedData";"undefined"!=typeof Symbol&&(t=Symbol.for(t));var n=this[t];if(n||(n={version:1},Object.defineProperty?Object.defineProperty(this,t,{value:n}):this[t]=n),1!==n.version)throw new Error("Multiple incompatible instances of source-map-support were loaded");for(var r in e)r in n||(n[r]=e[r]);return n}({errorPrepareStackTraceHook:void 0,processEmitHook:void 0,moduleResolveFilenameHook:void 0,onConflictingLibraryRedirectArr:[],emptyCacheBetweenOperations:!1,fileContentsCache:Object.create(null),sourceMapCache:Object.create(null),retrieveFileHandlers:[],retrieveMapHandlers:[],internalRetrieveFileHandlers:[],internalRetrieveMapHandlers:[]}),m="auto",g=/^data:application\/json[^,]+base64,/;function v(){return"browser"===m||"node"!==m&&("undefined"!=typeof window&&"function"==typeof XMLHttpRequest&&!(window.require&&window.module&&window.process&&"renderer"===window.process.type))}function y(e){return x(e)?l(e):e}function x(e){return e.startsWith("file:")}function E(e){return S.test(e)}const S=/^[\w+.-]+:\/\//;function w(e){return e.startsWith("//")}function b(e){if(e.startsWith("node:"))return e;if(x(e))return new URL(e).toString();try{return p(e).toString()}catch{return e}}function _(e,t){return f.fileContentsCache[b(e)]=t}function k(e,t){return f.sourceMapCache[b(e)]=t}function C(e,t){return function(n){for(var r=0;r<e.length;r++){if(i=e[r](n))return i}for(r=0;r<t.length;r++){var i;if(i=t[r](n))return i}return null}}var P=C(f.retrieveFileHandlers,f.internalRetrieveFileHandlers);function A(e,t){if(!e)return t;try{return E(e)||w(e)?E(t)||w(t)?new URL(t,e).toString():c.isAbsolute(t)?new URL(p(t),e).toString():new URL(t.replace(/\\/g,"/"),e).toString():c.isAbsolute(e)?x(t)?l(t):w(t)?l(new URL(t,"file://")):E(t)?t:c.isAbsolute(t)?c.normalize(t):c.join(e,"..",decodeURI(t)):E(t)||w(t)?t:c.join(e,"..",t)}catch(e){return t}}f.internalRetrieveFileHandlers.push((function(e){e=e.trim(),/^file:/.test(e)&&(e=e.replace(/file:\/\/\/(\w:)?/,(function(e,t){return t?"":"/"})));const t=b(e);if(function(e){return Object.prototype.hasOwnProperty.call(f.fileContentsCache,e)}(t))return function(e){return f.fileContentsCache[e]}(t);var n="";try{if(u)u.existsSync(e)&&(n=u.readFileSync(e,"utf8"));else{var r=new XMLHttpRequest;r.open("GET",e,!1),r.send(null),4===r.readyState&&200===r.status&&(n=r.responseText)}}catch(e){}return _(e,n)}));var N=C(f.retrieveMapHandlers,f.internalRetrieveMapHandlers);function I(e){var t,n=(t=e.source,f.sourceMapCache[b(t)]);if(!n){var r=N(e.source);r?((n=k(e.source,{url:r.url,map:new a(r.map,r.url)})).map.resolvedSources=n.map.sources.map((e=>A(n.url,e))),n.map.sourcesContent&&n.map.resolvedSources.forEach((function(e,t){var r=n.map.sourcesContent[t];r&&_(e,r)}))):n=k(e.source,{url:null,map:null})}if(n&&n.map){var s=i(n.map,e);if(null!==s.source)return s.source=function(e,t){try{if(E(e)||w(e)){if(E(t)||w(t))return t;if(c.isAbsolute(t))return p(t).toString()}else if(c.isAbsolute(e)&&(E(t)||w(t)))return l(new URL(t,"file://"));return t}catch(e){return t}}(e.source,s.source),s}return e}function T(e){var t=/^eval at ([^(]+) \((.+):(\d+):(\d+)\)$/.exec(e);if(t){var n=I({source:t[2],line:+t[3],column:t[4]-1});return"eval at "+t[1]+" ("+n.source+":"+n.line+":"+(n.column+1)+")"}return(t=/^eval at ([^(]+) \((.+)\)$/.exec(e))?"eval at "+t[1]+" ("+T(t[2])+")":e}function R(){var e,t="";if(this.isNative())t="native";else{!(e=this.getScriptNameOrSourceURL())&&this.isEval()&&(t=this.getEvalOrigin(),t+=", "),t+=e||"<anonymous>";var n=this.getLineNumber();if(null!=n){t+=":"+n;var r=this.getColumnNumber();r&&(t+=":"+r)}}var i="";if(!!this.isAsync&&this.isAsync()){i+="async ";var s=!!this.isPromiseAll&&this.isPromiseAll();if(!!this.isPromiseAny&&this.isPromiseAny()||s)i+=s?"Promise.all (index ":"Promise.any (index ",i+=this.getPromiseIndex()+")"}var o=this.getFunctionName(),a=!0,c=this.isConstructor();if(!(this.isToplevel()||c)){var l=this.getTypeName();"[object Object]"===l&&(l="null");var p=this.getMethodName();o?(l&&0!=o.indexOf(l)&&(i+=l+"."),i+=o,p&&o.indexOf("."+p)!=o.length-p.length-1&&(i+=" [as "+p+"]")):i+=l+"."+(p||"<anonymous>")}else c?i+="new "+(o||"<anonymous>"):o?i+=o:(i+=t,a=!1);return a&&(i+=" ("+t+")"),i}function O(e){var t={};return Object.getOwnPropertyNames(Object.getPrototypeOf(e)).forEach((function(n){t[n]=/^(?:is|get)/.test(n)?function(){return e[n].call(e)}:e[n]})),t.toString=R,t}function L(e,t){if(void 0===t&&(t={nextPosition:null,curPosition:null}),e.isNative())return t.curPosition=null,e;var n=e.getFileName()||e.getScriptNameOrSourceURL();if(n){if(n.startsWith("wasm://"))return t.curPosition=null,e;var r=e.getLineNumber(),i=e.getColumnNumber()-1,s=/^v(10\.1[6-9]|10\.[2-9][0-9]|10\.[0-9]{3,}|1[2-9]\d*|[2-9]\d|\d{3,}|11\.11)/.test(process.version)?0:62;1===r&&i>s&&!v()&&!e.isEval()&&(i-=s);var o=I({source:n,line:r,column:i});t.curPosition=o;var a=(e=O(e)).getFunctionName;return e.getFunctionName=function(){return null==t.nextPosition?a():t.nextPosition.name||a()},e.getFileName=function(){return o.source},e.getLineNumber=function(){return o.line},e.getColumnNumber=function(){return o.column+1},e.getScriptNameOrSourceURL=function(){return o.source},e}var c=e.isEval()&&e.getEvalOrigin();return c?(c=T(c),(e=O(e)).getEvalOrigin=function(){return c},e):e}f.internalRetrieveMapHandlers.push((function(e){var t,n=function(e){var t;if(v())try{var n=new XMLHttpRequest;n.open("GET",e,!1),n.send(null),t=4===n.readyState?n.responseText:null;var r=n.getResponseHeader("SourceMap")||n.getResponseHeader("X-SourceMap");if(r)return r}catch(e){}t=P(y(e));for(var i,s,o=/(?:\/\/[@#][\s]*sourceMappingURL=([^\s'"]+)[\s]*$)|(?:\/\*[@#][\s]*sourceMappingURL=([^\s*'"]+)[\s]*(?:\*\/)[\s]*$)/gm;s=o.exec(t);)i=s;return i?i[1]:null}(e);if(!n)return null;if(g.test(n)){var r=n.slice(n.indexOf(",")+1);t=Buffer.from(r,"base64").toString(),n=e}else n=A(e,n),t=P(y(n));return t?{url:n,map:t}:null}));var D=void 0;try{c.resolve(123)}catch(e){const t=Object.getOwnPropertySymbols(e).find((function(e){return e.toString().indexOf("kIsNodeError")>=0}));t&&(D=t)}function j(e){return function(t,n){if(!e.enabled)return e.originalValue.apply(this,arguments);f.emptyCacheBetweenOperations&&(f.fileContentsCache=Object.create(null),f.sourceMapCache=Object.create(null));var r;if(D)D in t?r=`${t.name} [${t.code}]: ${t.message}`:(o=t,r=Error.prototype.toString.call(o));else{var i=t.name||"Error",s=t.message||"";r=s?i+": "+s:i}var o;for(var a={nextPosition:null,curPosition:null},c=[],l=n.length-1;l>=0;l--)c.push("\n    at "+L(n[l],a)),a.nextPosition=a.curPosition;return a.curPosition=a.nextPosition=null,r+c.reverse().join("")}}function F(e){var t,n=/\n    at [^(]+ \((.*):(\d+):(\d+)\)/.exec(e.stack);if(n){var r=n[1],i=+n[2],s=+n[3],o=(t=r,f.fileContentsCache[b(t)]);const e=y(r);if(!o&&u&&u.existsSync(e))try{o=u.readFileSync(e,"utf8")}catch(e){o=""}if(o){var a=o.split(/(?:\r\n|\r|\n)/)[i-1];if(a)return r+":"+i+"\n"+a+"\n"+new Array(s).join(" ")+"^"}}return null}function M(){const e=process.emit;var t,n=f.processEmitHook={enabled:!0,originalValue:e,installedValue:void 0},r=!1;process.emit=f.processEmitHook.installedValue=function(i){const s=e.apply(this,arguments);var o,a;return n.enabled&&("uncaughtException"!==i||s||(r=!0,t=arguments[1],process.exit(1)),"exit"===i&&r&&(a=F(o=t),process.stderr._handle&&process.stderr._handle.setBlocking&&process.stderr._handle.setBlocking(!0),a&&console.error(a),console.error(h.inspect(o,{customInspect:!1,colors:process.stderr.isTTY})))),s}}f.retrieveFileHandlers.slice(0),f.retrieveMapHandlers.slice(0),n.wrapCallSite=L,n.getErrorSource=F,n.mapSourcePosition=I,n.retrieveSourceMap=N,n.install=function(t){if((t=t||{}).environment&&(m=t.environment,-1===["node","browser","auto"].indexOf(m)))throw new Error("environment "+m+" was unknown. Available options are {auto, browser, node}");var n=d(e,"module");const{redirectConflictingLibrary:r=!0,onConflictingLibraryRedirect:i}=t;if(r){if(!f.moduleResolveFilenameHook){const e=n._resolveFilename,t=f.moduleResolveFilenameHook={enabled:!0,originalValue:e,installedValue:void 0};n._resolveFilename=f.moduleResolveFilenameHook.installedValue=function(n,r,i,s){if(t.enabled){let e;if("source-map-support"===n?e="./":"source-map-support/register"===n&&(e="./register"),void 0!==e){const t=require.resolve(e);for(const e of f.onConflictingLibraryRedirectArr)e(n,r,i,s,t);n=t}}return e.call(this,n,r,i,s)}}i&&f.onConflictingLibraryRedirectArr.push(i)}if(t.retrieveFile&&(t.overrideRetrieveFile&&(f.retrieveFileHandlers.length=0),f.retrieveFileHandlers.unshift(t.retrieveFile)),t.retrieveSourceMap&&(t.overrideRetrieveSourceMap&&(f.retrieveMapHandlers.length=0),f.retrieveMapHandlers.unshift(t.retrieveSourceMap)),t.hookRequire&&!v()){var s=n.prototype._compile;s.__sourceMapSupport||(n.prototype._compile=function(e,t){return _(t,e),k(t,void 0),s.call(this,e,t)},n.prototype._compile.__sourceMapSupport=!0)}if(f.emptyCacheBetweenOperations||(f.emptyCacheBetweenOperations="emptyCacheBetweenOperations"in t&&t.emptyCacheBetweenOperations),!f.errorPrepareStackTraceHook){const e=Error.prepareStackTrace;f.errorPrepareStackTraceHook={enabled:!0,originalValue:e,installedValue:void 0},Error.prepareStackTrace=f.errorPrepareStackTraceHook.installedValue=j(f.errorPrepareStackTraceHook)}if(!f.processEmitHook){var o=!("handleUncaughtExceptions"in t)||t.handleUncaughtExceptions;try{!1===d(e,"worker_threads").isMainThread&&(o=!1)}catch(e){}o&&"object"==typeof process&&null!==process&&"function"==typeof process.on&&M()}},n.uninstall=function(){if(f.processEmitHook&&(f.processEmitHook.enabled=!1,process.emit===f.processEmitHook.installedValue&&(process.emit=f.processEmitHook.originalValue),f.processEmitHook=void 0),f.errorPrepareStackTraceHook&&(f.errorPrepareStackTraceHook.enabled=!1,Error.prepareStackTrace!==f.errorPrepareStackTraceHook.installedValue&&"function"==typeof f.errorPrepareStackTraceHook.originalValue||(Error.prepareStackTrace=f.errorPrepareStackTraceHook.originalValue),f.errorPrepareStackTraceHook=void 0),f.moduleResolveFilenameHook){f.moduleResolveFilenameHook.enabled=!1;var t=d(e,"module");t._resolveFilename===f.moduleResolveFilenameHook.installedValue&&(t._resolveFilename=f.moduleResolveFilenameHook.originalValue),f.moduleResolveFilenameHook=void 0}f.onConflictingLibraryRedirectArr.length=0},n.resetRetrieveHandlers=function(){f.retrieveFileHandlers.length=0,f.retrieveMapHandlers.length=0}}(Lt,Lt.exports)),Lt.exports}function Jt(){if($t)return qt;$t=1;const{versionGteLt:n}=D(),r=n(process.versions.node,"14.13.1")||n(process.versions.node,"12.20.0","13.0.0")?"node:":"nodejs:",{ArrayIsArray:s,ArrayPrototypeJoin:a,ArrayPrototypeShift:c,JSONParse:l,JSONStringify:p,ObjectFreeze:u,ObjectGetOwnPropertyNames:h,ObjectPrototypeHasOwnProperty:d,RegExpPrototypeTest:f,SafeMap:m,SafeSet:g,StringPrototypeEndsWith:v,StringPrototypeIndexOf:y,StringPrototypeLastIndexOf:x,StringPrototypeReplace:E,StringPrototypeSlice:S,StringPrototypeSplit:w,StringPrototypeStartsWith:b,StringPrototypeSubstr:_}=ie(),k=i,{NativeModule:C}=ue(),{realpathSync:P,statSync:A,Stats:N}=e,{getOptionValue:I}=Ee(),{sep:T,relative:R}=t,O=I("--preserve-symlinks"),L=I("--preserve-symlinks-main"),j=I("--input-type"),{URL:F,pathToFileURL:M,fileURLToPath:V}=o,{ERR_INPUT_TYPE_NOT_ALLOWED:B,ERR_INVALID_ARG_VALUE:U,ERR_INVALID_MODULE_SPECIFIER:H,ERR_INVALID_PACKAGE_CONFIG:q,ERR_INVALID_PACKAGE_TARGET:$,ERR_MANIFEST_DEPENDENCY_MISSING:W,ERR_MODULE_NOT_FOUND:G,ERR_PACKAGE_IMPORT_NOT_DEFINED:K,ERR_PACKAGE_PATH_NOT_EXPORTED:z,ERR_UNSUPPORTED_DIR_IMPORT:J,ERR_UNSUPPORTED_ESM_URL_SCHEME:Y}=Ae().codes,Q=k,X=de(),Z=u(["node","import",...I("--conditions")]),ee=new g(Z),te=I("--pending-deprecation");return qt={createResolve:function(e){const{preferTsExts:t,tsNodeExperimentalSpecifierResolution:i,extensions:o}=e,u=o.experimentalSpecifierResolutionAddsIfOmitted,{legacyMainResolveAddsIfOmitted:k,replacementsForCjs:D,replacementsForJs:W,replacementsForMjs:ne,replacementsForJsx:re}=o,ie=null!=i?i:I("--experimental-specifier-resolution"),se=new g;function oe(e,t,n,r){const i=V(t);if(!te){const e=x(i,"/node_modules/");if(-1!==e){const t=S(i,e+14,-13);try{const{packageSubpath:e}=Ae(t);if("."===e)return}catch{}}}se.has(i+"|"+e)||(se.add(i+"|"+e),process.emitWarning(`Use of deprecated folder mapping "${e}" in the ${n?'"exports"':'"imports"'} field module resolution of the package at ${i}${r?` imported from ${V(r)}`:""}.\nUpdate this package.json to use a subpath pattern like "${e}*".`,"DeprecationWarning","DEP0148"))}new m;const ae=new m,ce=n(process.versions.node,"15.3.0")||n(process.versions.node,"14.17.0","15.0.0")?function(e){const t=A(e,{throwIfNoEntry:!1});return null!=t?t:le}:function(e){try{return A(e)}catch{return le}},le=new N;function pe(e,t,n){const r=ae.get(e);if(void 0!==r)return r;const i=X.read(e).string;if(void 0===i){const t={pjsonPath:e,exists:!1,main:void 0,name:void 0,type:"none",exports:void 0,imports:void 0};return ae.set(e,t),t}let s;try{s=l(i)}catch(r){throw new q(e,(n?`"${t}" from `:"")+V(n||t),r.message)}let{imports:o,main:a,name:c,type:p}=s;const{exports:u}=s;"object"==typeof o&&null!==o||(o=void 0),"string"!=typeof a&&(a=void 0),"string"!=typeof c&&(c=void 0),"module"!==p&&"commonjs"!==p&&(p="none");const h={pjsonPath:e,exists:!0,main:a,name:c,type:p,exports:u,imports:o};return ae.set(e,h),h}function ue(e){let t=new F("./package.json",e);for(;;){const n=t.pathname;if(v(n,"node_modules/package.json"))break;const r=pe(V(t),e);if(r.exists)return r;const i=t;if(t=new F("../package.json",t),t.pathname===i.pathname)break}const n=V(t),r={pjsonPath:n,exists:!1,main:void 0,name:void 0,type:"none",exports:void 0,imports:void 0};return ae.set(n,r),r}function he(e){return ce(V(e)).isFile()}function de(e,t,n){let r;if(void 0!==t.main){if(r=me(new F(`./${t.main}`,e)))return r;if(he(r=new F(`./${t.main}`,e)))return r;for(const n of k)if(he(r=new F(`./${t.main}${n}`,e)))return r;for(const n of k)if(he(r=new F(`./${t.main}/index${n}`,e)))return r}for(const t of k)if(he(r=new F(`./index${t}`,e)))return r;throw new G(V(new F(".",e)),V(n))}function fe(e){for(let t=0;t<u.length;t++){const n=u[t],r=new F(`${e.pathname}${n}`,e);if(he(r))return r}}function me(e){const t=e.pathname.lastIndexOf(".");if(t>=0){const n=e.pathname.slice(t);if(".js"===n||".jsx"===n||".mjs"===n||".cjs"===n){const r=e.pathname.slice(0,t),i=".js"===n?W:".jsx"===n?re:".mjs"===n?ne:D,s=new F(e.toString());for(let e=0;e<i.length;e++){const t=i[e];if(s.pathname=`${r}${t}`,he(s))return s}}}}function ge(e){return fe(new F("index",e))}const ve=/%2F|%2C/i;function ye(e,t){if(f(ve,e.pathname))throw new H(e.pathname,'must not include encoded "/" or "\\" characters',V(t));if("node"===ie){const r=V(e);let i=me(n=e)||(he(n)?n:fe(n));if(void 0!==i)return i;if(v(r,"/"))return ge(e)||e;if(i=ge(new F(`${e}/`)),void 0!==i)return i;throw new G(e.pathname,V(t),"module")}var n;const r=me(e)||e,i=V(r),s=ce(v(i,"/")?S(i,-1):i);if(s.isDirectory()){const n=new J(i,V(t));throw n.url=String(e),n}if(!s.isFile())throw new G(i||e.pathname,V(t),"module");return r}function xe(e,t,n){throw new z(V(new F(".",t)),e,n&&V(n))}function Ee(e,t,n,r,i){throw t="object"==typeof t&&null!==t?p(t,null,""):`${t}`,new $(V(new F(".",n)),e,t,r,i&&V(i))}const Se=/(^|\\|\/)(\.\.?|node_modules)(\\|\/|$)/,we=/\*/g;function be(e,t,n,r,i,s,o,a){if(""===t||s||"/"===e[e.length-1]||Ee(n,e,r,o,i),!b(e,"./")){if(o&&!b(e,"../")&&!b(e,"/")){let n=!1;try{new F(e),n=!0}catch{}if(!n){return Ne(s?E(e,we,t):e+t,r,a)}}Ee(n,e,r,o,i)}f(Se,S(e,2))&&Ee(n,e,r,o,i);const c=new F(e,r),l=c.pathname,p=new F(".",r).pathname;return b(l,p)||Ee(n,e,r,o,i),""===t?c:(f(Se,t)&&function(e,t,n,r){const i=`request is not a valid subpath for the "${n?"imports":"exports"}" resolution of ${V(t)}`;throw new H(e,i,r&&V(r))}(n+t,r,o,i),s?new F(E(c.href,we,t)):new F(t,c))}function _e(e){const t=+e;return`${t}`===e&&(t>=0&&t<4294967295)}function ke(e,t,n,r,i,o,a,c){if("string"==typeof t)return be(t,n,r,e,i,o,a,c);if(s(t)){if(0===t.length)return null;let s;for(let l=0;l<t.length;l++){const p=t[l];let u;try{u=ke(e,p,n,r,i,o,a,c)}catch(e){if(s=e,"ERR_INVALID_PACKAGE_TARGET"===e.code)continue;throw e}if(void 0!==u){if(null!==u)return u;s=null}}if(null==s)return s;throw s}if("object"!=typeof t||null===t){if(null===t)return null;Ee(r,t,e,a,i)}else{const s=h(t);for(let t=0;t<s.length;t++){if(_e(s[t]))throw new q(V(e),i,'"exports" cannot contain numeric property keys.')}for(let l=0;l<s.length;l++){const p=s[l];if("default"===p||c.has(p)){const s=ke(e,t[p],n,r,i,o,a,c);if(void 0===s)continue;return s}}}}function Ce(e,t,n,r,i){let o=n.exports;if(function(e,t,n){if("string"==typeof e||s(e))return!0;if("object"!=typeof e||null===e)return!1;const r=h(e);let i=!1,o=0;for(let e=0;e<r.length;e++){const s=r[e],a=""===s||"."!==s[0];if(0==o++)i=a;else if(i!==a)throw new q(V(t),n,"\"exports\" cannot contain some keys starting with '.' and some not. The exports object must either be an object of package subpath keys or an object of main entry condition name keys only.")}return i}(o,e,r)&&(o={".":o}),d(o,t)){const n=ke(e,o[t],"",t,r,!1,!1,i);return null==n&&xe(t,e,r),{resolved:n,exact:!0}}let a="";const c=h(o);for(let e=0;e<c.length;e++){const n=c[e];("*"===n[n.length-1]&&b(t,S(n,0,-1))&&t.length>=n.length&&n.length>a.length||"/"===n[n.length-1]&&b(t,n)&&n.length>a.length)&&(a=n)}if(a){const n=o[a],s="*"===a[a.length-1],c=ke(e,n,_(t,a.length-(s?1:0)),a,r,s,!1,i);return null==c&&xe(t,e,r),s||oe(a,e,!0,r),{resolved:c,exact:s}}xe(t,e,r)}function Pe(e,t,n){if("#"===e||b(e,"#/")){throw new H(e,"is not a valid internal imports specifier name",V(t))}let r;const i=ue(t);if(i.exists){r=M(i.pjsonPath);const s=i.imports;if(s)if(d(s,e)){const i=ke(r,s[e],"",e,t,!1,!0,n);if(null!==i)return{resolved:i,exact:!0}}else{let i="";const o=h(s);for(let t=0;t<o.length;t++){const n=o[t];("*"===n[n.length-1]&&b(e,S(n,0,-1))&&e.length>=n.length&&n.length>i.length||"/"===n[n.length-1]&&b(e,n)&&n.length>i.length)&&(i=n)}if(i){const o=s[i],a="*"===i[i.length-1],c=ke(r,o,_(e,i.length-(a?1:0)),i,t,a,!0,n);if(null!==c)return a||oe(i,r,!1,t),{resolved:c,exact:a}}}}!function(e,t,n){throw new K(e,t&&V(new F(".",t)),V(n))}(e,r,t)}function Ae(e,t){let n=y(e,"/"),r=!0,i=!1;"@"===e[0]&&(i=!0,-1===n||0===e.length?r=!1:n=y(e,"/",n+1));const s=-1===n?e:S(e,0,n);for(let e=0;e<s.length;e++)if("%"===s[e]||"\\"===s[e]){r=!1;break}if(!r)throw new H(e,"is not a valid package name",V(t));return{packageName:s,packageSubpath:"."+(-1===n?"":S(e,n)),isScoped:i}}function Ne(e,t,n){const{packageName:r,packageSubpath:i,isScoped:s}=Ae(e,t),o=ue(t);if(o.exists){const e=M(o.pjsonPath);if(o.name===r&&void 0!==o.exports&&null!==o.exports)return Ce(e,i,o,t,n).resolved}let a,c=new F("./node_modules/"+r+"/package.json",t),l=V(c);do{if(!ce(S(l,0,l.length-13)).isDirectory()){a=l,c=new F((s?"../../../../node_modules/":"../../../node_modules/")+r+"/package.json",c),l=V(c);continue}const o=pe(l,e,t);return void 0!==o.exports&&null!==o.exports?Ce(c,i,o,t,n).resolved:"."===i?de(c,o,t):new F(i,c)}while(l.length!==a.length);throw new G(r,V(t))}function Ie(e){if("."===e[0]){if(1===e.length||"/"===e[1])return!0;if("."===e[1]&&(2===e.length||"/"===e[2]))return!0}return!1}function Te(e,t,n){let r;if(function(e){return""!==e&&("/"===e[0]||Ie(e))}(e))r=new F(e,t);else if("#"===e[0])({resolved:r}=Pe(e,t,n));else try{r=new F(e)}catch{r=Ne(e,t,n)}return ye(r,t)}return{DEFAULT_CONDITIONS:Z,defaultResolve:function(e,t={},n){let i,{parentURL:o,conditions:l}=t;try{if(i=new F(e),"data:"===i.protocol)return{url:e}}catch{}if(i&&i.protocol===r)return{url:e};if(i&&"file:"!==i.protocol&&"data:"!==i.protocol)throw new Y(i);if(C.canBeRequiredByUsers(e))return{url:r+e};o&&b(o,"data:")&&new F(e,o);const p=void 0===o;if(p&&(o=M(`${process.cwd()}/`).href,j))throw new B;let u;l=function(e){if(void 0!==e&&e!==Z){if(!s(e))throw new U("conditions",e,"expected an array");return new g(e)}return ee}(l);try{u=Te(e,o,l)}catch(t){if("ERR_MODULE_NOT_FOUND"===t.code||"ERR_UNSUPPORTED_DIR_IMPORT"===t.code){b(e,"file://")&&(e=V(e));const n=function(e,t){try{const n=V(t),r=new Q(n,null);r.paths=Q._nodeModulePaths(n);let i=Q._resolveFilename(e,r,!1);if(Ie(e))i=R(n,i),b(i,`..${T}`)||(i=`.${T}${i}`);else if(function(e){return e[0]&&"/"!==e[0]&&"."!==e[0]}(e)){const t=w(e,"/")[0],n=y(i,t);-1!==n&&(i=S(i,n))}return"win32"===process.platform&&(i=E(i,new RegExp(`\\${T}`,"g"),"/")),i}catch{return!1}}(e,o);if(n){const e=w(t.stack,"\n"),r=`Did you mean to import ${n}?`;t.stack=c(e)+"\n"+r+"\n"+a(e,"\n"),t.message+=`\n${r}`}}throw t}if(p?!L:!O){const e=V(u),t=P(e,{}),n=u;u=M(t+(v(e,T)?"/":"")),u.search=n.search,u.hash=n.hash}return{url:`${u}`}},encodedSepRegEx:ve,getPackageType:function(e){return ue(e).type},packageExportsResolve:Ce,packageImportsResolve:Pe}}},qt}Lt.exports;var Yt,Qt,Xt={};function Zt(){return Qt||(Qt=1,function(e){var n,r;Object.defineProperty(e,"__esModule",{value:!0}),e.createEsmHooks=e.createFromPreloadedConfig=e.create=e.register=e.TSError=e.DEFAULTS=e.VERSION=e.debug=e.INSPECT_CUSTOM=e.env=e.REGISTER_INSTANCE=e.createRepl=void 0;const a=t,c=i,l=s,u=o,h=(y||(y=1,function(e,t){var n="undefined"!=typeof Reflect?Reflect.construct:void 0,r=Object.defineProperty,i=Error.captureStackTrace;function s(e){void 0!==e&&r(this,"message",{configurable:!0,value:e,writable:!0});var t=this.constructor.name;void 0!==t&&t!==this.name&&r(this,"name",{configurable:!0,value:t,writable:!0}),i(this,this.constructor)}void 0===i&&(i=function(e){var t=new Error;r(e,"stack",{configurable:!0,get:function(){var e=t.stack;return r(this,"stack",{configurable:!0,value:e,writable:!0}),e},set:function(t){r(e,"stack",{configurable:!0,value:t,writable:!0})}})}),s.prototype=Object.create(Error.prototype,{constructor:{configurable:!0,value:s,writable:!0}});var o=function(){function e(e,t){return r(e,"name",{configurable:!0,value:t})}try{var t=function(){};if(e(t,"foo"),"foo"===t.name)return e}catch(e){}}();t=e.exports=function(e,t){if(null==t||t===Error)t=s;else if("function"!=typeof t)throw new TypeError("super_ should be a function");var r;if("string"==typeof e)r=e,e=void 0!==n?function(){return n(t,arguments,this.constructor)}:function(){t.apply(this,arguments)},void 0!==o&&(o(e,r),r=void 0);else if("function"!=typeof e)throw new TypeError("constructor should be either a string or a function");e.super_=e.super=t;var i={constructor:{configurable:!0,value:e,writable:!0}};return void 0!==r&&(i.name={configurable:!0,value:r,writable:!0}),e.prototype=Object.create(t.prototype,i),e},t.BaseError=s}(E,E.exports)),E.exports),d=D(),f=K(),m=function(){if(z)return J;z=1,Object.defineProperty(J,"__esModule",{value:!0}),J.createModuleTypeClassifier=void 0;const e=V(),t=D();function n(t,n){const r=(0,e.getPatternFromSpec)(n,t);return void 0!==r?new RegExp(r):/(?:)/}return J.createModuleTypeClassifier=function(e){const{patterns:r,basePath:i}=e,s=void 0!==i?(0,t.normalizeSlashes)(i).replace(/\/$/,""):void 0,o=Object.entries(null!=r?r:[]).map((([e,r])=>{const i=(0,t.normalizeSlashes)(e);return{pattern:n(s,i),type:r}})),a={package:{moduleType:"auto"},cjs:{moduleType:"cjs"},esm:{moduleType:"esm"}},c=a.package,l=(0,t.cachedLookup)((function(e){const t=function(e,t,n){for(let r=e.length-1;r>=0;r--){const i=e[r],s=t(i);if(null==s?void 0:s.test(n))return i}}(o,(e=>e.pattern),e);return t?a[t.type]:c}));return{classifyModuleByModuleTypeOverrides:o.length?l:function(e){return c}}},J}(),g=X(),x=(Z||(Z=1,Object.defineProperty(ee,"__esModule",{value:!0}),ee.installCommonjsResolveHooksIfNecessary=void 0,ee.installCommonjsResolveHooksIfNecessary=function(e){const t=i,n=t._resolveFilename,r=t._findPath;if(e.options.experimentalResolver){const{Module_findPath:s,Module_resolveFilename:o}=e.getNodeCjsLoader();function a(t,r,i,s,...a){return e.enabled()?o.call(this,t,r,i,s,...a):n.call(this,t,r,i,s,...a)}function c(){return e.enabled()?s.apply(this,arguments):r.apply(this,arguments)}t._resolveFilename=a,t._findPath=c}}),ee),S=function(){if(Ce)return re;Ce=1,Object.defineProperty(re,"__esModule",{value:!0}),re.classifyModule=void 0;const e=Ne();return re.classifyModule=function(t,n){const r=t.lastIndexOf(".");switch(r>=0?t.slice(r):""){case".cjs":case".cts":return n?"nodecjs":"cjs";case".mjs":case".mts":return n?"nodeesm":"esm"}if(n){const n=(0,e.readPackageScope)(t);return n&&"module"===n.data.type?"nodeesm":"nodecjs"}},re}(),w=function(){if(Ie)return Te;Ie=1,Object.defineProperty(Te,"__esModule",{value:!0}),Te.getExtensions=void 0;const e=D(),t=new Map([[".ts",".js"],[".tsx",".js"],[".jsx",".js"],[".mts",".mjs"],[".cts",".cjs"]]),n=new Map([[".ts",[".js"]],[".tsx",[".js",".jsx"]],[".mts",[".mjs"]],[".cts",[".cjs"]]]),r=[".js",".json",".node",".mjs",".cjs"],i=[".ts",".tsx",".jsx",".cts",".mts"];return Te.getExtensions=function(s,o,a){const c=(0,e.versionGteLt)(a,"4.5.0"),l=[];c||l.push(".cts",".cjs",".mts",".mjs");const p=Array.from(new Set([...o.preferTsExts?i:[],...r,...i])),u=[".ts"],h=[];s.options.jsx&&h.push(".tsx"),c&&u.push(".mts",".cts"),s.options.allowJs&&(u.push(".js"),s.options.jsx&&h.push(".jsx"),c&&u.push(".mjs",".cjs"));const d=[...u,...h],f=p.filter((e=>d.includes(e))),m=i.filter((e=>f.includes(e))),g=p.filter((e=>[...d,".js",".mjs",".cjs",".mts",".cts"].includes(e))),v=g.filter((e=>[".js",".jsx",".ts",".tsx"].includes(e))),y=g.filter((e=>[".jsx",".tsx"].includes(e))),x=g.filter((e=>[".mjs",".mts"].includes(e))),E=g.filter((e=>[".cjs",".cts"].includes(e))),S=g.filter((e=>[".js",".jsx",".ts",".tsx",".mjs",".mts"].includes(e))),w=Array.from(new Set([...S,".json",".node"])),b=Array.from(new Set([...v,".json",".node"]));return{compiled:f,nodeDoesNotUnderstand:i,compiledNodeDoesNotUnderstand:m,nodeEquivalents:t,tsResolverEquivalents:n,requiresHigherTypescriptVersion:l,experimentalSpecifierResolutionAddsIfOmitted:w,legacyMainResolveAddsIfOmitted:b,replacementsForMjs:x,replacementsForCjs:E,replacementsForJsx:y,replacementsForJs:v}},Te}(),b=(Re||(Re=1,Object.defineProperty(Oe,"__esModule",{value:!0}),Oe.createTsTranspileModule=void 0,Oe.createTsTranspileModule=function(e,t){const{createProgram:n,createSourceFile:r,getDefaultCompilerOptions:i,getImpliedNodeFormatForFile:s,fixupCompilerOptions:o,transpileOptionValueCompilerOptions:a,getNewLineCharacter:c,fileExtensionIs:l,normalizePath:p,Debug:u,toPath:h,getSetExternalModuleIndicator:d,getEntries:f,addRange:m,hasProperty:g,getEmitScriptTarget:v,getDirectoryPath:y}=e,x=[],E=t.compilerOptions?o(t.compilerOptions,x):{},S=i();for(const e in S)g(S,e)&&void 0===E[e]&&(E[e]=S[e]);for(const e of a)E[e.name]=e.transpileOptionValue;E.suppressOutputPathCheck=!0,E.allowNonTsExtensions=!0;const w=c(E),b={getSourceFile:e=>e===p(_)?P:void 0,writeFile:(e,t)=>{l(e,".map")?(u.assertEqual(N,void 0,"Unexpected multiple source map outputs, file:",e),N=t):(u.assertEqual(A,void 0,"Unexpected multiple outputs, file:",e),A=t)},getDefaultLibFileName:()=>"lib.d.ts",useCaseSensitiveFileNames:()=>!0,getCanonicalFileName:e=>e,getCurrentDirectory:()=>"",getNewLine:()=>w,fileExists:e=>e===_||e===k,readFile:e=>e===k?`{"type": "${C}"}`:"",directoryExists:()=>!0,getDirectories:()=>[]};let _,k,C,P,A,N;return function(e,i,o="commonjs"){_=i.fileName||(t.compilerOptions&&t.compilerOptions.jsx?"module.tsx":"module.ts"),k=y(_)+"/package.json",C=o,P=r(_,e,{languageVersion:v(E),impliedNodeFormat:s(h(_,"",b.getCanonicalFileName),void 0,b,E),setExternalModuleIndicator:d(E)}),i.moduleName&&(P.moduleName=i.moduleName),i.renamedDependencies&&(P.renamedDependencies=new Map(f(i.renamedDependencies))),A=void 0,N=void 0;const a=n([_],E,b),c=x.slice();return t.reportDiagnostics&&(m(c,a.getSyntacticDiagnostics(P)),m(c,a.getOptionsDiagnostics())),a.emit(void 0,void 0,void 0,void 0,t.transformers),void 0===A?u.fail("Output generation failed"):{outputText:A,diagnostics:c,sourceMapText:N}}}),Oe);var _=Tt();Object.defineProperty(e,"createRepl",{enumerable:!0,get:function(){return _.createRepl}});let k=parseInt(process.versions.node.split(".")[0],10)>=12?Ne().assertScriptCanLoadAsCJSImpl:()=>{};e.REGISTER_INSTANCE=Symbol.for("ts-node.register.instance"),e.env=process.env,e.INSPECT_CUSTOM=l.inspect.custom||"inspect";const C=(0,d.yn)(e.env.TS_NODE_DEBUG);e.debug=C?(...e)=>console.log(`[ts-node ${(new Date).toISOString()}]`,...e):()=>{};const P=C?(t,n)=>{let r=0;return i=>((0,e.debug)(t,i,++r),n(i))}:(e,t)=>t;e.VERSION=Ot.version,e.DEFAULTS={cwd:null!==(n=e.env.TS_NODE_CWD)&&void 0!==n?n:e.env.TS_NODE_DIR,emit:(0,d.yn)(e.env.TS_NODE_EMIT),scope:(0,d.yn)(e.env.TS_NODE_SCOPE),scopeDir:e.env.TS_NODE_SCOPE_DIR,files:(0,d.yn)(e.env.TS_NODE_FILES),pretty:(0,d.yn)(e.env.TS_NODE_PRETTY),compiler:e.env.TS_NODE_COMPILER,compilerOptions:(0,d.parse)(e.env.TS_NODE_COMPILER_OPTIONS),ignore:(0,d.split)(e.env.TS_NODE_IGNORE),project:e.env.TS_NODE_PROJECT,skipProject:(0,d.yn)(e.env.TS_NODE_SKIP_PROJECT),skipIgnore:(0,d.yn)(e.env.TS_NODE_SKIP_IGNORE),preferTsExts:(0,d.yn)(e.env.TS_NODE_PREFER_TS_EXTS),ignoreDiagnostics:(0,d.split)(e.env.TS_NODE_IGNORE_DIAGNOSTICS),transpileOnly:(0,d.yn)(e.env.TS_NODE_TRANSPILE_ONLY),typeCheck:(0,d.yn)(e.env.TS_NODE_TYPE_CHECK),compilerHost:(0,d.yn)(e.env.TS_NODE_COMPILER_HOST),logError:(0,d.yn)(e.env.TS_NODE_LOG_ERROR),experimentalReplAwait:null!==(r=(0,d.yn)(e.env.TS_NODE_EXPERIMENTAL_REPL_AWAIT))&&void 0!==r?r:void 0,tsTrace:console.log.bind(console)};class A extends h.BaseError{constructor(e,t,n=[]){super(`⨯ Unable to compile TypeScript:\n${e}`),this.diagnosticCodes=t,this.name="TSError",Object.defineProperty(this,"diagnosticText",{configurable:!0,writable:!0,value:e}),Object.defineProperty(this,"diagnostics",{configurable:!0,writable:!0,value:n})}[e.INSPECT_CUSTOM](){return this.diagnosticText}}e.TSError=A;const N=Symbol("TS_NODE_SERVICE_BRAND");function I(e={}){return T((0,f.findAndReadConfig)(e))}function T(n){var r,i,s,c;const{configFilePath:l,cwd:p,options:h,config:y,compiler:x,projectLocalResolveDir:E,optionBasePaths:_}=n,k=(0,d.createProjectLocalResolveHelper)(E),C=(0,f.loadCompiler)(x),I=y.options.target>=C.ScriptTarget.ES2018;if(!0===h.experimentalReplAwait&&!I)throw new Error("Experimental REPL await is not compatible with targets lower than ES2018");const T=(0,d.versionGteLt)(C.version,"3.8.0");if(!0===h.experimentalReplAwait&&!T)throw new Error("Experimental REPL await is not compatible with TypeScript versions older than 3.8");const R=!1!==h.experimentalReplAwait&&T&&I;if(h.swc&&!h.typeCheck){if(!1===h.transpileOnly)throw new Error("Cannot enable 'swc' option with 'transpileOnly: false'.  'swc' implies 'transpileOnly'.");if(h.transpiler)throw new Error("Cannot specify both 'swc' and 'transpiler' options.  'swc' uses the built-in swc transpiler.")}const L=h.readFile||C.sys.readFile,D=h.fileExists||C.sys.fileExists,j=(!0===h.transpileOnly||!0===h.swc)&&!0!==h.typeCheck;let F,M;h.transpiler?(F=h.transpiler,M=_.transpiler):h.swc&&(F=require.resolve("./transpilers/swc.js"),M=_.swc);const V=h.transformers||void 0,B=[{appliesToAllFiles:!0,filenamesAbsolute:[],diagnosticsIgnored:[6059,18002,18003,...h.experimentalTsImportSpecifiers?[2691]:[],...h.ignoreDiagnostics||[]].map(Number)}],U=O(y.errors,B),H=new Map,q=l?(0,a.dirname)(l):null,$=null!==(s=null!==(i=null!==(r=h.scopeDir)&&void 0!==r?r:y.options.rootDir)&&void 0!==i?i:q)&&void 0!==s?s:p,W=null!=q?q:p,G=h.scope?e=>"."!==(0,a.relative)($,e).charAt(0):()=>!0,K=function(e,t){return n=>{const r=(0,a.relative)(e,n),i=(0,d.normalizeSlashes)(r);return t.some((e=>e.test(i)))}}(W,h.skipIgnore?[]:(h.ignore||["(?:^|/)node_modules/"]).map((e=>new RegExp(e)))),z={getNewLine:()=>C.sys.newLine,getCurrentDirectory:()=>p,getCanonicalFileName:C.sys.useCaseSensitiveFileNames?e=>e:e=>e.toLowerCase()};if(h.transpileOnly&&"function"==typeof V)throw new TypeError('Transformers function is unavailable in "--transpile-only"');let J=function(){var e;if(F){if(!j)throw new Error("Custom transpiler can only be used when transpileOnly is enabled.");const t="string"==typeof F?F:F[0],n="string"==typeof F?{}:null!==(e=F[1])&&void 0!==e?e:{},r=M?(0,d.createProjectLocalResolveHelper)(M):k,i=v(r(t,!0)).create;return s;function s(e,t){return null==i?void 0:i({service:{options:h,config:{...y,options:e},projectLocalResolveHelper:k},transpilerConfigLocalResolveHelper:r,nodeModuleEmitKind:t,...n})}}}();let Y=!1;function Q(){zt().install({environment:"node",retrieveFile(e){var t;let n=e;if(Y&&n.startsWith("file://"))try{n=(0,u.fileURLToPath)(n)}catch(e){}return n=(0,d.normalizeSlashes)(n),(null===(t=H.get(n))||void 0===t?void 0:t.content)||""},redirectConflictingLibrary:!0,onConflictingLibraryRedirect(t,n,r,i,s){(0,e.debug)(`Redirected an attempt to require source-map-support to instead receive @cspotcode/source-map-support.  "${n.filename}" attempted to require or resolve "${t}" and was redirected to "${s}".`)}})}Q();const X=(void 0===h.pretty?process.stdout.isTTY:h.pretty)&&C.formatDiagnosticsWithColorAndContext||C.formatDiagnostics;function Z(e){const t=function(e){const t=X(e,z),n=e.map((e=>e.code));return new A(t,n,e)}(e);if(!h.logError)throw t;console.error("[31m%s[0m",t)}U.length&&Z(U);const ee=y.options.jsx===C.JsxEmit.Preserve;function te(e){const t=e.lastIndexOf(".");if(t>=0){switch(e.slice(t)){case".js":case".ts":return".js";case".jsx":case".tsx":return ee?".jsx":".js";case".mjs":case".mts":return".mjs";case".cjs":case".cts":return".cjs"}}return".js"}let ne,re;const se=C.createGetCanonicalFileName(C.sys.useCaseSensitiveFileNames),oe=(0,m.createModuleTypeClassifier)({basePath:null===(c=h.optionBasePaths)||void 0===c?void 0:c.moduleTypes,patterns:h.moduleTypes}),ae=(0,w.getExtensions)(y,h,C.version);if(j)re=()=>{throw new TypeError('Type information is unavailable in "--transpile-only"')};else{const t=new Map,n=new Set(y.fileNames),r=(0,d.cachedLookup)(P("readFile",L));if(h.compilerHost){const e={...C.sys,...z,readFile:e=>{const n=t.get(e);if(void 0!==n)return n;const i=r(e);return i&&t.set(e,i),i},readDirectory:C.sys.readDirectory,getDirectories:(0,d.cachedLookup)(P("getDirectories",C.sys.getDirectories)),fileExists:(0,d.cachedLookup)(P("fileExists",D)),directoryExists:(0,d.cachedLookup)(P("directoryExists",C.sys.directoryExists)),resolvePath:(0,d.cachedLookup)(P("resolvePath",C.sys.resolvePath)),realpath:C.sys.realpath?(0,d.cachedLookup)(P("realpath",C.sys.realpath)):void 0},i=C.createIncrementalCompilerHost?C.createIncrementalCompilerHost(y.options,e):{...e,getSourceFile:(t,n)=>{const r=e.readFile(t);if(void 0!==r)return C.createSourceFile(t,r,n)},getDefaultLibLocation:()=>(0,d.normalizeSlashes)((0,a.dirname)(x)),getDefaultLibFileName:()=>(0,d.normalizeSlashes)((0,a.join)((0,a.dirname)(x),C.getDefaultLibFileName(y.options))),useCaseSensitiveFileNames:()=>e.useCaseSensitiveFileNames};i.trace=h.tsTrace;const{resolveModuleNames:s,resolveTypeReferenceDirectives:o,isFileKnownToBeInternal:c,markBucketOfFilenameInternal:l}=(0,g.createResolverFunctions)({host:i,cwd:p,config:y,ts:C,getCanonicalFileName:se,projectLocalResolveHelper:k,options:h,extensions:ae});i.resolveModuleNames=s,i.resolveTypeReferenceDirectives=o;let u=C.createIncrementalProgram?C.createIncrementalProgram({rootNames:Array.from(n),options:y.options,host:i,configFileParsingDiagnostics:y.errors,projectReferences:y.projectReferences}):C.createEmitAndSemanticDiagnosticsBuilderProgram(Array.from(n),y.options,i,void 0,y.errors,y.projectReferences);const f="function"==typeof V?V(u.getProgram()):V,m=(e,r)=>{const s=t.get(r)!==e;s&&t.set(r,e);let o=!1;n.has(r)||c(r)||(l(r),n.add(r),o=!0),(o||s)&&(u=C.createEmitAndSemanticDiagnosticsBuilderProgram(Array.from(n),y.options,i,u,y.errors,y.projectReferences))};ne=(t,n)=>{let r="",i="";m(t,n);const s=u.getSourceFile(n);if(!s)throw new TypeError(`Unable to read file: ${n}`);const o=u.getProgram(),c=O(C.getPreEmitDiagnostics(o,s),B);c.length&&Z(c);if(u.emit(s,((t,n,s)=>{t.endsWith(".map")?i=n:r=n,h.emit&&e.writeFile(t,n,s)}),void 0,void 0,f).emitSkipped)return[void 0,void 0,!0];if(""===r){if(o.isSourceFileFromExternalLibrary(s))throw new TypeError(`Unable to compile file from external library: ${(0,a.relative)(p,n)}`);throw new TypeError(`Unable to require file: ${(0,a.relative)(p,n)}\nThis is usually the result of a faulty configuration or import. Make sure there is a \`.js\`, \`.json\` or other executable extension with loader attached before \`ts-node\` available.`)}return[r,i,!1]},re=(e,t,n)=>{const r=(0,d.normalizeSlashes)(t);m(e,r);const i=u.getSourceFile(r);if(!i)throw new TypeError(`Unable to read file: ${t}`);const s=function(e,t,n){let r=t;e:for(;;){for(const e of r.getChildren(t)){if(e.getFullStart()>n)break;if(n<=e.getEnd()){r=e;continue e}}return r}}(0,i,n),o=u.getProgram().getTypeChecker(),a=o.getSymbolAtLocation(s);if(!a)return{name:"",comment:""};const c=o.getTypeOfSymbolAtLocation(a,s),l=[...c.getConstructSignatures(),...c.getCallSignatures()];return{name:l.length?l.map((e=>o.signatureToString(e))).join("\n"):o.typeToString(c),comment:C.displayPartsToString(a?a.getDocumentationComment(o):[])}},h.emit&&y.options.incremental&&process.on("exit",(()=>{u.getProgram().emitBuildInfo()}))}else{let i=1;const s=new Map(Array.from(n).map((e=>[e,0]))),o=()=>{if("function"==typeof V){const e=E.getProgram();return e?V(e):void 0}return V},c={getProjectVersion:()=>String(i),getScriptFileNames:()=>Array.from(n),getScriptVersion:e=>{const t=s.get(e);return t?t.toString():""},getScriptSnapshot(e){let n=t.get(e);if(void 0===n){if(n=r(e),void 0===n)return;s.set(e,1),t.set(e,n),i++}return C.ScriptSnapshot.fromString(n)},readFile:r,readDirectory:C.sys.readDirectory,getDirectories:(0,d.cachedLookup)(P("getDirectories",C.sys.getDirectories)),fileExists:(0,d.cachedLookup)(P("fileExists",D)),directoryExists:(0,d.cachedLookup)(P("directoryExists",C.sys.directoryExists)),realpath:C.sys.realpath?(0,d.cachedLookup)(P("realpath",C.sys.realpath)):void 0,getNewLine:()=>C.sys.newLine,useCaseSensitiveFileNames:()=>C.sys.useCaseSensitiveFileNames,getCurrentDirectory:()=>p,getCompilationSettings:()=>y.options,getDefaultLibFileName:()=>C.getDefaultLibFilePath(y.options),getCustomTransformers:o,trace:h.tsTrace},{resolveModuleNames:l,getResolvedModuleWithFailedLookupLocationsFromCache:u,resolveTypeReferenceDirectives:f,isFileKnownToBeInternal:m,markBucketOfFilenameInternal:v}=(0,g.createResolverFunctions)({host:c,getCanonicalFileName:se,ts:C,cwd:p,config:y,projectLocalResolveHelper:k,options:h,extensions:ae});c.resolveModuleNames=l,c.getResolvedModuleWithFailedLookupLocationsFromCache=u,c.resolveTypeReferenceDirectives=f;const x=C.createDocumentRegistry(C.sys.useCaseSensitiveFileNames,p),E=C.createLanguageService(c,x),S=(e,r)=>{n.has(r)||m(r)||(v(r),n.add(r),i++);const o=s.get(r)||0;e!==t.get(r)&&(s.set(r,o+1),t.set(r,e),i++)};let w;ne=(t,n)=>{S(t,n);const r=E.getProgram();r!==w&&(0,e.debug)(`compiler rebuilt Program instance when getting output for ${n}`);const i=E.getEmitOutput(n),s=E.getSemanticDiagnostics(n).concat(E.getSyntacticDiagnostics(n)),o=E.getProgram();(0,e.debug)("invariant: Is service.getProject() identical before and after getting emit output and diagnostics? (should always be true) ",r===o),w=o;const c=O(s,B);if(c.length&&Z(c),i.emitSkipped)return[void 0,void 0,!0];if(0===i.outputFiles.length)throw new TypeError(`Unable to require file: ${(0,a.relative)(p,n)}\nThis is usually the result of a faulty configuration or import. Make sure there is a \`.js\`, \`.json\` or other executable extension with loader attached before \`ts-node\` available.`);return[i.outputFiles[1].text,i.outputFiles[0].text,!1]},re=(e,t,n)=>{const r=(0,d.normalizeSlashes)(t);S(e,r);const i=E.getQuickInfoAtPosition(r,n);return{name:C.displayPartsToString(i?i.displayParts:[]),comment:C.displayPartsToString(i?i.documentation:[])}}}}function ce(e,t){const n={...y.options};void 0!==e&&(n.module=e);let r=null==J?void 0:J(n,t),i=(0,d.versionGteLt)(C.version,"4.7.0")?(0,b.createTsTranspileModule)(C,{compilerOptions:n,reportDiagnostics:!0,transformers:V}):void 0;return(e,s)=>{let o;o=r?r.transpile(e,{fileName:s}):i?i(e,{fileName:s},"nodeesm"===t?"module":"commonjs"):C.transpileModule(e,{fileName:s,compilerOptions:n,reportDiagnostics:!0,transformers:V});const a=O(o.diagnostics||[],B);return a.length&&Z(a),[o.outputText,o.sourceMapText,!1]}}const le=y.options.module!==C.ModuleKind.CommonJS,pe=!(y.options.module===C.ModuleKind.ES2015||C.ModuleKind.ES2020&&y.options.module===C.ModuleKind.ES2020||C.ModuleKind.ES2022&&y.options.module===C.ModuleKind.ES2022||y.options.module===C.ModuleKind.ESNext),ue=C.ModuleKind.Node16&&y.options.module===C.ModuleKind.Node16||C.ModuleKind.NodeNext&&y.options.module===C.ModuleKind.NodeNext,he=ce(C.ModuleKind.CommonJS),de=ce(C.ModuleKind.NodeNext,"nodecjs"),fe=ce(C.ModuleKind.NodeNext,"nodeesm"),me=ce(C.ModuleKind.ES2022||C.ModuleKind.ES2020||C.ModuleKind.ES2015),ge=ce();let ve=!0;const ye=(0,d.once)((()=>Jt().createResolve({extensions:ae,preferTsExts:h.preferTsExts,tsNodeExperimentalSpecifierResolution:h.experimentalSpecifierResolution}))),xe=(0,d.once)((()=>function(){if(Gt)return Wt;Gt=1;const{RegExpPrototypeExec:e,StringPrototypeStartsWith:n}=ie(),{extname:r}=t,{getOptionValue:i}=Ee(),[s,a]=process.versions.node.split(".").map((e=>parseInt(e,10))),c=s>17||17===s&&a>=5||16===s&&a>=15||i("--experimental-json-modules"),l=i("--experimental-wasm-modules"),{URL:p,fileURLToPath:u}=o,{ERR_UNKNOWN_FILE_EXTENSION:h}=Ae().codes,d={__proto__:null,".cjs":"commonjs",".js":"module",".mjs":"module"},f={__proto__:null,".cjs":"commonjs",".js":"commonjs",".json":"commonjs",".mjs":"module",".node":"commonjs"};return l&&(d[".wasm"]=f[".wasm"]="wasm"),c&&(d[".json"]=f[".json"]="json"),Wt={createGetFormat:function(t,s){let o=null!=t?t:i("--experimental-specifier-resolution");const{getPackageType:a}=s;return{defaultGetFormat:function(t,i,s){if(n(t,"node:"))return{format:"builtin"};const m=new p(t);if("data:"===m.protocol){const[,t]=e(/^([^/]+\/[^;,]+)(?:[^,]*?)(;base64)?,/,m.pathname)||[null,null,null];return{format:{__proto__:null,"text/javascript":"module","application/json":c?"json":null,"application/wasm":l?"wasm":null}[t]||null}}if("file:"===m.protocol){const e=r(m.pathname);let n;if(n=".js"===e?"module"===a(m.href)?"module":"commonjs":d[e],!n){if("node"!==o)throw new h(e,u(t));process.emitWarning("The Node.js specifier resolution in ESM is experimental.","ExperimentalWarning"),n=f[e]}return{format:n||null}}return{format:null}}}}}}().createGetFormat(h.experimentalSpecifierResolution,ye()))),Se=(0,d.once)((()=>Ne().createCjsLoader({extensions:ae,preferTsExts:h.preferTsExts,nodeEsmResolver:ye()})));return{[N]:!0,ts:C,compilerPath:x,config:y,compile:function(e,t,n=0){const r=(0,d.normalizeSlashes)(t),i=oe.classifyModuleByModuleTypeOverrides(r);let s="",o="",c=!0;if(ne&&([s,o,c]=ne(e,r)),"cjs"===i.moduleType&&(le||c))[s,o]=he(e,r);else if("esm"===i.moduleType&&(pe||c))[s,o]=me(e,r);else if(c){const n=(0,S.classifyModule)(t,ue);[s,o]="nodecjs"===n?de(e,r):"nodeesm"===n?fe(e,r):"cjs"===n?he(e,r):"esm"===n?me(e,r):ge(e,r)}const l=function(e,t,n,r){const i=Buffer.from(function(e,t){const n=JSON.parse(e);return n.file=t,n.sources=[t],delete n.sourceRoot,JSON.stringify(n)}(n,t),"utf8").toString("base64"),s=`//# sourceMappingURL=data:application/json;charset=utf-8;base64,${i}`,o="//# sourceMappingURL=",c=o.length,l=(0,a.basename)(t),p=(0,a.extname)(t),u=r(t),h=l.slice(0,-p.length)+u+".map",d=c+h.length;if(e.substr(-d,c)===o)return e.slice(0,-d)+s;const f=c+encodeURI(h).length;if(e.substr(-f,c)===o)return e.slice(0,-f)+s;return`${e}\n${s}`}(s,r,o,te);return H.set(r,{content:l}),l},getTypeInfo:re,ignored:e=>{if(!ve)return!0;const t=(0,a.extname)(e);return!ae.compiled.includes(t)||(!G(e)||K(e))},enabled:e=>void 0===e?ve:ve=!!e,options:h,configFilePath:l,moduleTypeClassifier:oe,shouldReplAwait:R,addDiagnosticFilter:function(e){B.push({...e,filenamesAbsolute:e.filenamesAbsolute.map((e=>(0,d.normalizeSlashes)(e)))})},installSourceMapSupport:Q,enableExperimentalEsmLoaderInterop:function(){Y=!0},transpileOnly:j,projectLocalResolveHelper:k,getNodeEsmResolver:ye,getNodeEsmGetFormat:xe,getNodeCjsLoader:Se,extensions:ae}}function R(t,n,r){const i=v.extensions[t]||r;v.extensions[t]=function(t,r){if(n.ignored(r))return i(t,r);k(n,t,r);const s=t._compile;return t._compile=function(t,r){(0,e.debug)("module._compile",r);const i=n.compile(t,r);return s.call(this,i,r)},i(t,r)}}function O(e,t){return e.filter((e=>t.every((t=>{var n;return!t.appliesToAllFiles&&-1===t.filenamesAbsolute.indexOf(null===(n=e.file)||void 0===n?void 0:n.fileName)||-1===t.diagnosticsIgnored.indexOf(e.code)}))))}e.register=function(t){let n=t;(null==t?void 0:t[N])||(n=I(null!=t?t:{}));const r=v.extensions[".js"];return process[e.REGISTER_INSTANCE]=n,function(e,t,n,r){const i=new Set(t);for(const e of[".mts",".cts",".mjs",".cjs"])i.has(e)&&!(0,d.hasOwnProperty)(v.extensions,e)&&(i.add(".js"),i.delete(e));for(const e of i)R(e,n,r);if(e){const e=new Set([...i,...Object.keys(v.extensions)]);for(const t of e){const e=Object.getOwnPropertyDescriptor(v.extensions,t);delete v.extensions[t],Object.defineProperty(v.extensions,t,e)}}}(n.options.preferTsExts,n.extensions.compiled,n,r),(0,x.installCommonjsResolveHooksIfNecessary)(n),c.Module._preloadModules(n.options.require),n},e.create=I,e.createFromPreloadedConfig=T;e.createEsmHooks=e=>function(){if(Yt)return Xt;Yt=1,Object.defineProperty(Xt,"__esModule",{value:!0}),Xt.createEsmHooks=Xt.registerAndCreateEsmHooks=Xt.filterHooksByAPIVersion=void 0;const e=Zt(),n=o,r=t,s=p,a=D(),c=i,l=(0,a.versionGteLt)(process.versions.node,"16.12.0");function u(e){const{getFormat:t,load:n,resolve:r,transformSource:i}=e;return l?{resolve:r,load:n,getFormat:void 0,transformSource:void 0}:{resolve:r,getFormat:t,transformSource:i,load:void 0}}function h(e){e.enableExperimentalEsmLoaderInterop();const t=e.getNodeEsmResolver(),i=e.getNodeEsmGetFormat(),o=e.extensions,l=u({resolve:async function(e,r,i){const s=async()=>await i(e,r,i);async function o(t){try{const n=await t();return(null==n?void 0:n.url)&&h(e,r.parentURL)&&f.add(n.url),n}catch(t){if(!h(e,r.parentURL))throw t;try{let t=e;try{e.startsWith("file://")&&(t=(0,n.fileURLToPath)(e))}catch{}const r=(0,n.pathToFileURL)((0,c.createRequire)(process.cwd()).resolve(t)).toString();return f.add(r),m.add(r),{url:r,format:"commonjs"}}catch(e){throw t}}}return d((async()=>{const a=(0,n.parse)(e),{pathname:c,protocol:l,hostname:u}=a;return p(a)?o(null!==l&&"file:"!==l||u?s:()=>t.defaultResolve(e,r,i)):o(s)}))},load:async function(e,t,n){return d((async()=>{var r;const s=null!==(r=t.format)&&void 0!==r?r:(await g(e,t,i.defaultGetFormat)).format;let o;if("builtin"!==s&&"commonjs"!==s){const{source:r}=await n(e,{...t,format:s},n);if(null==r)throw new Error(`Failed to load raw source: Format was '${s}' and url was '${e}''.`);const i=async(e,t,n)=>({source:e}),{source:a}=await v(r,{url:e,format:s},i);o=a}return{format:s,source:o}}))},getFormat:g,transformSource:v});function p(e){const{protocol:t}=e;return null===t||"file:"===t}function h(e,t){return void 0===t&&e.startsWith("file://")}const f=new Set,m=new Set;async function g(t,i,c){const l=(e=t)=>c(e,i,c);async function u(e){try{return await e()}catch(e){if(!f.has(t))throw e;return{format:"commonjs"}}}const h=(0,n.parse)(t);if(!p(h))return u(l);const{pathname:d}=h;s(null!==d,"ESM getFormat() hook: URL should never have null pathname");const m=(0,n.fileURLToPath)(t);let g;const v=(0,r.extname)(m),y=e.ignored(m),x=o.nodeEquivalents.get(v);if(x&&!y)g=await u((()=>l((0,n.format)((0,n.pathToFileURL)(m+x)))));else try{g=await u(l)}catch(e){throw e instanceof Error&&y&&o.nodeDoesNotUnderstand.includes(v)&&(e.message+='\n\nHint:\nts-node is configured to ignore this file.\nIf you want ts-node to handle this file, consider enabling the "skipIgnore" option or adjusting your "ignore" patterns.\nhttps://typestrong.org/ts-node/docs/scope\n'),e}if(!e.ignored(m)&&("commonjs"===g.format||"module"===g.format)){const{moduleType:t}=e.moduleTypeClassifier.classifyModuleByModuleTypeOverrides((0,a.normalizeSlashes)(m));if("cjs"===t)return{format:"commonjs"};if("esm"===t)return{format:"module"}}return g}async function v(t,r,i){if(null==t)throw new Error("No source");const s=()=>i(t,r,i),o="string"==typeof t?t:t.toString("utf8"),{url:a}=r;if(!p((0,n.parse)(a)))return s();const c=(0,n.fileURLToPath)(a);return e.ignored(c)?s():{source:e.compile(o,c)}}return l}async function d(e){const t=await e();return null==t?t:{...t,shortCircuit:!0}}return Xt.filterHooksByAPIVersion=u,Xt.registerAndCreateEsmHooks=function(t){return h((0,e.register)(t))},Xt.createEsmHooks=h,Xt}().createEsmHooks(e)}(x)),x}var en=Zt();g.config(),en.register();(async()=>{try{const n=(n=>{const r=t.join(n,"validatedTranslations.js"),i=t.join(n,"validatedTranslations.ts");if(e.existsSync(r))return r;if(e.existsSync(i))return i;throw new Error(`Translations file not found. Expected "validatedTranslations.js" or "validatedTranslations.ts" in ${n}.`)})(process.env.VALIDATED_TRANSLATIONS_PATH||t.join(process.cwd(),"src","translations"));console.log(`Using translations from: ${n}`);const{validatedTranslations:r}=await import(n),i=Object.keys(r[0]).filter((e=>"key"!==e));console.log(`Detected locales: ${i.join(", ")}`);for(const n of i){const i=r.reduce(((e,t)=>{if(!t[n])throw new Error(`Missing translation for key '${t.key}' in locale '${n}'`);return e[t.key]=t[n],e}),{}),s=t.join(process.cwd(),"public","translations",`${n}.json`);e.writeFileSync(s,JSON.stringify(i,null,2),"utf-8"),console.log(`Generated ${s}`)}}catch(e){e instanceof Error?console.error("Error generating translations:",e.message):console.error("An unknown error occurred:",e),process.exit(1)}})();
//# sourceMappingURL=cli.js.map
